clear all
set more off
use macrodata.dta
rename col1 year
rename col2 GDPGr
rename col3 WageGr
rename col4 LSComp
rename col5 IGr
rename col6 DGr
rename col7 PE_SP
rename col8 TSspd
rename col9 FinLev
rename col10 MktVol
rename col11 SYr
rename col12 DefRate
rename col13 DefSpd
rename col14 UmpRate
rename col15 EmpGr

replace DefRate=. if DefRate==99
gen Eloss=DefRate[_n-1]*0.5
gen CS=DefSpd
reg CS Eloss
predict CSRP, res
sum CS CSRP Eloss
pwcorr LSComp CS CSRP Eloss, sig

eststo clear
estpost correlate  LSComp CS CSRP Eloss if year<=2006, matrix
esttab using "CS_decomposition_corr_2019.csv", b(%8.2f) not unstack compress noobs replace nostar

eststo clear
estpost sum  CS CSRP Eloss if year<=2006, detail
esttab using "CS_decomposition_summary_2019.csv", cells("count mean sd p5 p25 p50 p75 p95") nomtitle nonumber noobs replace




