function [I_A] = monthlyToAnnualVol(I_m, F)

% convert monthly flows to annual flows
% I_A: Annual
% I_m: Monthly N by T;
% F: conversion frequency

[T, N] = size(I_m);
I_A   = zeros(T/F,N);
for j = 1 : N
    
    for k = 1 : T/F
         I_A(k,j) = sqrt(F)*std(I_m((F*(k-1)+1):F*k,j));      % annualized std dev monthly flows of the year 
    end
    
end

