clear all
set more off
use ../firm_level_data/prefinal/cna_accounting.dta
* for north american only keep Canada and USA
keep if fic=="CAN"|fic=="USA"
append using ../firm_level_data/prefinal/cg_accounting.dta
sort gvkey datadate
gen datadate_lag=datadate[_n-1] if gvkey==gvkey[_n-1]
gen blev=(dltt+dlc)/at if dltt>=0 & dlc>=0 & at>0
gen blev2=(dltt+dlc)/(dltt+dlc+at+txditc-pstk-lt) if dltt>=0 & dlc>=0 & at>0 & txditc>=0 & pstk>=0 & lt>=0
joinby gvkey datadate using ../firm_level_data/prefinal/cg_staffexpense.dta, unm(m)
drop _merge
joinby gvkey datadate using ../firm_level_data/prefinal/cna_staffexpense.dta, unm(m)
drop _merge
gen llev=xlr/at
replace llev=. if xlr<0
replace llev=. if at<=0
replace blev=. if blev>1
replace blev2=. if blev2>1
replace llev=. if llev>1
replace blev2=0 if blev2<0
ssc install egenmore
* note that the egen corr function takes a long time in stata -- better off using matlab to calculate corr
* the following two lines can be uncommented to calculate corrbl measure
* sort gvkey
* egen corrbl = corr(blev llev), by(gvkey)
save ../firm_level_data/prefinal/corrbl.dta, replace
