/* need to change the directory to your own directory*/
libname mylocal 'J:\CG Security Daily';
libname rawdata 'J:\CG Security Daily\rawdata';

%let cgvars=gvkey datadate fyear consol indfmt datafmt popsrc costat sich curcd fyr fic at ceq dlc dltt lt pstk seq txditc emp xlr xsga sale wcap re ebit nicon act lct ppent oibdp capx cshoi;

%let cnvars=gvkey datadate fyear consol indfmt datafmt popsrc costat sich curcd fyr fic at ceq dlc dltt lt pstk seq txditc emp xlr xsga sale wcap re ebit ni act lct ppent oibdp capx sppe csho prcc_f;


data cg_funda;
    set rawdata.g_funda(keep= &cgvars);
    rename nicon=ni sich=sic cshoi=csho;
    where year(datadate)>=1986 and consol="C" and indfmt="INDL" and datafmt="HIST_STD" and popsrc="I" and (costat="A" or costat="I") and (fic~="USA" and fic~="CAN");
run;

data cna_funda;
    set rawdata.funda(keep= &cnvars);
    rename sich=sic;
    where year(datadate)>=1986 and consol="C" and indfmt="INDL" and datafmt="STD" and popsrc="D" and (curcd="USD" or curcd="CAD") and (costat="A" or costat="I") and (fic="USA" or fic="CAN");
run;

data cg_cna_funda;
    set cg_funda cna_funda;
run;

proc sort data=cg_cna_funda;
    by gvkey datadate;
run;

data cg_cna_funda;
    set cg_cna_funda;
    by gvkey fyear;
    if first.fyear;
run;

data fx;
    set rawdata.g_exrt_dly;
    year=year(datadate);
    month=month(datadate);
    day=day(datadate);
    fx_rate=1/exratd;
run;

proc sql;
    create table cg_cna_funda as
    select a.*, b.fx_rate as fx_acct
    from cg_cna_funda as a left join fx as b 
    on a.curcd=b.tocurd and year(a.datadate)=b.year and month(a.datadate)=b.month and day(a.datadate)=b.day;
quit;


data cg_price;
    set mylocal.cna_price_m mylocal.cg_price_m;
    where year>=1986 and year<=2014;
run;

proc sort data=cg_cna_funda;
    by gvkey datadate;
run;

data cg_cna_funda;
    set cg_cna_funda;
    datadate_lag=lag(datadate);
    if gvkey~=lag(gvkey) then datadate_lag=.;
run;

proc sql;
    create table def_data as
    select distinct a.*, sqrt(mean(b.log_r*b.log_r)*12) as sigma, (mean(b.log_r)*12) as past_rt
    from cg_cna_funda as a left join cg_price as b
    on a.gvkey=b.gvkey and (year(a.datadate_lag)*12+month(a.datadate_lag))<(year(b.datadate)*12+month(b.datadate))<=(year(a.datadate)*12+month(a.datadate))
    group by a.gvkey, a.datadate;
quit;


proc sql;
    create table def_data as
    select distinct a.*, b.prccd as prcc, b.cshoc, b.fx_rate as fx_prcc, b.curcdd as curcd_prcc, b.gvkey_n
    from def_data as a left join cg_price as b
    on a.gvkey=b.gvkey and (year(b.datadate)*12+month(b.datadate))=(year(a.datadate)*12+month(a.datadate))
    group by a.gvkey, a.datadate;
quit;

data def_data;
    set def_data;
    cf=oibdp/at;
    if at<=0 then cf=.;
    drop consol indfmt datafmt popsrc costat;
run;

proc sql;
    create table cf_vol as
    select distinct a.*, std(b.cf) as cf_vol, count(b.cf) as no_cf
    from def_data as a left join def_data as b
    on a.gvkey=b.gvkey and (year(b.datadate)*12+month(b.datadate))<=(year(a.datadate)*12+month(a.datadate))
    group by a.gvkey, a.datadate;
quit;


proc sql;
    create table def_data as
    select distinct a.*, b.cf_vol, b.no_cf
    from def_data as a left join cf_vol as b
    on a.gvkey=b.gvkey and (a.datadate=b.datadate);
quit;

data mylocal.fx_acct;
    set def_data;
    keep gvkey datadate fx_acct;
run;

data mylocal.def_data_201503;
    set def_data;
run;



