/* need to change the directory to your own directory*/

libname mylocal 'J:\CG Security Daily';

data corrbl;
    set mylocal.corrbl;
run;

/*
gvkey_acds_1y_5y: this is the monthly CDS file that we constructed using the proprietary data 
purchased from IHS Markit.
The key vars: acds5y is the 5-year CDS spread, and acds1y is the 1-year CDS spread
*/
data cds;
    set mylocal.gvkey_acds_1y_5y;
    year=year(date);
    month=month(date);
run;

proc sql;
    create table ann_cds as
    select distinct a.gvkey, b.datadate, b.datadate_lag, mean(a.acds5y) as avg_cds5y, mean(a.acds1y) as avg_cds1y, mean(a.arecovery) as avg_recovery
    from cds as a left join corrbl as b
    on a.gvkey=b.gvkey and (year(b.datadate)*12+month(b.datadate)-12)<((a.year)*12+(a.month))<=(year(b.datadate)*12+month(b.datadate))
    group by a.gvkey, b.datadate;
quit;

proc sort data=ann_cds;
    by gvkey datadate;
run;

proc sql;
    create table ann_cds_f1y as
    select distinct a.gvkey, b.datadate, mean(a.acds5y) as avg_cds5y_f1y, mean(a.acds1y) as avg_cds1y_f1y, mean(a.arecovery) as avg_recovery_f1y
    from cds as a left join corrbl as b
    on a.gvkey=b.gvkey and (year(b.datadate)*12+month(b.datadate))<((a.year)*12+(a.month))<=(year(b.datadate)*12+month(b.datadate)+12)
    group by a.gvkey, b.datadate;
quit;

proc sort data=ann_cds_f1y;
    by gvkey datadate;
run;

proc sql;
    create table ann_cds_final as
    select distinct a.*, b.avg_cds5y, b.avg_cds1y, b.avg_recovery
    from ann_cds_f1y as a left join ann_cds as b
    on a.gvkey=b.gvkey and a.datadate=b.datadate;
quit;

data ann_cds_final;
    set ann_cds_final;
    where not missing(datadate);
run;

data mylocal.ann_cds;
    set ann_cds_final;
run;





