!to compile this code using inte's ifort compiler and openMP: ifort -mkl -O3 -fPIC -unroll -ipo -axavx -xsse4.2 -qopenmp -zero affordable.f libSLATEC.f -o temp
!to compile this code with gfortran: gfortran -fopenmp wff4.f -o temp libSLATEC.f (however need to comment out IFPORT if doing this)

      PROGRAM RepAgent
      implicit none
      integer nKI,nK,nS,nWBI,nZagg,nZsr,nZind,nNIlast,nDKI,nAgg
!      parameter (nKI=57+16,nK=57,nS=2,nZagg=3,nZind=3,nNIlast=2,nWBi=2)
      parameter (nKI=43,nK=20,nS=6,nZagg=3,nZind=3,nNIlast=13,nWBI=18)
      parameter (nZsr=3,nDKI=13)
      integer iS,i,j,iZ,iK,iKI,iDKI,iAgg,iZlastGrid(nZagg)
      real Kgrid(nK),KIgrid(nKI),Agrid(nZagg,nZsr),Zgrid(nZagg)
      real DKIgrid(nDKI),WBIgrid(nWBi),RFgrid(nK*nS*nZagg,1),Sgrid(nS)
      real TrProbInd(nZind,nZind),ZIgrid(nZind),K,S,mu0,RecRate,CorpTax
      real TrProbAggSR(nZsr)
      real beta1,theta,eis,deltaK,psiK,RTS,v1P,v1N,growth,FixedCost
      real TrProbAgg(nZagg,nZagg),tempR1,tempR2,tempR3,deltaKfree
      real TrProbCost(nNIlast,nNIlast),NIlastGrid(nNIlast)
      real PriceDebtRF(nK*nS*nZagg*nDKI,1)
      real BW0(nZagg),BW1(nZagg),BW2(nZagg)
      real BC0(nZagg),BC1(nZagg),BC2(nZagg)
      real BI0(nZagg),BI1(nZagg),BI2(nZagg)
      real SDF(nK*nS*nZagg*nZagg*nZsr,1),meanC(nK*nS*nZagg,3)
      real meanI(nK*nS*nZagg,3),meanY(nK*nS*nZagg,3)
      real meanW(nK*nS*nZagg,3),xi,CES,ProbExp
      real V(nK*nS*nZagg*nDKI*nKi*nWBI*nNIlast*nZind,1)
      real PriceDebt(nK*nS*nZagg*nDKI*nKi*nWBI*nNIlast*nZind,1)
      integer mytime(3),tempI1,tempI2,tempI3,tempI4,tempI5
      integer iZnext,iZind,iNIlast,iState,iInd,nIterSim
      real meanCtemp(nS*nK*nZagg,3),meanWtemp(nS*nK*nZagg,3)
      real SDFtemp(nS*nK*nZagg*nZagg*nZsr,1)
      real Vtemp(nKi*nZind*nK*nZagg,1),lab0,lab1
      real psiKshock(nZagg),mu0shock(nZagg)
      real GDPmult,mu0shock2(nZind),psiKshock2(nZind),Ngrid(nZagg)

      RecRate=1.0
      CorpTax=0.3
      ProbExp=0.025
      GDPmult=0.25
      do iZ=1,nZagg
       psiKshock(iZ)=1.0
       mu0shock(iZ)=1.0
      end do
      do iZ=1,nZind
       psiKshock2(iZ)=1.0
       mu0shock2(iZ)=1.0
      end do
      Ngrid(1)=1.0
      Ngrid(2)=1.0
      Ngrid(3)=1.0
      iZlastGrid(1)=1
      iZlastGrid(2)=2
      iZlastGrid(3)=3

      nAgg=nK*nS*nZagg
      nIterSim=nAgg+2

      call readparams(nZagg,nZsr,nZind,nNIlast,beta1,theta,eis,deltaK,
     1     psiK,RTS,v1P,v1N,FixedCost,growth,Agrid,Zgrid,TrProbAgg,
     2     TrProbAggSR,ZIgrid,TrProbInd,TrProbCost,
     1     lab0,lab1,tempR3,mu0,xi,CES)
      deltaKfree=deltaK
      write(6,*) 'Actual Beta ',beta1
      write(6,'(f8.4,f7.3,f8.4,f8.4,f8.4,f8.4,f8.4,f8.4,f8.4,f8.4,
     1          f8.4,f8.4,f8.4)')
     1 beta1,theta,eis,deltaK,psiK,RTS,v1P,v1N,FixedCost,growth
      write(6,*) 'deltaKfree=',deltaKfree,' mu=',mu0,' xi=',xi,
     1 ' CES=',CES
      do i=1,nZagg
       write(6,*) (Agrid(i,j),j=1,nZagg)
      end do
      !write(6,*) (Zgrid(i),i=1,nZagg)
      do i=1,nZagg
      write(6,*) (TrProbAgg(i,j),j=1,nZagg)
      end do
      write(6,*) (ZIgrid(i),i=1,nZind)
      do i=1,nZind
      write(6,*) (TrProbInd(i,j),j=1,nZind)
      end do
      write(6,*) lab0,lab1,tempR3

      tempI1=4
      do iK=1,nK-tempI1
       Kgrid(iK)=1.5+3.0*real(iK-1)/real(nK-tempI1-1)
       !Kgrid(iK)=1.5+3.0*real(iK-1)/real(nK-tempI1-1)
      end do
      do iK=nK-tempI1+1,nK
       Kgrid(iK)=Kgrid(iK-1)+(Kgrid(iK-1)-Kgrid(iK-2))*1.2
      end do

      KIgrid(1)=0.01
      KIgrid(2)=0.08
      do iKi=3,nKi
       KIgrid(iKi)=KIgrid(iKi-1)+(KIgrid(iKi-1)-KIgrid(iKi-2))*1.05
       !write(6,*) iKi,KIgrid(iKi)
      end do

      do iS=1,nS
       Sgrid(iS)=1.02+0.47*real(iS-1)/real(nS-1)
      end do

      do i=1,nWBi
       WBIgrid(i)=0.8+0.4*real(i-1)/real(nWBI-1)
      end do
      do iNIlast=1,nNIlast
       NIlastGrid(iNIlast)=0.01+2.99*real(iNIlast-1)/real(nNIlast-1)
      end do

      WBIgrid(1)=0.01
      WBIgrid(2)=0.04
      WBIgrid(3)=0.08
      WBIgrid(4)=0.12
      WBIgrid(5)=0.16
      WBIgrid(6)=0.20
      WBIgrid(7)=0.24
      WBIgrid(8)=0.28
      WBIgrid(9)=0.32
      WBIgrid(10)=0.36
      WBIgrid(11)=0.40
      WBIgrid(12)=0.44
      WBIgrid(13)=0.48
      WBIgrid(14)=0.52
      WBIgrid(15)=0.56
      WBIgrid(16)=0.60
      WBIgrid(17)=0.64
      WBIgrid(18)=0.68

      NIlastGrid(1)=0.01
      NIlastGrid(2)=0.25
      NIlastGrid(3)=0.50
      NIlastGrid(4)=0.75
      NIlastGrid(5)=1.00
      NIlastGrid(6)=1.25
      NIlastGrid(7)=1.50
      NIlastGrid(8)=1.75
      NIlastGrid(9)=2.00
      NIlastGrid(10)=2.25
      NIlastGrid(11)=2.50
      NIlastGrid(12)=2.75
      NIlastGrid(13)=3.00

      DKIgrid(1)=0.00
      DKIgrid(2)=0.01
      DKIgrid(3)=0.02
      DKIgrid(4)=0.03
      DKIgrid(5)=0.04
      DKIgrid(6)=0.06
      DKIgrid(7)=0.08
      DKIgrid(8)=0.10
      DKIgrid(9)=0.12
      DKIgrid(10)=0.15
      DKIgrid(11)=0.18
      DKIgrid(12)=0.22
      DKIgrid(13)=0.26

      call writedata(KIgrid,'KIgrid.txt',nKi,1,nKi,1)
      call writedata(Kgrid,'Kgrid0.txt',nK,1,nK,1)
      call writedata(Sgrid,'Sgrid0.txt',nS,1,nS,1)
      call writedata(WBIgrid,'SIgrid.txt',nWBI,1,nWBI,1)
      call writedata(NIlastGrid,'NIgrid.txt',nNIlast,1,nNIlast,1)
      call writedata(DKIgrid,'DKgrid.txt',nDKi,1,nDKi,1)

      do iZ=1,nZagg
       BC0(iZ)=-1.80
       BC1(iZ)=0.53
       BC2(iZ)=0.08
       BI0(iZ)=0.24
       BI1(iZ)=-1.29
       BI2(iZ)=0.05
       BW0(iZ)=0.0
       BW1(iZ)=1.0
       BW2(iZ)=0.0

       do iS=1,nS
       do iK=1,nK
        iAgg=((iS-1)*nK+iK-1)*nZagg+iZ
        K=Kgrid(iK)
        S=Sgrid(iS)
        meanC(iAgg,1)=exp(BC0(iZ))*(K**BC1(iZ))
        meanY(iAgg,1)=GDPmult*Zgrid(iZ)*(K**psiK)
        meanW(iAgg,1)=BW0(iZ)+BW1(iZ)*(1.0-psiK)*meanY(iAgg,1)+
     1                BW2(iZ)*S
        meanI(iAgg,1)=meanY(iAgg,1)-meanC(iAgg,1)

        meanC(iAgg,2)=0.0
        meanC(iAgg,3)=100
        meanW(iAgg,2)=0.0
        meanW(iAgg,3)=100
        meanI(iAgg,2)=0.0
        meanI(iAgg,3)=100
        meanY(iAgg,2)=0.0
        meanY(iAgg,3)=100
        V(iAgg,1)=0.0
        tempR1=0
        do iZnext=1,nZagg
        do j=1,nZsr
         SDF((iAgg-1)*nZagg*nZsr+j,1)=beta1*
     1    exp(-.25*(Kgrid(iK)-Kgrid(nint(.5*real(nK))))/Kgrid(nK))
         tempR1=tempR1+TrProbAgg(iZ,iZnext)*TrProbAggSR(j)*
     1    SDF((iAgg-1)*nZagg*nZsr+(iZnext-1)*nZsr+j,1)
        end do
        end do
        RFgrid(iAgg,1)=1.0/tempR1
        do i=1,nDKI*nKi*nWBI*nNIlast*nZind
         PriceDebt((i-1)*nAgg+iAgg,1)=0!tempR1
         !PriceDebt((i-1)*nAgg+iAgg,2)=0
        end do
        do i=1,nDKI
         PriceDebtRF((i-1)*nAgg+iAgg,1)=0
        end do
       end do
       end do
      end do

      tempI1=0
      if(tempI1.eq.1) then
!      call writedata(V,'valueF.txt',nAgg*nNIlast*nKi*nZind,1,
!     1               nAgg*nNIlast*nKi*nZind,1)
      call writedata(meanC,'meanC0.txt',nAgg,3,nAgg,3)
      call writedata(meanW,'meanW0.txt',nAgg,3,nAgg,3)
      call writedata(meanI,'meanI0.txt',nAgg,3,nAgg,3)
      call writedata(meanY,'meanY0.txt',nAgg,3,nAgg,3)
      call writedata(SDF,'SDF000.txt',nAgg*nZagg*nZsr,1,
     1               nAgg*nZagg*nZsr,1)
      call writedata(RFgrid,'RFgrid.txt',nAgg,1,nAgg,1)
      call writedatabinary(PriceDebt,'PrcDbt.dat',
     1 nAgg*nDKI*nWBI*nNIlast*nKi*nZind,1)
!      call writedata(PriceDebt,
!     1 'PrcDbt.txt',nAgg*nDKI*nWBI*nNIlast*nKi*nZind,1,
!     1              nAgg*nDKI*nWBI*nNIlast*nKi*nZind,1)
      call writedata(PriceDebtRF,'PrcDRF.txt',nAgg*nDKI,1,nAgg*nDKI,1)
      end if

!      call writedata(PriceDebt,
!     1 'PrcDbt.txt',nAgg*nDKI*nWBI*nNIlast*nKi*nZind,1,
!     1              nAgg*nDKI*nWBI*nNIlast*nKi*nZind,1)
!      call writedata(PriceDebtRF,'PrcDRF.txt',nAgg*nDKI,1,nAgg*nDKI,1)

      tempI1=0
      if(tempI1.eq.1) then
      call writedata(BI0,'BI0000.txt',nZagg,1,nZagg,1)
      call writedata(BI1,'BI1000.txt',nZagg,1,nZagg,1)
      call writedata(BI2,'BI2000.txt',nZagg,1,nZagg,1)
      call writedata(BC0,'BC0000.txt',nZagg,1,nZagg,1)
      call writedata(BC1,'BC1000.txt',nZagg,1,nZagg,1)
      call writedata(BC2,'BC2000.txt',nZagg,1,nZagg,1)
      call writedata(BW0,'BW0000.txt',nZagg,1,nZagg,1)
      call writedata(BW1,'BW1000.txt',nZagg,1,nZagg,1)
      call writedata(BW2,'BW2000.txt',nZagg,1,nZagg,1)
!!      call writedata(SDF,'SDF000.txt',nAgg*nZagg,1,nAagg*nZagg,1)
      call writedata(meanC,'meanC0.txt',nAgg,3,nAgg,3)
      call writedata(meanW,'meanW0.txt',nAgg,3,nAgg,3)
      call writedata(meanI,'meanI0.txt',nAgg,3,nAgg,3)
      call writedata(meanY,'meanY0.txt',nAgg,3,nAgg,3)
!!      call DPrepagent(nK,nS,nZagg,nZind,nNIlast,deltaKfree)
      end if

!       call DPrepagent(nK,nS,nZagg,nZsr,nZind,nNIlast,deltaKfree,
!     1     psiKshock,mu0shock,GDPmult,Ngrid,iZlastGrid)

      call itime(mytime)
      write(6,*) mytime
!If starting code for first time, start with i=1. If starting from existing (previously written) value functions, prices, beliefs ... then start with i=2
      do i=1,30
      call DP(nKI,nK,nS,nZagg,nZsr,nZind,nNIlast,nWBI,nDKI,deltaKfree,
     1        psiKshock,psiKshock2,mu0shock,mu0shock2,
     1        GDPmult,Ngrid,iZlastGrid,RecRate,CorpTax,
     1        ProbExp,i)!!!!
      call Simulate(nKI,nK,nS,nZagg,nZsr,nZind,nNIlast,nWBI,nDKI,
     1     deltaKfree,psiKshock,psiKshock2,mu0shock,mu0shock2,
     1     GDPmult,Ngrid,iZlastGrid,nIterSim,RecRate,CorpTax,
     1     ProbExp)  !!!!
      call DPrepagent(nK,nS,nZagg,nZsr,nZind,nNIlast,deltaKfree,
     1     psiKshock,mu0shock,GDPmult,Ngrid,iZlastGrid)

      call itime(mytime)
      write(6,*) 'iter ',i,mytime
      end do

      end
!------------------------------------------------------------------------
      SUBROUTINE DP(nKi,nK,nS,nZagg,nZsr,nZind,nNIlast,nWBi,nDKi,
     1              deltaKfree,psiKshock,psiKshock2,mu0shock,mu0shock2,
     1              GDPmult,Ngrid,iZlastGrid,RecRate,CorpTax,
     1              ProbExp,iIter)
      implicit none
      integer nKi,nK,nS,nZagg,nZsr,nState,t,TotYears0,nNIlast,nWBi,nDKi
      integer iNIlast,iNIlastNext,iS,iSnext,iWBi,iDKi,iLtemp
      integer iIter,TotYears1,TotYearsCur,iLabor,nLabor,TotYearsV
      integer nC,nCfine,nCfine1,nAgg,nZind,iZind,iInd,iZindNext
      integer nDKIchoice,iDKIchoice
      parameter (TotYears0=3,TotYears1=3,TotYearsV=20)
      parameter (nLabor=10,nC=15,nCfine=10,nCfine1=6)
      integer nLaborGrid(nC+3+nCfine+nCfine1+1)
      real DKIchoice(2),DKIchoice1(2),DKIchoice2(2)
      integer i,j,iKi,iK,iKnext,iZ,iState,iAgg,iC,iZnext,iKItemp
      integer iIndNextL,iIndNextH,iAggNext,iLL,iLH,iHL,iHH
      real KIgrid(nKi),Kgrid(nK),Agrid(nZagg,nZsr),Zgrid(nZagg)
      real Sgrid(nS),TrProbAggSR(nZsr)
      real DKIgrid(nDKi),multDKI,RecRate,CorpTax,TaxPaid,DKItemp
      real TrProbCost(nNIlast,nNIlast),TrProb,deltaKfree,S,Snext,ProbExp
      real Wage,INVfine(2),INVfine1(2),Knext,multK,SDFtemp,multS,multNI
      real TrProbAgg(nZagg,nZagg),TrProbInd(nZind,nZind),Ngrid(nZagg)
      real beta1,theta,eis,deltaK,psiK0,psiK,psiKshock(nZagg),psiKnext
      real growth,v1P,v1N,C,ZIgrid(nZind),WBIgrid(nWBi),WBi
      real mu0shock(nZagg)
      real BI0(nZagg),BI1(nZagg),BI2(nZagg),mu0shock2(nZind),multDKImax
      real BW0(nZagg),BW1(nZagg),BW2(nZagg),mu0grid(nZagg,nZind)
      real BC0(nZagg),BC1(nZagg),BC2(nZagg),psiKshock2(nZind)
      real Yi,Ki,K,X,DIV,KInext,INV,Labor,Costs,KItemp,multKI,FixedCost
      real tempR1,tempR2,tempR3,tempR4,tempR5,tempR6,tempR7,tempR8
      integer tempI1,tempI2,tempI3,tempI4,tempI5
      integer iKInext,iWBInext,iDKInext,jNI,jWBI,jDKI,jK,jS,jKI,iIndNext
      real VtempKi(nKi),DtempKi(nKi),YiPos,WageBill,multWBi
      integer extrap(2),iZlast,iZlastGrid(nZagg),iIndNextDef
      integer iStateNextDef,iZSRnext
      real WageGrid(nK*nS*nZagg),LaborGrid(nLabor,nNIlast)
      real SDF(nK*nS*nZagg*nZagg*nZsr,1),LaborInd,VnextLowNI,VnextHighNI
      real RFgrid(nK*nS*nZagg,1),PriceRiskFree
      real LaborIndMPL,LaborIndBest1,LaborIndBest2,xi,KiBar
      real LaborIndBest3,LaborInt3,GDPmult,LaborIndAnal
      real KnextGrid(nK*nS*nZagg,nZsr),SnextGrid(nK*nS*nZagg,nZsr)
      real KmultGrid(nK*nS*nZagg,nZsr),SmultGrid(nK*nS*nZagg,nZsr)
      integer KspotGrid(nK*nS*nZagg,nZsr),SspotGrid(nK*nS*nZagg,nZsr)
      real INVgrid0(nC,nKi),DKInext,DKI,Vtemp,V0next
      real PriceDebtRF(nK*nS*nZagg*nDKI,1)
      real PriceDebtRF0(nK*nS*nZagg*nDKI,1)
      !real Policy(nK*nS*nKi*nZagg*nZind*nNIlast,1)
      !real V(nK*nS*nKi*nZagg*nZind*nNIlast,1)
      real DKInextBest(nK*nS*nZagg*nDKi*nKI*nWBi*nNILast*nZind)
      real KInextBest(nK*nS*nZagg*nDKi*nKI*nWBi*nNILast*nZind)
      real WBInextBest(nK*nS*nZagg*nDKi*nKI*nWBi*nNILast*nZind)
      integer iKInextBest(nK*nS*nZagg*nDKi*nKI*nWBi*nNILast*nZind)
      integer iNInextBest(nK*nS*nZagg*nDKi*nKI*nWBi*nNILast*nZind)
      integer iWBInextBest(nK*nS*nZagg*nDKi*nKI*nWBi*nNILast*nZind)
      integer iDKInextBest(nK*nS*nZagg*nDKi*nKI*nWBi*nNILast*nZind)
      real multKIBest(nK*nS*nZagg*nDKi*nKI*nWBi*nNILast*nZind)
      real multNIBest(nK*nS*nZagg*nDKi*nKI*nWBi*nNILast*nZind)
      real multWBiBest(nK*nS*nZagg*nDKi*nKI*nWBi*nNILast*nZind)
      real multDKIBest(nK*nS*nZagg*nDKi*nKI*nWBi*nNILast*nZind)
      real DivBest(nK*nS*nZagg*nDKi*nKI*nWBi*nNILast*nZind)
      real Vnext5(2,2,2,2,2),Vnext6(2,2,2,2,2,2)
      real Vnext1(2),Vnext2(2,2),Vnext3(2,2,2),Vnext4(2,2,2,2)
      real Vnext1nd(2),Vnext2nd(2,2),Vnext3nd(2,2,2),VnextND
      real Vdebt1(2),Vdebt2(2,2),Vdebt3(2,2,2),Vdebt
      real VdebtNRP1(2),VdebtNRP2(2,2),VdebtNRP3(2,2,2),VdebtNRP
      real Vdebt4(2,2,2,2),Vdebt5(2,2,2,2,2),Vdebt6(2,2,2,2,2,2)
      real dVdebt1(2),dVdebt2(2,2),dVdebt3(2,2,2),VdebtNRP4(2,2,2,2)
      real dVdebt4(2,2,2,2),dVdebt5(2,2,2,2,2),dVdebt6(2,2,2,2,2,2)
      real Vdef1(2),Vdef2(2,2),Vdef3(2,2,2),Vdef
      real Vdef4(2,2,2,2),Vdef5(2,2,2,2,2),Vdef6(2,2,2,2,2,2)
      real Def1(2),Def2(2,2),Def3(2,2,2),Def
      real Def4(2,2,2,2),Def5(2,2,2,2,2),Def6(2,2,2,2,2,2)
      real Policy(nK*nS*nZagg*nDKi*nKI*nWBi*nNILast*nZind,5)
      real V(nK*nS*nZagg*nDKi*nKI*nWBi*nNILast*nZind,1)      ! (nKI=25,nK=20,nS=9,nZagg=3,nZind=3,nNIlast=7,nSI=5)
      real VnextGrid(nK*nS*nZagg*nDKi*nKI*nWBi*nNILast*nZind)
      real PriceDebtNextGrid(nK*nS*nZagg*nDKi*nKI*nWBi*nNILast*nZind)
      real PriceDebt(nK*nS*nZagg*nDKI*nKi*nWBI*nNIlast*nZind,1)
      real PriceDebt0(nK*nS*nZagg*nDKI*nKi*nWBI*nNIlast*nZind,1)
      real PriceDebtNRPNextGrid(nK*nS*nZagg*nDKi*nKI*nWBi*nNILast*nZind)
      real PriceDebtNRP(nK*nS*nZagg*nDKI*nKi*nWBI*nNIlast*nZind,1)
      real PolicyAnal(nK*nS*nZagg*nDKi*nKI*nWBi*nNILast*nZind,2)
!      real INVgrid(nK*nS*nZagg*nDKi*nKI*nWBi*nNILast*nZind*nC*nLabor)
      real DerivsAllKi(nK*nS*nZagg*nDKi*nKI*nWBi*nNILast*nZind)
      real DerivsAllDKI(nK*nS*nZagg*nDKi*nKI*nWBi*nNILast*nZind)
      real DtempDKi(nDKI),VtempDKI(nDKI)
      double precision Vmax(nK*nS*nZagg*nDKi*nKI*nWBi*nNILast*nZind,1)
!      real Dividend(nK*nS*nZagg*nDKi*nKI*nWBi*nNILast*nZind*nC*nLabor)
      double precision minval,U,Vnext
      double precision paramR1,paramR2,paramR3,paramR4
      integer mytime(3),iStateNext,iNItemp,iWBItemp,iDKItemp
      real meanC(nK*nS*nZagg,3),meanW(nK*nS*nZagg,3),Xnext,WageNext
      real NIlastGrid(nNIlast),NIlast,Vlt0best,WBInext,WBItemp
      real Q0(nS*nK*nZagg,nZind),Q1(nS*nK*nZagg,nZind)
      real EMQ0(nS*nK*nZagg,nZind),EMQ1(nS*nK*nZagg,nZind),mu0
      real LaborInt1,LaborInt2,RTS,CES,meanI(nS*nK*nZagg,3)
      real meanY(nS*nK*nZagg,3),lab0,lab1,EMQ3w(nK*nS*nZagg)
      !real PolicyAnal0(nK*nS*nZagg*nDKi*nKI*nWBi*nNILast*nZind,2)
      !real Vanal0(nK*nS*nZagg*nDKi*nKI*nWBi*nNILast*nZind,1)
      real LaborDemand,LaborDemandLast
      real WageAvgGrid(nK*nS*nZagg),Q3(nK*nS*nZagg),Q3next,MPL
      real KItempDef,WBItempDef,multWBIdef,multKIdef,multNIdef
      real ProbDef,Interest,InterestNext,PriceDebtNext,PriceDebtNRPnext
      integer SortIndx6(nDKI+1),iNIlastTemp,nInd
      real EMVnext,NIlastNext,KiDef,EpriceDebt,EpriceDebtNRP
      integer iStateNextL,iStateNextH,iStateNextLnd,iStateNextHnd,iInd0
      integer iStateNextDefL,iStateNextDefH,iIndNextDefL,iIndNextDefH
      integer iIndNextND,iStateDefL,iStateDefH,iIndDef,iKiDef,iState0
      integer iIndDebt,iStateDebtL,iStateDebtH

      do i=1,nC+3+nCfine+nCfine1+1
       if(i.le.nC+3) nLaborGrid(i)=nLabor
       if(i.gt.nC+3) nLaborGrid(i)=5
       if(i.gt.nC+3+nCfine+nCfine1) nLaborGrid(i)=10
      end do

      Labor=1.0
      nAgg=nK*nS*nZagg
      nInd=nDKi*nKI*nWBi*nNILast*nZind
      nState=nAgg*nInd
      call readparams(nZagg,nZsr,nZind,nNIlast,beta1,theta,eis,deltaK,
     1     psiK0,RTS,v1P,v1N,FixedCost,growth,Agrid,Zgrid,TrProbAgg,
     2     TrProbAggSR,ZIgrid,TrProbInd,TrProbCost,
     1     lab0,lab1,tempR3,mu0,xi,CES)
      call readdata(SDF,'SDF000.txt',nAgg*nZagg*nZsr,1,
     1              nAgg*nZagg*nZsr,1)
      call readdata(RFgrid,'RFgrid.txt',nAgg,1,nAgg,1)
      call readdata(Q3,'Q3grid.txt',nAgg,1,nAgg,1)
      call readdata(BI0,'BI0000.txt',nZagg,1,nZagg,1)
      call readdata(BI1,'BI1000.txt',nZagg,1,nZagg,1)
      call readdata(BI2,'BI2000.txt',nZagg,1,nZagg,1)
      call readdata(BC0,'BC0000.txt',nZagg,1,nZagg,1)
      call readdata(BC1,'BC1000.txt',nZagg,1,nZagg,1)
      call readdata(BC2,'BC2000.txt',nZagg,1,nZagg,1)
      call readdata(BW0,'BW0000.txt',nZagg,1,nZagg,1)
      call readdata(BW1,'BW1000.txt',nZagg,1,nZagg,1)
      call readdata(BW2,'BW2000.txt',nZagg,1,nZagg,1)
      call readdata(KIgrid,'KIgrid.txt',nKi,1,nKi,1)
      call readdata(Kgrid,'Kgrid0.txt',nK,1,nK,1)
      call readdata(Sgrid,'Sgrid0.txt',nS,1,nS,1)
      call readdata(WBIgrid,'SIgrid.txt',nWBi,1,nWBi,1)
      call readdata(DKIgrid,'DKgrid.txt',nDKi,1,nDKi,1)
      call readdata(meanC,'meanC0.txt',nAgg,3,nAgg,3)
      call readdata(meanW,'meanW0.txt',nAgg,3,nAgg,3)
      call readdata(meanI,'meanI0.txt',nAgg,3,nAgg,3)
      call readdata(meanY,'meanY0.txt',nAgg,3,nAgg,3)
      call readdata(NIlastGrid,'NIgrid.txt',nNIlast,1,nNIlast,1)
      if(iIter.gt.1) then
       call readdatabinary(V,'valueF.dat',nState,1)
       call readdatabinary(Policy,'policy.dat',nState,5)
       call readdatabinary(PriceDebt,'PrcDbt.dat',nState,1)
       !call readdatabinary(PriceDebtNRP,'PrcDNR.dat',nState,1)
       !call readdata(V,'valueF.txt',nState,1,nState,1)
       !call readdata(Policy,'policy.txt',nState,5,nState,5)
       !call readdata(PriceDebt,'PrcDbt.txt',nState,1,nState,1)
       call readdata(PriceDebtRF,'PrcDRF.txt',nAgg*nDKI,1,nAgg*nDKI,1)
       !call readdata(Vanal0,'valueF.txt',nState,1,nState,1)
       !call readdata(PolicyAnal0,'policy.txt',nState,2,nState,2)
      end if

      if(abs(eis-1.0).gt..00001) then
       tempR1=(.0001**(1.0-(1.0/eis)))/(1.0-(1.0/eis))
      else
       tempR1=log(.0001)
      end if
      if(tempR1.gt.0.0) then
       minval=0.0
      else
       minval=tempR1*1000.0
      end if
      multDKImax=(DKIgrid(nDKI)*(Agrid(nZagg,nZsr)**RTS)-
     1            DKIgrid(nDKI-1))/
     1           (DKIgrid(nDKI)-DKIgrid(nDKI-1))

      paramR1=(1.0-(1.0/eis))/(1.0-theta)
      if(abs((1.0/eis)-theta).lt..00001) paramR1=1.0
      paramR2=1.0/paramR1
      paramR3=(1.0-beta1)*(1.0-theta)
      paramR4=(1.0-(1.0/eis))
      if(abs(eis-1.0).lt..00001) paramR4=1.0

      do iZ=1,nZagg
      do iZind=1,nZind
       mu0grid(iZ,iZind)=mu0*mu0shock(iZ)*mu0shock2(iZind)
      end do
      end do

      iNItemp=nint(.5*real(nNIlast))

      do iKi=1,nKi
       Ki=KIgrid(iKi)
       tempR1=KIgrid(nKi)-(1.0-deltaK)*Ki
      do iC=1,nC
       INVgrid0(iC,iKi)=-0.6*Ki+(tempR1+0.6*Ki)*real(iC-1)/real(nC-1)
      end do
      end do

      do iNIlast=1,nNIlast
      do iLabor=1,nLabor
       LaborGrid(iLabor,iNIlast)=0.01+(NIlastGrid(nNIlast)-.01)*
     1                           real(iLabor-1)/real(nLabor-2)
!       tempR1=mu0*NIlastGrid(iNIlast)
!       LaborGrid(iLabor,iNIlast,iKi)=tempR1+
!     1    (NIlastGrid(nNIlast)-tempR1)*real(iLabor-1)/real(nLabor-1)
      end do
      end do

!Create transition for aggregate quantity
      do iAgg=1,nAgg
       iZ=mod(iAgg-1,nZagg)+1
       iZlast=iZlastGrid(iZ)
       tempI1=1+(iAgg-iZ)/nZagg
       iK=mod(tempI1-1,nK)+1
       iS=1+(tempI1-iK)/nK
       !iAgg=((iS-1)*nK+iK-1)*nZagg+iZ
       K=Kgrid(iK)
       S=Sgrid(iS) !this is aggregate wage at t-1
       psiK=psiK0*psiKshock(iZ)
       tempR1=GDPmult*Zgrid(iZ)*(1.0-psiK)*RTS*(K**psiK) !use this one for general case
       !Wage=BW0(iZ)+BW1(iZ)*tempR1+BW2(iZ)*S
       if(Wage.lt..01) Wage=.01
       !meanW(iAgg,1)=Wage
       Wage=meanW(iAgg,1)
       WageGrid(iAgg)=Wage   !this is the spot wage at t
       C=exp(BC0(iZ))*(K**BC1(iZ))*(S**BC2(iZ))
       C=meanC(iAgg,1)
       if(C.lt..001) C=.001
!       INV=meanI(iAgg,1)   !wastecost
       INV=meanY(iAgg,1)-C

       tempR1=GDPmult*Zgrid(iZ)*(1.0-psiK)*RTS*(K**psiK)
       LaborDemandLast=Ngrid(iZlast)
       LaborDemand=Ngrid(iZ)
       WageAvgGrid(iAgg)=(mu0*LaborDemandLast*S*tempR1+
     1          Wage*(LaborDemand-mu0*LaborDemandLast))/LaborDemand

       do iZSRnext=1,nZsr
        psiKnext=psiK0!*psiKshock(iZSRnext)
        Knext=((1-deltaK)*K+INV)/(Agrid(iZ,iZSRnext)**RTS)
!        tempR1=GDPmult*Zgrid(iZ)*(1.0-psiK)*RTS*(K**psiK)
!        tempR2=GDPmult*Zgrid(iZnext)*
!     1        (1.0-psiKnext)*RTS*(Knext**psiKnext)
        tempR1=GDPmult*(1.0-psiK)*RTS*(K**psiK)
        tempR2=GDPmult*(1.0-psiKnext)*RTS*(Knext**psiKnext)
        Snext=(mu0*mu0shock(iZ)*S*tempR1*LaborDemandLast+
     1         Wage*(LaborDemand-mu0*mu0shock(iZ)*LaborDemandLast))/
     1        ((Agrid(iZ,iZSRnext)**RTS)*tempR2*LaborDemand)

!mu*S+(1-mu)*Wage is the average wage at t, it puts weight (1-mu) on the spot wage
        if(Snext.gt.Sgrid(nS)) Snext=Sgrid(nS)
        if(Snext.lt.Sgrid(1)) Snext=Sgrid(1)
        if(Knext.lt..001) Knext=.001
        KnextGrid(iAgg,iZSRnext)=Knext
        call findspot(Kgrid,nK,Knext,iK,iKnext)
        KspotGrid(iAgg,iZSRnext)=iKnext
        multK=(Knext-Kgrid(iKnext))/(Kgrid(iKnext+1)-Kgrid(iKnext))
        if(multK.gt.1.0) multK=1.0
        if(multK.lt.0.0) multK=0.0
        KmultGrid(iAgg,iZSRnext)=multK
        SnextGrid(iAgg,iZSRnext)=Snext
        call findspot(Sgrid,nS,Snext,iS,iSnext)
        SspotGrid(iAgg,iZSRnext)=iSnext
        multS=(Snext-Sgrid(iSnext))/(Sgrid(iSnext+1)-Sgrid(iSnext))
        if(multS.gt.1.0) multS=1.0
        if(multS.lt.0.0) multS=0.0
        SmultGrid(iAgg,iZSRnext)=multS
       end do
      end do

!create initial value function
      do iAgg=1,nAgg
       iZ=mod(iAgg-1,nZagg)+1
       tempI1=1+(iAgg-iZ)/nZagg
       iK=mod(tempI1-1,nK)+1
       iS=1+(tempI1-iK)/nK
      do iDKi=1,nDKi
      do iWBi=1,nWBi
      do iKi=1,nKi
      do iZind=1,nZind
      do iNIlast=1,nNIlast
       !iAgg=((iS-1)*nK+iK-1)*nZagg+iZ
       iInd=(iDKi-1)*nWBI*nNIlast*nKI*nZind+
     1      (iWBi-1)*nNIlast*nKI*nZind+
     1      (iNIlast-1)*nKI*nZind+(iKi-1)*nZind+iZind
       iState=(iInd-1)*nAgg+iAgg
       K=Kgrid(iK)
       S=Sgrid(iS)
       KI=KIgrid(iKI)
       WBi=WBIgrid(iWBi)
       Wage=WageGrid(iAgg)
       psiK=psiK0!*psiKshock(iZ)
       X=psiK*((1.0-psiK)**((1.0-psiK)/psiK))*
     1  (GDPmult*Zgrid(iZ)**(1.0/psiK))*(Wage**((psiK-1.0)/psiK))

       tempR1=0.0
       tempR2=0.0
       tempR3=0.0
       EMQ3w(iAgg)=0
       do iZnext=1,nZagg
       do iZSRnext=1,nZsr
        TrProb=TrProbAgg(iZ,iZnext)*TrProbAggSR(iZSRnext)
!Use below for iZSRnext perfectly correlated with iZnext (this is the process we used in an earlier version)
!        if(iZSRnext.eq.iZnext) then
!         TrProb=TrProbAgg(iZ,iZnext)
!        else
!         TrProb=0.0
!        end if
        tempR1=tempR1+TrProb*
     1         SDF((iAgg-1)*nZagg*nZsr+(iZnext-1)*nZsr+iZSRnext,1)*
     1        (1.0-deltaK)
        tempR3=tempR3+TrProb*beta1*(Agrid(iZ,iZSRnext)**RTS)
        Knext=KnextGrid(iAgg,iZSRnext)
        Snext=SnextGrid(iAgg,iZSRnext)
        multK=KmultGrid(iAgg,iZSRnext)
        multS=SmultGrid(iAgg,iZSRnext)
        iKnext=KspotGrid(iAgg,iZSRnext)
        iSnext=SspotGrid(iAgg,iZSRnext)
        psiKnext=psiK0!*psiKshock(iZnext)
        iLL=((iSnext-1)*nK+iKnext-1)*nZagg+iZnext
        iLH=iLL+nZagg
        iHL=iLL+nK*nZagg
        iHH=iHL+nZagg
        tempR4=meanW(iLL,1)+multK*(meanW(iLH,1)-meanW(iLL,1))
        tempR5=meanW(iHL,1)+multK*(meanW(iHH,1)-meanW(iHL,1))
        WageNext=tempR4+multS*(tempR5-tempR4)
        if(WageNext.lt..001) WageNext=.001
        tempR4=Q3(iLL)+multK*(Q3(iLH)-Q3(iLL))
        tempR5=Q3(iHL)+multK*(Q3(iHH)-Q3(iHL))
        Q3next=tempR4+multS*(tempR5-tempR4)
        EMQ3w(iAgg)=EMQ3w(iAgg)+TrProb*
     1      SDF((iAgg-1)*nZagg*nZsr+(iZnext-1)*nZsr+iZSRnext,1)*Q3next*
     1     ((Agrid(iZ,iZSRnext)**RTS)*WageNext-Wage)
        Xnext=psiKnext*((1.0-psiKnext)**((1.0-psiKnext)/psiKnext))*
     1  (GDPmult*Zgrid(iZnext)**(1.0/psiKnext))*
     1  (WageNext**((psiKnext-1.0)/psiKnext))

       do iZindNext=1,nZind
        tempR2=tempR2+TrProb*TrProbInd(iZind,iZindNext)*
     1         SDF((iAgg-1)*nZagg*nZsr+(iZnext-1)*nZsr+iZSRnext,1)*
     2         ZIgrid(iZindNext)*Xnext*
     3         Agrid(iZ,iZSRnext)**
     4         (RTS*(1.0-(psiKnext/(1.0-(1.0-psiKnext)*RTS))))
       end do

       end do !iZSRnext
       end do !iZnext

       PolicyAnal(iState,1)=
     1   ((1.0-tempR1)/((psiK/(1.0-(1.0-psiK)*RTS))*tempR2))**
     2   (1.0/((psiK/(1.0-(1.0-psiK)*RTS))-1.0))-(1.0-deltaK)*Ki
       tempR4=0
       if(iIter.eq.1) then
        V(iState,1)=tempR4+(1-deltaK)*Ki+
     1              ZIgrid(iZind)*X*(Ki**(psiK/(1.0-(1.0-psiK)*RTS)))+
     1              Q3(iAgg)*WBIgrid(iWBi)-
     1              Q3(iAgg)*Wage*NIlastGrid(iNIlast)
        PriceDebt(iState,1)=0!1.0/RFgrid(iAgg,1)
        PriceDebtNRP(iState,1)=0
        !PriceDebt(iState,2)=0
        PriceDebtRF((iDKI-1)*nAgg+iAgg,1)=0
        if(V(iState,1).lt.0) V(iState,1)=0
       end if
      end do
      end do
      end do
      end do
      end do
      end do

      if(iIter.eq.1) then
       call writedatabinary(PriceDebt,'PrcDbt.dat',nState,1)
       call writedatabinary(PriceDebt,'PrcDNR.dat',nState,1)
!       call writedata(PriceDebt,'PrcDbt.txt',nState,1,nState,1)
       call writedata(PriceDebtRF,'PrcDRF.txt',nAgg*nDKI,1,nAgg*nDKI,1)
      end if

c$omp parallel
c$omp& default(none)
c$omp& shared(iAgg,nAgg,nZagg,nK,nS,nDKi,nWBi,nNIlast,nZind,nKi,KIgrid,
c$omp& WageGrid,WBIgrid,NILastGrid,ZIgrid,EMQ3w,psiK0,psiKshock,
c$omp& PolicyAnal,RTS,CES,GDPmult)
c$omp& private(iZ,iK,iS,iDKi,iWBi,iNIlast,iZind,iKi,iInd,iState,tempI1,
c$omp& psiK,WBi,Ki,NIlast,tempR1,tempR2,tempR3,tempR4,iLabor,LaborInd,
c$omp& MPL,Wage)
c$omp do

      do iAgg=1,nAgg
       iZ=mod(iAgg-1,nZagg)+1
       tempI1=1+(iAgg-iZ)/nZagg
       iK=mod(tempI1-1,nK)+1
       iS=1+(tempI1-iK)/nK
       Wage=WageGrid(iAgg)
       psiK=psiK0*psiKshock(iZ)
       do iDKi=1,nDKi
       do iWBi=1,nWBi
        WBi=WBIgrid(iWBi)
       do iKi=1,nKi
        Ki=KIgrid(iKi)
       do iZind=1,nZind
       do iNIlast=1,nNIlast
        iInd=(iDKi-1)*nWBI*nNIlast*nKI*nZind+
     1       (iWBi-1)*nNIlast*nKI*nZind+
     1       (iNIlast-1)*nKI*nZind+(iKi-1)*nZind+iZind
        iState=(iInd-1)*nAgg+iAgg
        NIlast=NIlastGrid(iNIlast)
        tempR1=(Wage+EMQ3w(iAgg))/(GDPmult*RTS*(1.0-psiK)*ZIgrid(iZind))

        tempR2=10000000
        do iLabor=1,25
         LaborInd=.01+(NIlastGrid(nNIlast)-.01)*real(iLabor-1)/(25-1)
         if(abs(CES).gt..0001) then
          MPL=(LaborInd**(RTS*CES-1.0))*
     1        (psiK*(Ki**CES)+(1.0-psiK)*(LaborInd**(RTS*CES)))**
     1        ((1.0-CES)/CES)
         else
          MPL=(Ki**psiK)*(LaborInd**(RTS*(1.0-psiK)-1.0))
         end if
         if(abs(1.0-(MPL/tempR1)).lt.tempR2) then
          tempR2=abs(1.0-(MPL/tempR1))
          PolicyAnal(iState,2)=LaborInd
         end if
        end do

        LaborInd=PolicyAnal(iState,2)
        do iLabor=1,50
         if(abs(CES).gt..0001) then
          MPL=(LaborInd**(RTS*CES-1.0))*
     1        (psiK*(Ki**CES)+(1.0-psiK)*(LaborInd**(RTS*CES)))**
     1        ((1.0-CES)/CES)
         else
          MPL=(Ki**psiK)*(LaborInd**(RTS*(1.0-psiK)-1.0))
         end if
         if(iLabor.lt.25) then
          LaborInd=LaborInd+.5*((MPL/tempR1)-1.0)
         else
          LaborInd=LaborInd+.25*((MPL/tempR1)-1.0)
         end if
         if(LaborInd.lt..01) LaborInd=.01
         if(abs(1.0-(MPL/tempR1)).lt..01) goto 838
        end do
 838    continue
        if(abs(1.0-(MPL/tempR1)).lt.tempR2) then
         PolicyAnal(iState,2)=LaborInd
        end if

        tempR3=1.0/(1.0-RTS*(1.0-psiK))
        tempR4=
     1 ((GDPmult*RTS*(1.0-psiK)*ZIgrid(iZind)/
     1  (Wage+EMQ3w(iAgg)))**tempR3)*
     1 (KIgrid(iKi)**(psiK*tempR3))
        if(abs(CES).lt..0001) then
         PolicyAnal(iState,2)=tempR4
        end if
        if(PolicyAnal(iState,2).gt.NIlastGrid(nNIlast)) then
         PolicyAnal(iState,2)=NIlastGrid(nNIlast)
        end if
       end do
       end do
       end do
       end do
       end do
      end do

c$omp end do
c$omp end parallel


!      call itime(mytime)
!      write(6,*) mytime,' start t'


      if(iIter.eq.1) then
       TotYearsCur=TotYears0
      else
       TotYearsCur=TotYears1
      end if
      do t=1,TotYearsCur+TotYearsV

      do i=1,nState
       Vmax(i,1)=minval
       if(t.eq.1.and.iIter.eq.1) then
        Policy(i,1)=0!INV
        Policy(i,2)=1.0!LaborInd/LaborIndMPL
        Policy(i,3)=0
        Policy(i,4)=0.0 !default
        Policy(i,5)=0.0 !PriceDebt
       end if
       if(t.le.TotYearsCur) then
        iKInextBest(i)=1
        iWBInextBest(i)=1
        iNInextBest(i)=1
        iDKInextBest(i)=1
        multWBiBest(i)=0
        multKIBest(i)=0
        multNIBest(i)=0
        multDKIBest(i)=0
        DKInextBest(i)=0
        KInextBest(i)=0
        WBInextBest(i)=0
        DivBest(i)=0
       end if
      end do

c$omp parallel
c$omp& default(none)
c$omp& shared(iAgg,nAgg,nZagg,nK,nS,nDKi,nWBi,nNIlast,nZind,nKi,KIgrid,
c$omp& V,DerivsAllKi)
c$omp& private(iZ,iK,iS,iWBi,iNIlast,iZind,iDKi,iKi,iInd,iState,tempI1,
c$omp& tempI2,VtempKi,DtempKi)
c$omp do

      do iAgg=1,nAgg
       iZ=mod(iAgg-1,nZagg)+1
       tempI1=1+(iAgg-iZ)/nZagg
       iK=mod(tempI1-1,nK)+1
       iS=1+(tempI1-iK)/nK
       !iAgg=((iS-1)*nK+iK-1)*nZagg+iZ
! create derivatives of V
       do iDKI=1,nDKi
       do iWBi=1,nWBi
       do iNIlast=1,nNIlast
       do iZind=1,nZind
        do iKi=1,nKi
         iInd=(iDKi-1)*nWBI*nNIlast*nKI*nZind+
     1        (iWBi-1)*nNIlast*nKI*nZind+
     1        (iNIlast-1)*nKI*nZind+(iKi-1)*nZind+iZind
         iState=(iInd-1)*nAgg+iAgg
         VtempKi(iKi)=V(iState,1)
        end do
        tempI1=1
        tempI2=0
        call PCHIM(nKi,KIgrid,VtempKi,DtempKi,tempI1,tempI2)
        do iKi=1,nKi
         iInd=(iDKi-1)*nWBI*nNIlast*nKI*nZind+
     1        (iWBi-1)*nNIlast*nKI*nZind+
     1        (iNIlast-1)*nKI*nZind+(iKi-1)*nZind+iZind
         iState=(iInd-1)*nAgg+iAgg
         DerivsAllKi(iState)=DtempKi(iKi)
        end do
       end do
       end do
       end do
       end do

      end do

c$omp end do
c$omp end parallel



c$omp parallel
c$omp& default(none)
c$omp& shared(iAgg,nAgg,nZagg,nZsr,nK,nS,nDKi,nWBi,nNIlast,nZind,nKi,
c$omp& KIgrid,WBIgrid,KnextGrid,KspotGrid,KmultGrid,SnextGrid,SspotGrid,
c$omp& SmultGrid,SDF,Agrid,RTS,TrProbAgg,TrProbInd,V,DerivsAllKi,
c$omp& NIlastGrid,VnextGrid,PriceDebtNextGrid,DKIgrid,multDKImax,
c$omp& RecRate,Policy,PriceDebt,t,deltaK,TrProbAggSR,RFgrid,
c$omp& PriceDebtNRP,PriceDebtNRPNextGrid)
c$omp& private(iZ,iK,iS,iWBInext,iNIlastNext,iZind,iKInext,iInd,iState,
c$omp& iZnext,tempI1,tempI2,KInext,WBInext,Vnext,Knext,iKnext,multK,
c$omp& Snext,iSnext,multS,iAggNext,iIndNextL,iIndNextH,Vnext1,
c$omp& SDFtemp,KItemp,iKItemp,DKItemp,iDKItemp,WBItemp,iWBItemp,
c$omp& iDKInext,DKInext,iZindNext,TrProb,jDKI,jWBI,jS,jK,Vnext3,Vnext2,
c$omp& Vnext4,tempI3,extrap,tempR1,multKI,multDKI,multWBI,
c$omp& iStateNextL,iStateNextH,EpriceDebt,InterestNext,PriceDebtNext,
c$omp& iIndNextDefL,iIndNextDefH,iStateNextDefL,iStateNextDefH,iKiDef,
c$omp& KIdef,multKIdef,Vdef4,Vdef3,Vdef2,Vdef1,Vdebt4,Vdebt3,Vdebt2,
c$omp& Vdebt1,Def4,Def3,Def2,Def1,Def,Vdef,tempR3,EMVnext,iZSRnext,
c$omp& EpriceDebtNRP,PriceDebtNRPnext,VdebtNRP4,VdebtNRP3,VdebtNRP2,
c$omp& VdebtNRP1)
c$omp do

      do iAgg=1,nAgg
       iZ=mod(iAgg-1,nZagg)+1
       tempI1=1+(iAgg-iZ)/nZagg
       iK=mod(tempI1-1,nK)+1
       iS=1+(tempI1-iK)/nK
       !iAgg=((iS-1)*nK+iK-1)*nZagg+iZ
       do iZind=1,nZind
       do iKInext=1,nKi
       do iNIlastNext=1,nNIlast
       do iWBInext=1,nWBi
       do iDKInext=1,nDKi
        iInd=(iDKInext-1)*nWBI*nNIlast*nKI*nZind+
     1       (iWBInext-1)*nNIlast*nKI*nZind+
     1       (iNIlastNext-1)*nKI*nZind+(iKInext-1)*nZind+iZind
        iState=(iInd-1)*nAgg+iAgg
        KInext=KIgrid(iKiNext)

        WBInext=WBIgrid(iWBInext)
        DKInext=DKIgrid(iDKInext)
        !LaborInd=NIgrid(iNIlast)  !dont need to define it as it stays on grid because its stationary and doesn't need to be rescaled by A^RTS

        EMVnext=0
        EpriceDebt=0
        EpriceDebtNRP=0
        tempR3=0
        do iZnext=1,nZagg
        do iZSRnext=1,nZsr
         Knext=KnextGrid(iAgg,iZSRnext)
         iKnext=KspotGrid(iAgg,iZSRnext)
         multK=KmultGrid(iAgg,iZSRnext)
         Snext=SnextGrid(iAgg,iZSRnext)
         iSnext=SspotGrid(iAgg,iZSRnext)
         multS=SmultGrid(iAgg,iZSRnext)
         SDFtemp=SDF((iAgg-1)*nZagg*nZsr+(iZnext-1)*nZsr+iZSRnext,1)
         KItemp=KInext/(Agrid(iZ,iZSRnext)**RTS)
         call findspot(KIgrid,nKI,KItemp,iKInext,iKItemp)
         multKI=(KItemp-KIgrid(iKItemp))/
     1          (KIgrid(iKItemp+1)-KIgrid(iKItemp))
         if(multKI.lt.0.0) multKI=0.0
         if(multKI.gt.1.0) multKI=1.0
         KIdef=RecRate*KItemp
         call findspot(KIgrid,nKI,KIdef,iKItemp,iKIdef)
         multKIdef=(KIdef-KIgrid(iKiDef))/
     1             (KIgrid(iKiDef+1)-KIgrid(iKiDef))
         if(multKIdef.lt.0.0) multKIdef=0.0
         if(multKIdef.gt.1.0) multKIdef=1.0
         DKItemp=DKInext/(Agrid(iZ,iZSRnext)**RTS)
         call findspot(DKIgrid,nDKI,DKItemp,iDKInext,iDKItemp)
         multDKI=(DKItemp-DKIgrid(iDKItemp))/
     1           (DKIgrid(iDKItemp+1)-DKIgrid(iDKItemp))
         if(multDKI.lt.0.0) multDKI=0.0
         if(multDKI.gt.multDKImax) multDKI=multDKImax
         InterestNext=DKItemp
         WBItemp=WBInext/(Agrid(iZ,iZSRnext)**RTS)
         call findspot(WBIgrid,nWBI,WBItemp,iWBInext,iWBItemp)
         multWBI=(WBItemp-WBIgrid(iWBItemp))/
     1           (WBIgrid(iWBItemp+1)-WBIgrid(iWBItemp))
         if(multWBI.lt.0.0) multWBI=0.0
         !if(multWBI.gt.1.0) multWBI=1.0
        do iZindNext=1,nZind
         TrProb=TrProbAgg(iZ,iZnext)*TrProbAggSR(iZSRnext)*
     1          TrProbInd(iZind,iZindNext)
!Use below for iZSRnext perfectly correlated with iZnext (this is the process we used in a previous version)
!         if(iZSRnext.eq.iZnext) then
!          TrProb=TrProbAgg(iZ,iZnext)*TrProbInd(iZind,iZindNext)
!         else
!          TrProb=0.0
!         end if
         if(TrProb.lt..0001) goto 1088

         do jDKI=1,2
         do jWBI=1,2
         do jS=1,2
         do jK=1,2

          iAggNext=(iSnext+(jS-1)-1)*nK*nZagg+
     1             (iKnext+(jK-1)-1)*nZagg+iZnext
          iIndNextL=(iDKItemp+(jDKI-1)-1)*nWBI*nNIlast*nKI*nZind+
     1              (iWBItemp+(jWBI-1)-1)*nNIlast*nKI*nZind+
     1              (iNIlastNext-1)*nKI*nZind+
     1              (iKItemp-1)*nZind+iZindNext
          iIndNextH=(iDKItemp+(jDKI-1)-1)*nWBI*nNIlast*nKI*nZind+
     1              (iWBItemp+(jWBI-1)-1)*nNIlast*nKI*nZind+
     1              (iNIlastNext-1)*nKI*nZind+
     1              (iKItemp+1-1)*nZind+iZindNext
          iStateNextL=(iIndNextL-1)*nAgg+iAggNext
          iStateNextH=(iIndNextH-1)*nAgg+iAggNext
          iIndNextDefL=(1+(jDKI-1)-1)*nWBI*nNIlast*nKI*nZind+
     1                 (iWBItemp+(jWBI-1)-1)*nNIlast*nKI*nZind+
     1                 (iNIlastNext-1)*nKI*nZind+
     1                 (iKiDef-1)*nZind+iZindNext
          iIndNextDefH=(1+(jDKI-1)-1)*nWBI*nNIlast*nKI*nZind+
     1                 (iWBItemp+(jWBI-1)-1)*nNIlast*nKI*nZind+
     1                 (iNIlastNext-1)*nKI*nZind+
     1                 (iKiDef+1-1)*nZind+iZindNext
          iStateNextDefL=(iIndNextDefL-1)*nAgg+iAggNext
          iStateNextDefH=(iIndNextDefH-1)*nAgg+iAggNext  

          if(KItemp.lt.KIgrid(1)) then
           Vnext4(jDKI,jWBI,jS,jK)=V(iStateNextL,1)
          else
           if(KItemp.gt.KIgrid(nKI)) then
            Vnext4(jDKI,jWBI,jS,jK)=V(iStateNextL,1)+multKI*
     1                             (V(iStateNextH,1)-V(iStateNextL,1))
           else
            call CHFEV(KIgrid(iKItemp),KIgrid(iKItemp+1),
     1            V(iStateNextL,1),V(iStateNextH,1),
     2            DerivsAllKi(iStateNextL),DerivsAllKi(iStateNextH),
     3            1,KItemp,tempR1,extrap,tempI3) !low S, low K
            if(tempR1.lt.V(iStateNextL,1).or.
     1         tempR1.gt.V(iStateNextH,1)) then
             tempR1=V(iStateNextL,1)+multKI*
     1             (V(iStateNextH,1)-V(iStateNextL,1))
            end if
            Vnext4(jDKI,jWBI,jS,jK)=tempR1
           end if
          end if

          Def4(jDKI,jWBI,jS,jK)=Policy(iStateNextL,4)+multKI*
     1                  (Policy(iStateNextH,4)-Policy(iStateNextL,4))
          Vdef4(jDKI,jWBI,jS,jK)=V(iStateNextDefL,1)+multKIdef*
     1                        (V(iStateNextDefH,1)-V(iStateNextDefL,1))
          Vdebt4(jDKI,jWBI,jS,jK)=PriceDebt(iStateNextL,1)+multKI*
     1              (PriceDebt(iStateNextH,1)-PriceDebt(iStateNextL,1))
!          VdebtNRP4(jDKI,jWBI,jS,jK)=PriceDebtNRP(iStateNextL,1)+multKI*
!     1         (PriceDebtNRP(iStateNextH,1)-PriceDebtNRP(iStateNextL,1))
!          dVdebt4(jDKI,jWBI,jS,jK)=DerivsAllDKi(iStateNextL)+multKI*
!     1            (DerivsAllDKi(iStateNextH)-DerivsAllDKi(iStateNextL))
         end do
          Vnext3(jDKI,jWBI,jS)=Vnext4(jDKI,jWBI,jS,1)+multK*
     1                  (Vnext4(jDKI,jWBI,jS,2)-Vnext4(jDKI,jWBI,jS,1))
          Vdef3(jDKI,jWBI,jS)=Vdef4(jDKI,jWBI,jS,1)+multK*
     1                  (Vdef4(jDKI,jWBI,jS,2)-Vdef4(jDKI,jWBI,jS,1))
          Vdebt3(jDKI,jWBI,jS)=Vdebt4(jDKI,jWBI,jS,1)+multK*
     1                  (Vdebt4(jDKI,jWBI,jS,2)-Vdebt4(jDKI,jWBI,jS,1))
!          VdebtNRP3(jDKI,jWBI,jS)=VdebtNRP4(jDKI,jWBI,jS,1)+multK*
!     1             (VdebtNRP4(jDKI,jWBI,jS,2)-VdebtNRP4(jDKI,jWBI,jS,1))
!          dVdebt3(jDKI,jWBI,jS)=dVdebt4(jDKI,jWBI,jS,1)+multK*
!     1                (dVdebt4(jDKI,jWBI,jS,2)-dVdebt4(jDKI,jWBI,jS,1))
          Def3(jDKI,jWBI,jS)=Def4(jDKI,jWBI,jS,1)+multK*
     1                  (Def4(jDKI,jWBI,jS,2)-Def4(jDKI,jWBI,jS,1))
         end do
          Vnext2(jDKI,jWBI)=Vnext3(jDKI,jWBI,1)+multS*
     1                     (Vnext3(jDKI,jWBI,2)-Vnext3(jDKI,jWBI,1))
          Vdef2(jDKI,jWBI)=Vdef3(jDKI,jWBI,1)+multS*
     1                     (Vdef3(jDKI,jWBI,2)-Vdef3(jDKI,jWBI,1))
          Vdebt2(jDKI,jWBI)=Vdebt3(jDKI,jWBI,1)+multS*
     1                     (Vdebt3(jDKI,jWBI,2)-Vdebt3(jDKI,jWBI,1))
!          VdebtNRP2(jDKI,jWBI)=VdebtNRP3(jDKI,jWBI,1)+multS*
!     1                   (VdebtNRP3(jDKI,jWBI,2)-VdebtNRP3(jDKI,jWBI,1))
!          dVdebt2(jDKI,jWBI)=dVdebt3(jDKI,jWBI,1)+multS*
!     1                     (dVdebt3(jDKI,jWBI,2)-dVdebt3(jDKI,jWBI,1))
          Def2(jDKI,jWBI)=Def3(jDKI,jWBI,1)+multS*
     1                     (Def3(jDKI,jWBI,2)-Def3(jDKI,jWBI,1))
         end do
          Vnext1(jDKI)=Vnext2(jDKI,1)+multWBI*
     1                (Vnext2(jDKI,2)-Vnext2(jDKI,1))
          if(multWBI.gt.1.0.and.Vnext2(jDKI,2).gt.Vnext2(jDKI,1)) then
           Vnext1(jDKI)=Vnext2(jDKI,2)
          end if
          Vdebt1(jDKI)=Vdebt2(jDKI,1)+multWBI*
     1                (Vdebt2(jDKI,2)-Vdebt2(jDKI,1))
          if(multWBI.gt.1.0.and.Vdebt2(jDKI,2).gt.Vdebt2(jDKI,1)) then
           Vdebt1(jDKI)=Vdebt2(jDKI,2)
          end if
!          VdebtNRP1(jDKI)=VdebtNRP2(jDKI,1)+multWBI*
!     1                   (VdebtNRP2(jDKI,2)-VdebtNRP2(jDKI,1))
!          if(multWBI.gt.1.0.and.
!     1       VdebtNRP2(jDKI,2).gt.VdebtNRP2(jDKI,1)) then
!           VdebtNRP1(jDKI)=VdebtNRP2(jDKI,2)
!          end if
!          dVdebt1(jDKI)=dVdebt2(jDKI,1)+multWBI*
!     1                (dVdebt2(jDKI,2)-dVdebt2(jDKI,1))
          Vdef1(jDKI)=Vdef2(jDKI,1)+multWBI*
     1               (Vdef2(jDKI,2)-Vdef2(jDKI,1))
          if(multWBI.gt.1.0.and.Vdef2(jDKI,2).gt.Vdef2(jDKI,1)) then
           Vdef1(jDKI)=Vdef2(jDKI,2)
          end if
          Def1(jDKI)=Def2(jDKI,1)+multWBI*
     1              (Def2(jDKI,2)-Def2(jDKI,1))
         end do
         Vnext=Vnext1(1)+multDKI*(Vnext1(2)-Vnext1(1))
         if(Vnext.lt.0) Vnext=0
         Vdef=Vdef1(1)!+multDKI*(Vdef1(2)-Vdef1(1))
         Def=Def1(1)+multDKI*(Def1(2)-Def1(1))
         if(Vnext.lt..0001) Def=1.0

         if(Def.lt.0.5) then
          PriceDebtNext=Vdebt1(1)+multDKI*(Vdebt1(2)-Vdebt1(1))
!          call CHFEV(DKIgrid(iDKItemp),DKIgrid(iDKItemp+1),
!     1             Vdebt1(1),Vdebt1(2),dVdebt1(1),dVdebt1(2),
!     3             1,DKItemp,tempR1,extrap,tempI3)
!          PriceDebtNext=tempR1
          if(PriceDebtNext.lt.0) PriceDebtNext=0
          EpriceDebt=EpriceDebt+TrProb*SDFtemp*
     1              (Agrid(iZ,iZSRnext)**RTS)*
     1              (InterestNext+PriceDebtNext) !PriceDebt is the price of an asset that definitely pays interest next period, and after that with probability 1-ProbExp unless the debt defaults
          EpriceDebtNRP=EpriceDebtNRP+TrProb*(1.0/RFgrid(iAgg,1))*
     1              (Agrid(iZ,iZSRnext)**RTS)*
     1              (InterestNext+PriceDebtNext)
         else
          EpriceDebt=EpriceDebt+TrProb*SDFtemp*
     1              (Agrid(iZ,iZSRnext)**RTS)*Vdef
          EpriceDebtNRP=EpriceDebtNRP+TrProb*(1.0/RFgrid(iAgg,1))*
     1              (Agrid(iZ,iZSRnext)**RTS)*Vdef
          Vnext=0
         end if
         tempR3=tempR3+TrProb*SDFtemp*(Agrid(iZ,iZSRnext)**RTS)*Vdef


      if(iK.eq.9.and.iS.eq.4.and.iZ.eq.2) then
      if(iZind.eq.2.and.iKiNext.eq.25.and.iNIlastNext.eq.5.and.
     1   (iWBInext.eq.1.or.iWBInext.eq.5.or.
     1    iWBInext.eq.10.or.iWBInext.eq.15).and.
     1   (iDKInext.eq.2.or.iDKInext.eq.5.or.iDKInext.eq.10)) then
      if(Def.lt.0.5) then
      write(6,'(f8.3,f8.3,i4,i4,i4,f9.4,f9.4,f9.4,f9.4,f5.1)')
     1 WBInext,DKInext,iZnext,iZSRnext,iZindNext,RFgrid(iAgg,1),SDFtemp,
     1 InterestNext,PriceDebtNext,Def
      else
      write(6,'(f8.3,f8.3,i4,i4,i4,f9.4,f9.4,f9.4,f9.4,f5.1)')
     1 WBInext,DKInext,iZnext,iZSRnext,iZindNext,RFgrid(iAgg,1),SDFtemp,
     1 0,Vdef,Def
      end if
      end if
      end if

  
         EMVnext=EMVnext+TrProb*SDFtemp*(Agrid(iZ,iZSRnext)**RTS)*Vnext
!note: no need to interpolate across NIlastNext because it is already at the grid point

 1088   continue
        end do !iZindNext
        end do !iZSRnext
        end do !iZnext

        VnextGrid(iState)=EMVnext
        PriceDebtNextGrid(iState)=EpriceDebt
        PriceDebtNRPNextGrid(iState)=EpriceDebtNRP

!        if(iAgg.eq.145.and.iZind.eq.1.and.iWBInext.eq.1.and.
!     1 iNIlastNext.eq.1.and.iDKInext.eq.5) then
!        write(6,'(i12,i6,i3,i4,i4,i4,i4,f8.4,f8.4,f8.4,f8.4)') 
!     1 iState,iAgg,iZind,iKInext,iNIlastNext,
!     1 iWBInext,iDKInext,KInext,EMVnext,EpriceDebt,tempR3
!        end if


       end do !iDKInext
       end do !iSInext
       end do !iNIlastNext
       end do !iKInext
       end do !iZind
      end do

c$omp end do
c$omp end parallel


c$omp parallel
c$omp& default(none)
c$omp& shared(iAgg,nAgg,nZagg,nK,nS,nDKI,nWBI,nNIlast,nZind,nKi,KIgrid,
c$omp& VnextGrid,DerivsAllKi)
c$omp& private(iZ,iK,iS,iDKI,iWBI,iNIlast,iZind,iKi,iInd,iState,tempI1,
c$omp& tempI2,VtempKi,DtempKi)
c$omp do

      do iAgg=1,nAgg
       iZ=mod(iAgg-1,nZagg)+1
       tempI1=1+(iAgg-iZ)/nZagg
       iK=mod(tempI1-1,nK)+1
       iS=1+(tempI1-iK)/nK
       !iAgg=((iS-1)*nK+iK-1)*nZagg+iZ
! create derivatives of Vnext, note that they are stored in DerivsAllKi (before stored dVnext/dK there but don't need dVnext/dK in this iteration anymore)
       do iDKI=1,nDKI
       do iWBI=1,nWBI
       do iNIlast=1,nNIlast
       do iZind=1,nZind
        do iKi=1,nKi
         iInd=(iDKi-1)*nWBI*nNIlast*nKI*nZind+
     1        (iWBi-1)*nNIlast*nKI*nZind+
     1        (iNIlast-1)*nKI*nZind+(iKi-1)*nZind+iZind
         iState=(iInd-1)*nAgg+iAgg
         VtempKi(iKi)=VnextGrid(iState)
        end do
        tempI1=1
        tempI2=0
        call PCHIM(nKi,KIgrid,VtempKi,DtempKi,tempI1,tempI2)
        do iKi=1,nKi
         iInd=(iDKi-1)*nWBI*nNIlast*nKI*nZind+
     1        (iWBi-1)*nNIlast*nKI*nZind+
     1        (iNIlast-1)*nKI*nZind+(iKi-1)*nZind+iZind
         iState=(iInd-1)*nAgg+iAgg
         DerivsAllKi(iState)=DtempKi(iKi)
        end do
       end do
       end do
       end do
       end do

      end do

c$omp end do
c$omp end parallel



c$omp parallel
c$omp& default(none)
c$omp& shared(iAgg,nAgg,nZagg,nK,nS,nDKi,nWBi,nNIlast,nZind,nKi,KIgrid,
c$omp& WBIgrid,NIlastGrid,Kgrid,Sgrid,WageGrid,psiK0,psiKshock,RTS,
c$omp& Zgrid,ZIgrid,INVgrid0,LaborGrid,nLaborGrid,TotYearsCur,t,
c$omp& mu0,mu0grid,mu0shock,Policy,Vmax,deltaKfree,v1P,v1N,xi,deltaK,
c$omp& CES,FixedCost,EMQ3w,VnextGrid,PolicyAnal,iKInextBest,iNInextBest,
c$omp& PriceDebt,Ngrid,iWBInextBest,multKIBest,multNIBest,
c$omp& multWBIbest,DivBest,DerivsAllKi,GDPmult,psiKshock2,iDKInextBest,
c$omp& iZlastGrid,KInextBest,WageAvgGrid,multDKIbest,DKIgrid,KmultGrid,
c$omp& WBInextBest,iIter,RFgrid,CorpTax,DKInextBest,V,SDF,SmultGrid,
c$omp& Agrid,TrProbAgg,TrProbInd,meanY,meanC,PriceDebtNextGrid,
c$omp& KspotGrid,SspotGrid,RecRate,ProbExp,TrProbAggSR,
c$omp& PriceDebtNRPNextGrid,PriceDebtNRP)
c$omp& private(iZ,iK,iS,iDKi,iWBI,iZind,iKi,iNIlast,iInd,iState,iZnext,
c$omp& iZlast,tempI1,tempI2,K,S,KI,WBi,NIlast,Wage,psiK,LaborIndMPL,
c$omp& LaborInt1,LaborInt2,LaborInt3,iC,iLabor,INV,LaborInd,Costs,Vnext,
c$omp& KInext,iKinext,tempR1,WageBill,Yi,DIV,WBInext,iWBInext,multWBI,
c$omp& multKI,iNIlastNext,multNI,Vnext1,Vnext2,Vnext3,Vtemp,iIndNext,
c$omp& LaborIndBest1,LaborIndBest2,LaborIndBest3,jNI,jWBI,jDKI,TaxPaid,
c$omp& INVfine,INVfine1,tempR2,iLtemp,psiKnext,tempI3,tempR3,extrap,
c$omp& Vlt0best,LaborIndAnal,iDKInext,multDKI,DKInext,nDKIchoice,
c$omp& DKIchoice,DKIchoice1,DKIchoice2,iDKIchoice,iKItemp,Knext,
c$omp& KIbar,iAggNext,iStateNext,jKI,jK,jS,iWBItemp,
c$omp& WBItemp,KItemp,TrProb,SDFtemp,multS,multK,iKnext,iSnext,
c$omp& KItempDef,multKIdef,iIndNextDef,iStateNextDef,
c$omp& Vnext3nd,Vnext2nd,Vnext1nd,VnextND,Vdebt3,Vdebt2,Vdebt1,Vdebt,
c$omp& VdebtNRP3,VdebtNRP2,VdebtNRP1,VdebtNRP,
c$omp& EMVnext,iStateDebtH,iIndNextND,iIndDebt,iStateDebtL,
c$omp& Interest,iStateNextL,iStateNextH,iStateNextLnd,iStateNextHnd)
c$omp do

      do iAgg=1,nAgg!
       iZ=mod(iAgg-1,nZagg)+1
       tempI1=1+(iAgg-iZ)/nZagg
       iK=mod(tempI1-1,nK)+1
       iS=1+(tempI1-iK)/nK
       !iAgg=((iS-1)*nK+iK-1)*nZagg+iZ
       iZlast=iZlastGrid(iZ)
       K=Kgrid(iK)
       S=Sgrid(iS)
       Wage=WageGrid(iAgg) !this is the spot wage
       Knext=(1.0-deltaK)*K+meanY(iAgg,1)-meanC(iAgg,1) !this isn't actual Knext as not normalizing by A^RTS

       do iDKi=1,nDKi
        Interest=DKIgrid(iDKI)
       do iWBi=1,nWBi
        WBi=WBIgrid(iWBi)
       do iKi=1,nKi
        Ki=KIgrid(iKi)
        KiBar=Ki
	if(KiBar.lt.0.5) KiBar=0.5
       do iZind=1,nZind
       do iNIlast=1,nNIlast

        iInd=(iDKi-1)*nWBI*nNIlast*nKI*nZind+
     1       (iWBi-1)*nNIlast*nKI*nZind+
     1       (iNIlast-1)*nKI*nZind+(iKi-1)*nZind+iZind
        iState=(iInd-1)*nAgg+iAgg

        NIlast=NIlastGrid(iNIlast)
        psiK=psiK0*psiKshock(iZ)*psiKshock2(iZind)
        LaborIndMPL=
     1   (((1.0-psiK)*RTS*GDPmult*Zgrid(iZ)*ZIgrid(iZind)/Wage)**
     1             (1.0/(1.0-(1.0-psiK)*RTS)))*
     2             (Ki**(psiK/(1.0-(1.0-psiK)*RTS)))
        Vlt0best=-100000
        tempR1=LaborGrid(2,iNIlast)-LaborGrid(1,iNIlast)
        LaborInt1=.5*tempR1
        LaborInt2=.25*tempR1
        LaborInt3=.15*tempR1

        LaborIndAnal=PolicyAnal(iState,2)   !this is the analytic solution when there are no labor adjustment costs
        DKIchoice(1)=DKIgrid(1)
        DKIchoice(2)=DKIgrid(nDKI)
        DKIchoice1(1)=DKIgrid(1)
        DKIchoice1(2)=DKIgrid(nDKI)
        DKIchoice2(1)=DKIgrid(1)
        DKIchoice2(2)=DKIgrid(nDKI)

        do iC=1,nC+3+nCfine+nCfine1+1

         if(iC.eq.nC+3+1.or.iC.eq.nC+3+nCfine+1) then
          if(iC.eq.nC+3+1) then
           DKIchoice(1)=DKIchoice1(1)
           DKIchoice(2)=DKIchoice1(2)
          else
           DKIchoice(1)=DKIchoice2(1)
           DKIchoice(2)=DKIchoice2(2)
          end if
         end if

        do iLabor=1,nLaborGrid(iC)

        if(iDKI.eq.1) then
         nDKIchoice=1+nint(real(DKIgrid(nDKI))/0.045)
        else
         nDKIchoice=1
        end if
        do iDKIchoice=1,nDKIchoice

         if(t.gt.TotYearsCur) then
          if(iC.gt.1.or.iLabor.gt.1.or.iDKIchoice.gt.1) then
           goto 301
          else
           INV=Policy(iState,1)
           LaborInd=LaborIndMPL*Policy(iState,2)
           WBInext=WBInextBest(iState)
           KInext=KInextBest(iState)
           DKInext=DKInextBest(iState)
           iKInext=iKInextBest(iState)
           iNIlastNext=iNInextBest(iState)
           iWBInext=iWBInextBest(iState)
           iDKInext=iDKInextBest(iState)
           multWBI=multWBIBest(iState)
           multNI=multNIBest(iState)
           multKI=multKIBest(iState)
           multDKI=multDKIBest(iState)
           DIV=DivBest(iState)
           Vdebt=Policy(iState,5)
           goto 303
          end if
         end if

         if((iC.eq.nC+1.or.iC.eq.nC+2).and.iKi.eq.1) goto 301
         if(iC.le.nC) then
          INV=INVgrid0(iC,iKi)
          LaborInd=LaborGrid(iLabor,iNIlast)!LaborIndMPL*LaborGrid(iLabor)
          if(iLabor.eq.nLabor) LaborInd=LaborIndAnal
         else
          if(iC.eq.nC+1.or.iC.eq.nC+2.or.iC.eq.nC+3) then
           if(iC.eq.nC+1) INV=Policy(iState-nAgg*nZind,1)
           if(iC.eq.nC+2)
     1        INV=Policy(iState-nAgg*nZind,1)*KIgrid(iKi)/KIgrid(iKi-1)
           if(iC.eq.nC+3) INV=PolicyAnal(iState,1)
           LaborInd=LaborGrid(iLabor,iNIlast)!LaborIndMPL*LaborGrid(iLabor)
           if(iLabor.eq.nLabor) LaborInd=LaborIndAnal
          else
           tempR1=-1.0+2.0*real(iLabor-1)/real(nLaborGrid(iC)-1)
           if(iC.le.nC+3+nCfine) then
            INV=INVfine(1)+(INVfine(2)-INVfine(1))*
     1          real(iC-(nC+3)-1)/real(nCfine-1)
            LaborInd=LaborIndBest1+tempR1*LaborInt1
            if(LaborIndBest1-LaborInt1.lt..01) then
             LaborInd=.01+2.0*LaborInt1*
     1                real(iLabor-1)/real(nLaborGrid(iC)-1)
            end if
           else
            if(iC.le.nC+3+nCfine+nCfine1) then
             INV=INVfine1(1)+(INVfine1(2)-INVfine1(1))*
     1           real(iC-(nC+3+nCfine)-1)/real(nCfine1-1)
             LaborInd=LaborIndBest2+tempR1*LaborInt2
             if(LaborIndBest2-LaborInt2.lt..01) then
              LaborInd=.01+2.0*LaborInt2*
     1                 real(iLabor-1)/real(nLaborGrid(iC)-1)
             end if
            else
             INV=Policy(iState,1)
             LaborInd=LaborIndBest3+tempR1*LaborInt3
             if(LaborIndBest3-LaborInt3.lt..01) then
              LaborInd=.01+2.0*LaborInt3*
     1                 real(iLabor-1)/real(nLaborGrid(iC)-1)
             end if
             if(iLabor.eq.nLabor) LaborInd=LaborIndAnal
            end if
           end if
          end if
         end if

         if(iDKI.eq.1) then
          DKInext=DKIchoice(1)+(DKIchoice(2)-DKIchoice(1))*
     1            real(iDKIchoice-1)/real(nDKIchoice-1)
         else
          DKInext=Interest
         end if
         if(LaborInd.gt.NIlastGrid(nNIlast))
     1      LaborInd=NIlastGrid(nNIlast)
         Costs=v1P*((INV-deltaKfree*Ki)**2.0)/KiBar
         KInext=(1-deltaK)*Ki+INV
!note: M(t+1)=b*(c(t+1)/c(t))^-theta * A(t+1)^(-RTS*theta) = b*(C(t+1)/C(t))^-theta
!v(t)=d(t)+E[M(t+1) * A(t+1)^RTS * v(t+1)]  <-> V(t)=v(t)*X(t)^RTS = d(t)*X(t)^RTS + E[M(t+1)*X(t+1)*v(t+1)]=D(t)+E[M(t+1)V(t+1)]
!for any asset that pays B(t+1) at t+1, and whose detrended value is b(t+1)*X(t+1)^RTS, P(t)=p(t)*X(t)^RTS=E[M(t+1)*B(t+1)] -> p(t)=E[M(t+1) * A(t+1)^RTS * b(t+1)]
!in the case of corporate debt w/ face value F(t+1) (known at t), the price per dollar:
!P(t)/F(t+1)=E[M(t+1) * B(t+1)/F(t+1)] = E[M(t+1)*(1-Def(t+1))*1]+E[M(t+1)*Def(t+1)*V(t+1)/F(t+1)]
!Note that F is expressed as DKI*KI so that V(t+1)/F(t+1) = (1/DKInext) * V(KItemp)/KItemp where
!KItemp=((1-d)*KI+INV)/A(t+1)^RTS

         psiK=psiK0*psiKshock(iZ)
         tempR1=GDPmult*Zgrid(iZ)*(1.0-psiK)*RTS*(K**psiK)
         WageBill=mu0grid(iZ,iZind)*WBi+
     1           (LaborInd-mu0grid(iZ,iZind)*NIlast)*Wage
         if(KInext.lt.0.0.or.LaborInd.lt.0.0.or.
     1      WageBill.gt.WBIgrid(nWBI)) then
          Vnext=-100000.0
          goto 300
         end if
         psiK=psiK0*psiKshock(iZ)*psiKshock2(iZind)
         if(abs(CES).gt..001) then
          Yi=ZIgrid(iZind)*GDPmult*Zgrid(iZ)*
     1      (psiK*(Ki**CES)+
     2       (1.0-psiK)*(LaborInd**(CES*RTS)))**(1.0/CES)-
     2       WageBill-FixedCost*K
         else
          Yi=ZIgrid(iZind)*GDPmult*Zgrid(iZ)*(Ki**psiK)*
     1      (LaborInd**((1.0-psiK)*RTS))-
     1       WageBill-FixedCost*K
         end if
         !if(DIV.gt..99*V(iState,1)) DIV=.99*V(iState,1)
         psiK=psiK0*psiKshock(iZ)
         tempR1=GDPmult*Zgrid(iZ)*(1.0-psiK)*RTS*(K**psiK)
!         SInext=(WageBill/LaborInd)/
!     1          (mu0*mu0shock(iZ)*S*tempR1+(1-mu0*mu0shock(iZ))*Wage)
         WBInext=WageBill

         call findspot(KIgrid,nKi,KInext,iKi,iKInext)
         multKI=(KInext-KIgrid(iKInext))/
     1          (KIgrid(iKInext+1)-KIgrid(iKInext))
         if(multKI.gt.1.0) multKI=1.0
         if(multKI.lt.0.0) multKI=0.0
         call findspot(DKIgrid,nDKI,DKInext,
     1                 nint(.5*real(nDKI)),iDKInext)
         multDKI=(DKInext-DKIgrid(iDKInext))/
     1           (DKIgrid(iDKInext+1)-DKIgrid(iDKInext))
         if(multDKI.lt.0.0) multDKI=0.0
         if(multDKI.gt.1.0) multDKI=1.0

         call findspot(WBIgrid,nWBI,WBInext,
     1                 nint(.5*real(nWBI)),iWBInext)
         multWBI=(WBInext-WBIgrid(iWBInext))/
     1           (WBIgrid(iWBInext+1)-WBIgrid(iWBInext))
         if(multWBI.gt.1.0) multWBI=1.0
         if(multWBI.lt.0.0) multWBI=0.0
         call findspot(NIlastGrid,nNIlast,LaborInd,
     1                 nint(.5*real(nNIlast)),iNIlastNext)
         multNI=(LaborInd-NIlastGrid(iNIlastNext))/
     1          (NIlastGrid(iNIlastNext+1)-NIlastGrid(iNIlastNext))
         if(multNI.gt.1.0) multNI=1.0
         if(multNI.lt.0.0) multNI=0.0

 303     continue

         do jDKI=1,2
         do jWBI=1,2
         do jNI=1,2
          iIndNext=(iDKInext+(jDKI-1)-1)*nWBI*nNIlast*nKI*nZind+
     1             (iWBInext+(jWBI-1)-1)*nNIlast*nKI*nZind+
     1             (iNIlastNext+(jNI-1)-1)*nKI*nZind+
     1             (iKInext-1)*nZind+iZind
          iStateNextL=(iIndNext-1)*nAgg+iAgg
          iStateNextH=(iIndNext+nZind-1)*nAgg+iAgg
          iIndNextND=(1+(jDKI-1)-1)*nWBI*nNIlast*nKI*nZind+
     1               (iWBInext+(jWBI-1)-1)*nNIlast*nKI*nZind+
     1               (iNIlastNext+(jNI-1)-1)*nKI*nZind+
     1               (iKInext-1)*nZind+iZind
          iStateNextLnd=(iIndNextND-1)*nAgg+iAgg
          iStateNextHnd=(iIndNextND+nZind-1)*nAgg+iAgg
!Market value of firm's debt today, given all of the firm's choices. Note that this market value is computed assuming debt can expire as early as next period (no more coupons paid), but for firms issuing new debt will adjust for this below
!          Vdebt3(jDKI,jWBI,jNI)=PriceDebt(iStateNextL,2)+multKI*
!     1              (PriceDebt(iStateNextH,2)-PriceDebt(iStateNextL,2))
          Vdebt3(jDKI,jWBI,jNI)=PriceDebtNextGrid(iStateNextL)+multKI*
     1                         (PriceDebtNextGrid(iStateNextH)-
     1                          PriceDebtNextGrid(iStateNextL))
          VdebtNRP3(jDKI,jWBI,jNI)=
     1        PriceDebtNRPNextGrid(iStateNextL)+multKI*
     1                       (PriceDebtNRPNextGrid(iStateNextH)-
     1                        PriceDebtNRPNextGrid(iStateNextL))
!          dVdebt3(jDKI,jWBI,jNI)=DerivsAllDKi(iStateNextL)+multKI*
!     1                          (DerivsAllDKi(iStateNextH)-
!     1                           DerivsAllDKi(iStateNextL))

!Expected value of firm next period conditional on having the same debt (if debt does not expire)
          call CHFEV(KIgrid(iKInext),KIgrid(iKInext+1),
     1              VnextGrid(iStateNextL),VnextGrid(iStateNextH),
     2              DerivsAllKi(iStateNextL),DerivsAllKi(iStateNextH),
     3              1,KInext,Vtemp,extrap,tempI3)
          if(Vtemp.lt.VnextGrid(iStateNextL).or.
     1       Vtemp.gt.VnextGrid(iStateNextH)) then
           Vtemp=VnextGrid(iStateNextL)+multKI*
     1          (VnextGrid(iStateNextH)-VnextGrid(iStateNextL))
          end if
          Vnext3(jDKI,jWBI,jNI)=Vtemp
!Expected value of firm next period conditional on having zero debt (if debt expires)
          call CHFEV(KIgrid(iKInext),KIgrid(iKInext+1),
     1            VnextGrid(iStateNextLnd),VnextGrid(iStateNextHnd),
     2            DerivsAllKi(iStateNextLnd),DerivsAllKi(iStateNextHnd),
     3            1,KInext,Vtemp,extrap,tempI3)
          if(Vtemp.lt.VnextGrid(iStateNextLnd).or.
     1       Vtemp.gt.VnextGrid(iStateNextHnd)) then
           Vtemp=VnextGrid(iStateNextLnd)+multKI*
     1          (VnextGrid(iStateNextHnd)-VnextGrid(iStateNextLnd))
          end if
          Vnext3nd(jDKI,jWBI,jNI)=Vtemp
         end do
          Vdebt2(jDKI,jWBI)=Vdebt3(jDKI,jWBI,1)+multNI*
     1                     (Vdebt3(jDKI,jWBI,2)-Vdebt3(jDKI,jWBI,1))
          VdebtNRP2(jDKI,jWBI)=VdebtNRP3(jDKI,jWBI,1)+multNI*
     1                  (VdebtNRP3(jDKI,jWBI,2)-VdebtNRP3(jDKI,jWBI,1))
!          dVdebt2(jDKI,jWBI)=dVdebt3(jDKI,jWBI,1)+multNI*
!     1                      (dVdebt3(jDKI,jWBI,2)-dVdebt3(jDKI,jWBI,1))
          Vnext2(jDKI,jWBI)=Vnext3(jDKI,jWBI,1)+multNI*
     1                     (Vnext3(jDKI,jWBI,2)-Vnext3(jDKI,jWBI,1))
          Vnext2nd(jDKI,jWBI)=Vnext3nd(jDKI,jWBI,1)+multNI*
     1                     (Vnext3nd(jDKI,jWBI,2)-Vnext3nd(jDKI,jWBI,1))
         end do
          Vdebt1(jDKI)=Vdebt2(jDKI,1)+multWBI*
     1                (Vdebt2(jDKI,2)-Vdebt2(jDKI,1))
          VdebtNRP1(jDKI)=VdebtNRP2(jDKI,1)+multWBI*
     1                (VdebtNRP2(jDKI,2)-VdebtNRP2(jDKI,1))
!          dVdebt1(jDKI)=dVdebt2(jDKI,1)+multWBI*
!     1                 (dVdebt2(jDKI,2)-dVdebt2(jDKI,1))
          Vnext1(jDKI)=Vnext2(jDKI,1)+multWBI*
     1                (Vnext2(jDKI,2)-Vnext2(jDKI,1))
          Vnext1nd(jDKI)=Vnext2nd(jDKI,1)+multWBI*
     1                (Vnext2nd(jDKI,2)-Vnext2nd(jDKI,1))
         end do
         Vdebt=Vdebt1(1)+multDKI*(Vdebt1(2)-Vdebt1(1))
         VdebtNRP=VdebtNRP1(1)+multDKI*(VdebtNRP1(2)-VdebtNRP1(1))
!         call CHFEV(DKIgrid(iDKInext),DKIgrid(iDKInext+1),
!     1              Vdebt1(1),Vdebt1(2),dVdebt1(1),dVdebt1(2),
!     3              1,DKInext,tempR1,extrap,tempI3)
!         Vdebt=tempR1
         Vnext=Vnext1(1)+multDKI*(Vnext1(2)-Vnext1(1))
         VnextND=Vnext1nd(1)!+0.0*(Vnext1(2)-Vnext1(1)) !note that if firm has no debt then multDKI=0
         if(iDKI.eq.1) then
          EMVnext=Vnext
         else
          EMVnext=Vnext*(1.0-ProbExp)+VnextND*ProbExp
         end if

         if(t.le.TotYearsCur) then
          TaxPaid=CorpTax*(Yi-deltaK*Ki-Interest)
          if(TaxPaid.lt.0.0) TaxPaid=0.0*TaxPaid
!Only firms w/ no debt are allowed to issue new debt. Debt newly issued at t will expire no earlier than at t+2 (firm can still default at t+1)
!Note that PriceDebt(:,1) contains the price of debt which may expire next period w/ probability ProbExp
!However, Vdebt is computed as E[M*(IntNext+PriceDebtNext)] so that Vdebt (stored in policy(:,5)) is the price of debt that does not expire until t+2 at the earliest
!Thus Vdebt is the right price for a firm issuing new debt, however for existing debt the price of debt is Vdebt*(1-ProbExp)
          if(iDKI.eq.1) then
           DIV=Yi-INV-Interest-Costs-TaxPaid+Vdebt
          else
           DIV=Yi-INV-Interest-Costs-TaxPaid
          end if
         end if
         if((EMVnext.le.0.0001.and.DKInext.gt.0.0001).or.
     1      (DIV+EMVnext.lt.0.and.DKInext.gt.0.0001)) EMVnext=-100.0

!      if(iZ.eq.2.and.iK.eq.8.and.iS.eq.3.and.iZind.eq.2.and.
!     1 iNIlast.eq.1.and.iWBI.eq.1.and.iKi.eq.22.and.
!     1 iDKi.eq.2.and.t.eq.1) then
!      if(iC.eq.35.and.iLabor.eq.10.and.iDKIchoice.eq.1) then
!      write(6,'(i5,i5,i5,f8.4,f8.4,f8.4,f8.4,f8.4,f8.4,f8.4,
!     1 f8.4,f8.4,f8.4,f8.4,f8.4)')
!     1 iC,iLabor,iDKIchoice,KI,KInext,WBInext,LaborInd,
!     1 INV,DIV,Vnext,VnextND,DIV+EMVnext,
!     1 Vmax(iState,1),Vdebt
!      end if
!      end if


         Vnext=DIV+EMVnext !here Vnext=E[J^[(1-theta)/(1-rho)]]

 300     continue

         if(Vmax(iState,1).lt.Vnext.or.
     1      Vnext.gt.Vlt0best) then
          Vlt0best=Vnext
          Vmax(iState,1)=Vnext
          Policy(iState,1)=INV
          Policy(iState,2)=LaborInd/LaborIndMPL
          Policy(iState,3)=DKInext
          Policy(iState,5)=Vdebt !note: always recording Vdebt, which is price of debt which cannot expire next period, at t+2 at earliest. to get market price of existing debt multiply by 1-PrEx
          if(Vmax(iState,1).lt.0) then
           Policy(iState,5)=PriceDebt(iState,1)
          end if
          PriceDebtNRP(iState,1)=VdebtNRP
          DKInextBest(iState)=DKInext
          KInextBest(iState)=KInext
          WBInextBest(iState)=WBInext
          iKInextBest(iState)=iKInext
          iWBInextBest(iState)=iWBInext
          iDKInextBest(iState)=iDKInext
          iNInextBest(iState)=iNIlastNext
          multWBiBest(iState)=multWBI
          multKIBest(iState)=multKI
          multNIBest(iState)=multNI
          multDKIBest(iState)=multDKI
          DivBest(iState)=Div
          iLtemp=iLabor
          if(iLabor.eq.1) iLtemp=2
          if(iLabor.eq.nLaborGrid(iC)) iLtemp=nLaborGrid(iC)-1
          if(iC.le.nC) then
           LaborIndBest1=LaborInd
           LaborIndBest2=LaborInd
           LaborIndBest3=LaborInd
           tempR1=.5*(LaborGrid(iLtemp+1,iNIlast)-
     1                LaborGrid(iLtemp-1,iNIlast))
           if(LaborIndBest1.gt..15) then
            LaborInt1=.5*tempR1
            LaborInt2=.25*tempR1
            LaborInt3=.15*tempR1
           else
            LaborInt1=.5*tempR1
            LaborInt2=.25*tempR1
            LaborInt3=.15*tempR1
           end if

           if(iC.gt.1) then
            INVfine(1)=INVgrid0(iC-1,iKi)+
     1             .1*(INVgrid0(iC,iKi)-INVgrid0(iC-1,iKi))
            !if(INVfine(1).lt.0.0) INVfine(1)=0.0
           else
            !INVfine(1)=0.0
            INVfine(1)=-0.9*(1.0-deltaK)*Ki!-2.0*abs(INVgrid0(iC,iKi))
           end if
           if(iC.lt.nC) then
            INVfine(2)=INVgrid0(iC,iKi)+
     1             .9*(INVgrid0(iC+1,iKi)-INVgrid0(iC,iKi))
           else
            INVfine(2)=KIgrid(nKi)-(1.0-deltaK)*KI!INV*3.0
           end if
           if(INVfine(1).gt.INVfine(2)) then    !INV<0
            tempR1=INVfine(1)
            INVfine(1)=INVfine(2)
            INVfine(2)=tempR1
           end if
           INVfine1(1)=.65*INVfine(1)+.35*INVfine(2)
           INVfine1(2)=.35*INVfine(1)+.65*INVfine(2)
           DKIchoice1(1)=DKIchoice(1)*0.5+DKInext*0.5
           DKIchoice1(2)=DKIchoice(2)*0.5+DKInext*0.5
           DKIchoice2(1)=DKIchoice(1)*0.25+DKInext*0.75
           DKIchoice2(2)=DKIchoice(2)*0.25+DKInext*0.75
          end if
          if(iC.gt.nC.and.iC.le.nC+3+nCfine) then
           tempR1=.5*(LaborGrid(iLtemp+1,iNIlast)-
     1                LaborGrid(iLtemp-1,iNIlast))

           DKIchoice2(1)=DKIchoice(1)*0.5+DKInext*0.5
           DKIchoice2(2)=DKIchoice(2)*0.5+DKInext*0.5

           if(iC.le.nC+3) then
            LaborIndBest1=LaborInd
            if(LaborIndBest1.gt..15) then
             LaborInt1=.5*tempR1
             LaborInt2=.25*tempR1
             LaborInt3=.15*tempR1
            else
             LaborInt1=.5*tempR1
             LaborInt2=.25*tempR1
             LaborInt3=.15*tempR1
            end if
            DKIchoice1(1)=DKIchoice(1)*0.5+DKInext*0.5
            DKIchoice1(2)=DKIchoice(2)*0.5+DKInext*0.5
            DKIchoice2(1)=DKIchoice(1)*0.25+DKInext*0.75
            DKIchoice2(2)=DKIchoice(2)*0.25+DKInext*0.75
           end if

           LaborIndBest2=LaborInd
           LaborIndBest3=LaborInd
           if(LaborIndBest2.gt..15) then
            LaborInt2=.25*tempR1
            LaborInt3=.15*tempR1
           else
            LaborInt2=.25*tempR1
            LaborInt3=.15*tempR1
           end if
           if(iC.eq.nC+1.or.iC.eq.nC+2.or.iC.eq.nC+3) then
            INVfine(1)=INV*.9
            INVfine(2)=INV*1.1
            INVfine1(1)=INV*.95
            INVfine1(2)=INV*1.05
            if(INV.lt.0.and.INV*1.1.lt.-(1.0-deltaK)*KI*.9) then
             INVfine(1)=-(1.0-deltaK)*KI*.9
             INVfine1(1)=-(1.0-deltaK)*KI*.9
            end if
            if(INV.lt.0.0.and.INV.lt.INVgrid0(3,iKi)) then
             INVfine(1)=INV*1.5
             INVfine(2)=INV*.75
             INVfine1(1)=INV*1.25
             INVfine1(2)=INV*.9
             if(INV*1.5.lt.-(1.0-deltaK)*KI) then
              INVfine(1)=-(1.0-deltaK)*KI*.9
              INVfine1(1)=-(1.0-deltaK)*KI*.9
             end if
            end if
            if(INV.gt.0.0.and.INV.gt.INVgrid0(nC-3,iKi))then
             INVfine(1)=INV*.75
             INVfine(2)=INV*1.5
             INVfine1(1)=INV*.9
             INVfine1(2)=INV*1.25
            end if
            tempR1=abs(INVgrid0(2,iKi)-INVgrid0(1,iKi))
            if(abs(INVfine(1)-INVfine(2)).lt..8*tempR1) then
             tempR2=.5*(INVfine(1)+INVfine(2))
             INVfine(1)=tempR2-.4*tempR1
             INVfine(2)=tempR2+.4*tempR1
            end if
            if(abs(INVfine1(1)-INVfine(2)).lt..4*tempR1) then
             tempR2=.5*(INVfine1(1)+INVfine1(2))
             INVfine1(1)=tempR2-.2*tempR1
             INVfine1(2)=tempR2+.2*tempR1
            end if
           else
            INVfine1(1)=INVfine(1)+(INVfine(2)-INVfine(1))*
     1                  real(iC-(nC+3)-1-0.9)/real(nCfine-1)
            INVfine1(2)=INVfine(1)+(INVfine(2)-INVfine(1))*
     1                  real(iC-(nC+3)-1+0.9)/real(nCfine-1)
           end if
           if(INVfine1(1).gt.INVfine1(2)) then    !INV<0
            tempR1=INVfine1(1)
            INVfine1(1)=INVfine1(2)
            INVfine1(2)=tempR1
           end if
           !if(INVfine1(1).lt.0.0) INVfine1(1)=0.0
           if(INVfine1(1).lt.-.9*(1.0-deltaK)*KI)        !INV<0
     1        INVfine1(1)=-.9*(1.0-deltaK)*KI
           if(INVfine1(2).gt.INVfine(2)) then
            if(INVfine(2).gt.0.0) then
             INVfine1(2)=3.0*INVfine(2)
            else
             INVfine1(2)=0.0
            end if
           end if
          end if
          if(iC.gt.nC+3+nCfine.and.iC.le.nC+3+nCfine+nCfine1) then
           tempR1=.5*(LaborGrid(iLtemp+1,iNIlast)-
     1                LaborGrid(iLtemp-1,iNIlast))
           LaborIndBest3=LaborInd
           if(LaborIndBest3.gt..15) then
            LaborInt3=.15*tempR1
           else
            LaborInt3=.15*tempR1
           end if
          end if
         end if

 301     continue

        end do   !iDKIchoice
        end do   !iLabor
        end do   !iC

      if(t.le.TotYearsCur.or.t.eq.TotYearsCur+TotYearsV.or.
     1 mod(t,20).eq.-1) then
      if(iZ.eq.2.and.iK.eq.8.and.iS.eq.3.and.iZind.eq.2.and.
     1 iNIlast.eq.5.and.iWBI.eq.4.and.iKi.eq.22.and.
     1 iDKi.ge.1) then
      write(6,'(i4,i11,i7,i4,i4,i4,i4,i4,f8.4,f8.4,f8.4,f8.4,
     1 f8.4,f11.5,f8.4)')
     1 t,istate,iAgg,iKi,iWBi,iNIlast,iDKi,iZind,
     1 policy(istate,1),policy(istate,2),policy(istate,3),
     1 policy(istate,4),policy(istate,5),vmax(istate,1),
     1 pricedebt(istate,1)
      end if
      end if


       end do  !iNI
       end do !iZind
       end do !iKi
       end do !iWBi
       end do !iDKi
      end do !iAgg

c$omp end do
c$omp end parallel


      do i=1,nState
       V(i,1)=Vmax(i,1)
       Policy(i,4)=0.0
       if(V(i,1).lt.0.0) V(i,1)=0.0
       if(V(i,1).lt.0.0001) then
        Policy(i,4)=1.0
        Policy(i,3)=0.0
       end if
      end do

      end do !end t

      if(mod(iIter,5).eq.0) then
!       call writedata(Policy,'policy.txt',nState,5,nState,5)
!       call writedata(V,'valueF.txt',nState,1,nState,1)
      end if
      call writedatabinary(V,'valueF.dat',nState,1)
      call writedatabinary(Policy,'policy.dat',nState,5)


      do t=1,TotYearsV

!This computes the price of a long term coupon bond without default risk. The price computed below entitles holder to a security that pays 1.0 every period until expiry
!Expiry occurs w/ probability ProbExp and can occur in any period including the first one (ie no coupons paid at all)
      do iAgg=1,nAgg!
       iZ=mod(iAgg-1,nZagg)+1
       tempI1=1+(iAgg-iZ)/nZagg
       iK=mod(tempI1-1,nK)+1
       iS=1+(tempI1-iK)/nK
      do iDKI=1,nDKI
       iState=(iDKI-1)*nAgg+iAgg

       EpriceDebt=0
       do iZnext=1,nZagg
       do iZSRnext=1,nZsr
        TrProb=TrProbAgg(iZ,iZnext)*TrProbAggSR(iZSRnext)
!Use below for iZSRnext perfectly correlated with iZnext (this is the process we have previously used)
!        if(iZSRnext.eq.iZnext) then
!         TrProb=TrProbAgg(iZ,iZnext)
!        else
!         TrProb=0.0
!        end if
        SDFtemp=SDF((iAgg-1)*nZagg*nZsr+(iZnext-1)*nZsr+iZSRnext,1)
        Knext=KnextGrid(iAgg,iZSRnext)
        Snext=SnextGrid(iAgg,iZSRnext)
        iKnext=KspotGrid(iAgg,iZSRnext)
        iSnext=SspotGrid(iAgg,iZSRnext)
        multK=KmultGrid(iAgg,iZSRnext)
        multS=SmultGrid(iAgg,iZSRnext)
        DKItemp=DKIgrid(iDKI)/(Agrid(iZ,iZSRnext)**RTS)
        call findspot(DKIgrid,nDKI,DKItemp,iDKI,iDKItemp)
        multDKI=(DKItemp-DKIgrid(iDKItemp))/
     1          (DKIgrid(iDKItemp+1)-DKIgrid(iDKItemp))
        if(multDKI.lt.0.0) multDKI=0.0
        if(multDKI.gt.multDKImax) multDKI=multDKImax
        InterestNext=DKItemp

        do jS=1,2
        do jK=1,2
         iAggNext=(iSnext+(jS-1)-1)*nK*nZagg+
     1            (iKnext+(jK-1)-1)*nZagg+iZnext
        do jDKI=1,2
         tempI1=(iDKItemp+(jDKI-1)-1)*nAgg+iAggNext
         Vdebt3(jS,jK,jDKI)=PriceDebtRF(tempI1,1)
        end do
         Vdebt2(jS,jK)=Vdebt3(jS,jK,1)+multDKI*
     1                (Vdebt3(jS,jK,2)-Vdebt3(jS,jK,1))
        end do
         Vdebt1(jS)=Vdebt2(jS,1)+multK*(Vdebt2(jS,2)-Vdebt2(jS,1))
        end do
        PriceDebtNext=Vdebt1(1)+multS*(Vdebt1(2)-Vdebt1(1))
        EpriceDebt=EpriceDebt+TrProb*SDFtemp*(Agrid(iZ,iZSRnext)**RTS)*
     1            (InterestNext+PriceDebtNext)
       end do !iZnext
       PriceDebtRF0(iState,1)=(1.0-ProbExp)*EpriceDebt
      end do !iZSRnext
      end do !iZnext
      end do  !iAgg

      do iAgg=1,nAgg
      do iDKI=1,nDKI
       iState=(iDKI-1)*nAgg+iAgg
       PriceDebtRF(iState,1)=PriceDebtRF0(iState,1)
      end do
      end do
      
c$omp parallel
c$omp& default(none)
c$omp& shared(iAgg,nAgg,nZagg,nK,nS,nDKi,nWBi,nNIlast,nZind,nKi,
c$omp& PriceDebt,DerivsAllDKi,DKIgrid,t)
c$omp& private(iZ,iK,iS,iKi,iWBI,iNIlast,iZind,iDKI,iInd,iState,
c$omp& VtempDKI,DtempDKi,tempI1,tempI2,DKI,multDKI,extrap,
c$omp& tempR1,tempR2,tempI3)
c$omp do

      do iAgg=1,nAgg
       iZ=mod(iAgg-1,nZagg)+1
       tempI1=1+(iAgg-iZ)/nZagg
       iK=mod(tempI1-1,nK)+1
       iS=1+(tempI1-iK)/nK
       do iKI=1,nKI
       do iWBI=1,nWBI
       do iNIlast=1,nNIlast
       do iZind=1,nZind
        do iDKi=1,nDKi
         iInd=(iDKi-1)*nWBI*nNIlast*nKI*nZind+
     1        (iWBi-1)*nNIlast*nKI*nZind+
     1        (iNIlast-1)*nKI*nZind+(iKi-1)*nZind+iZind
         iState=(iInd-1)*nAgg+iAgg
         VtempDKi(iDKi)=PriceDebt(iState,1)
        end do
        tempI1=1
        tempI2=0
        call PCHIM(nDKi,DKIgrid,VtempDKi,DtempDKi,tempI1,tempI2)
        do iDKi=1,nDKi
         iInd=(iDKi-1)*nWBI*nNIlast*nKI*nZind+
     1        (iWBi-1)*nNIlast*nKI*nZind+
     1        (iNIlast-1)*nKI*nZind+(iKi-1)*nZind+iZind
         iState=(iInd-1)*nAgg+iAgg
         DerivsAllDKi(iState)=DtempDKi(iDKi)
        end do
       end do
       end do
       end do
       end do
      end do

c$omp end do
c$omp end parallel
      

c$omp parallel
c$omp& default(none)
c$omp& shared(iAgg,nAgg,nZagg,nK,nS,nDKi,nWBi,nNIlast,nZind,nKi,KIgrid,
c$omp& WBIgrid,NIlastGrid,Kgrid,Sgrid,DKIgrid,Agrid,TrProbAgg,TrProbInd,
c$omp& V,SDF,PriceDebt,PriceDebt0,Policy,GDPmult,RTS,ProbExp,RecRate,
c$omp& KnextGrid,SnextGrid,KspotGrid,SspotGrid,KmultGrid,SmultGrid,t,
c$omp& KInextBest,WBInextBest,iNInextBest,multNIBest,PriceDebtRF,
c$omp& multDKImax,nZsr,TrProbAggSR,DerivsAllDKi)
c$omp& private(iZ,iK,iS,iDKI,iZind,iKInext,iNIlastNext,iInd,iState,
c$omp& iZnext,NIlastNext,Knext,Snext,TrProb,
c$omp& KItemp,DKItemp,KIdef,WBItemp,iKItemp,iKiDef,iWBInext,iWBItemp,
c$omp& iKnext,iDKItemp,iKI,iWBI,iNIlast,iZSRnext,
c$omp& iSnext,iAggNext,iIndNext,iStateNext,iIndNextDef,iStateNextDef,
c$omp& multWBI,multKI,multKIdef,multDKI,multNI,multS,multK,
c$omp& jK,jS,jKI,jWBI,jDKI,jNI,Def1,Def2,Def3,Def4,Def5,Def6,Vdef1,
c$omp& Def,Vdef2,Vdef3,Vdef4,Vdef5,Vdef6,Vdef,Vdebt1,Vdebt2,
c$omp& Vdebt3,Vdebt4,Vdebt5,Vdebt6,Vnext,Vnext1,Vnext2,Vnext3,Vnext4,
c$omp& dVdebt6,dVdebt5,dVdebt4,dVdebt3,dVdebt2,dVdebt1,tempI3,
c$omp& Vnext5,Vnext6,EpriceDebt,SDFtemp,Interest,extrap,tempR1,
c$omp& InterestNext,PriceDebtNext,tempi1,iStateNextL,iStateNextH)
c$omp do

      do iAgg=1,nAgg!

       iZ=mod(iAgg-1,nZagg)+1
       tempI1=1+(iAgg-iZ)/nZagg
       iK=mod(tempI1-1,nK)+1
       iS=1+(tempI1-iK)/nK
       !iAgg=((iS-1)*nK+iK-1)*nZagg+iZ

       do iZind=1,nZind
       do iWBI=1,nWBi
       do iKI=1,nKi
       do iNIlast=1,nNIlast
       do iDKI=1,nDKI

        iInd=(iDKI-1)*nWBI*nNIlast*nKI*nZind+
     1       (iWBI-1)*nNIlast*nKI*nZind+
     1       (iNIlast-1)*nKI*nZind+(iKI-1)*nZind+iZind
        iState=(iInd-1)*nAgg+iAgg

        EpriceDebt=0
        do iZnext=1,nZagg
        do iZSRnext=1,nZsr
         SDFtemp=SDF((iAgg-1)*nZagg*nZsr+(iZnext-1)*nZsr+iZSRnext,1)
         Knext=KnextGrid(iAgg,iZSRnext)
         Snext=SnextGrid(iAgg,iZSRnext)
         iKnext=KspotGrid(iAgg,iZSRnext)
         iSnext=SspotGrid(iAgg,iZSRnext)
         multK=KmultGrid(iAgg,iZSRnext)
         multS=SmultGrid(iAgg,iZSRnext)

         DKItemp=DKIgrid(iDKI)/(Agrid(iZ,iZSRnext)**RTS)
         call findspot(DKIgrid,nDKI,DKItemp,iDKI,iDKItemp)
         multDKI=(DKItemp-DKIgrid(iDKItemp))/
     1           (DKIgrid(iDKItemp+1)-DKIgrid(iDKItemp))
         if(multDKI.lt.0.0) multDKI=0.0
         if(multDKI.gt.multDKImax) multDKI=multDKImax
         InterestNext=DKItemp

         WBItemp=WBInextBest(iState)/(Agrid(iZ,iZSRnext)**RTS)
         call findspot(WBIgrid,nWBI,WBItemp,iWBI,iWBItemp)
         multWBI=(WBItemp-WBIgrid(iWBItemp))/
     1           (WBIgrid(iWBItemp+1)-WBIgrid(iWBItemp))
         if(multWBI.lt.0.0) multWBI=0.0
         !if(multWBI.lt.1.0) multWBI=1.0

         KItemp=KInextBest(iState)/(Agrid(iZ,iZSRnext)**RTS)
         call findspot(KIgrid,nKI,KItemp,iKI,iKItemp)
         multKI=(KItemp-KIgrid(iKItemp))/
     1          (KIgrid(iKItemp+1)-KIgrid(iKItemp))
         if(multKI.lt.0.0) multKI=0.0
         if(multKI.gt.1.0) multKI=1.0

         KIdef=RecRate*KItemp
         call findspot(KIgrid,nKI,KIdef,iKItemp,iKIdef)
         multKIdef=(KIdef-KIgrid(iKiDef))/
     1             (KIgrid(iKiDef+1)-KIgrid(iKiDef))
         if(multKIdef.lt.0.0) multKIdef=0.0
         if(multKIdef.gt.1.0) multKIdef=1.0

         iNIlastNext=iNInextBest(iState) !Note that NI is stationary so no need to normailze by A^RTS
         multNI=multNIBest(iState)

        do iZindNext=1,nZind
         TrProb=TrProbAgg(iZ,iZnext)*TrProbAggSR(iZSRnext)*
     1          TrProbInd(iZind,iZindNext)
!Use below for iZSRnext perfectly correlated with iZnext (this is the process we have previously used)
!         if(iZSRnext.eq.iZnext) then
!          TrProb=TrProbAgg(iZ,iZnext)*TrProbInd(iZind,iZindNext)
!         else
!          TrProb=0.0
!         end if
         if(TrProb.lt..0001) goto 1817

         do jDKI=1,2
         do jS=1,2
         do jK=1,2
          iAggNext=(iSnext+(jS-1)-1)*nK*nZagg+
     1             (iKnext+(jK-1)-1)*nZagg+iZnext
         do jWBI=1,2
         do jKI=1,2
         do jNI=1,2
!no need to interpolate over NIlastNext because already at those gridpoints
!interpolating over KInext and WBInext only because shock implies dividing by A^RTS, thus next period's value not at gridpoint

          iIndNext=(iDKItemp+(jDKI-1)-1)*nWBI*nNIlast*nKI*nZind+
     1             (iWBItemp+(jWBI-1)-1)*nNIlast*nKI*nZind+
     1             (iNIlastNext+(jNI-1)-1)*nKI*nZind+
     1             (iKItemp+(jKI-1)-1)*nZind+iZindNext
          iStateNext=(iIndNext-1)*nAgg+iAggNext
          iIndNextDef=(1+(jDKI-1)-1)*nWBI*nNIlast*nKI*nZind+
     1                (iWBItemp+(jWBI-1)-1)*nNIlast*nKI*nZind+
     1                (iNIlastNext+(jNI-1)-1)*nKI*nZind+
     1                (iKiDef+(jKI-1)-1)*nZind+iZindNext
          iStateNextDef=(iIndNextDef-1)*nAgg+iAggNext

          Def6(jDKI,jS,jK,jWBI,jKI,jNI)=Policy(iStateNext,4)
          Vdebt6(jDKI,jS,jK,jWBI,jKI,jNI)=PriceDebt(iStateNext,1)
          dVdebt6(jDKI,jS,jK,jWBI,jKI,jNI)=DerivsAllDKi(iStateNext)
          Vdef6(jDKI,jS,jK,jWBI,jKI,jNI)=V(iStateNextDef,1)
          Vnext6(jDKI,jS,jK,jWBI,jKI,jNI)=V(iStateNext,1)
         end do
          Def5(jDKI,jS,jK,jWBI,jKI)=
     1        Def6(jDKI,jS,jK,jWBI,jKI,1)+multNI*
     1       (Def6(jDKI,jS,jK,jWBI,jKI,2)-Def6(jDKI,jS,jK,jWBI,jKI,1))
          Vdebt5(jDKI,jS,jK,jWBI,jKI)=
     1      Vdebt6(jDKI,jS,jK,jWBI,jKI,1)+multNI*
     1     (Vdebt6(jDKI,jS,jK,jWBI,jKI,2)-Vdebt6(jDKI,jS,jK,jWBI,jKI,1))
          dVdebt5(jDKI,jS,jK,jWBI,jKI)=
     1    dVdebt6(jDKI,jS,jK,jWBI,jKI,1)+multNI*
     1   (dVdebt6(jDKI,jS,jK,jWBI,jKI,2)-dVdebt6(jDKI,jS,jK,jWBI,jKI,1))
          Vnext5(jDKI,jS,jK,jWBI,jKI)=
     1      Vnext6(jDKI,jS,jK,jWBI,jKI,1)+multNI*
     1     (Vnext6(jDKI,jS,jK,jWBI,jKI,2)-Vnext6(jDKI,jS,jK,jWBI,jKI,1))
          Vdef5(jDKI,jS,jK,jWBI,jKI)=
     1      Vdef6(jDKI,jS,jK,jWBI,jKI,1)+multNI*
     1     (Vdef6(jDKI,jS,jK,jWBI,jKI,2)-Vdef6(jDKI,jS,jK,jWBI,jKI,1))
         end do
          Def4(jDKI,jS,jK,jWBI)=Def5(jDKI,jS,jK,jWBI,1)+multKI*
     1           (Def5(jDKI,jS,jK,jWBI,2)-Def5(jDKI,jS,jK,jWBI,1))
          Vdebt4(jDKI,jS,jK,jWBI)=Vdebt5(jDKI,jS,jK,jWBI,1)+multKI*
     1           (Vdebt5(jDKI,jS,jK,jWBI,2)-Vdebt5(jDKI,jS,jK,jWBI,1))
          dVdebt4(jDKI,jS,jK,jWBI)=dVdebt5(jDKI,jS,jK,jWBI,1)+multKI*
     1           (dVdebt5(jDKI,jS,jK,jWBI,2)-dVdebt5(jDKI,jS,jK,jWBI,1))
          Vnext4(jDKI,jS,jK,jWBI)=Vnext5(jDKI,jS,jK,jWBI,1)+multKI*
     1           (Vnext5(jDKI,jS,jK,jWBI,2)-Vnext5(jDKI,jS,jK,jWBI,1))
          Vdef4(jDKI,jS,jK,jWBI)=Vdef5(jDKI,jS,jK,jWBI,1)+multKIdef*
     1           (Vdef5(jDKI,jS,jK,jWBI,2)-Vdef5(jDKI,jS,jK,jWBI,1))
         end do
          Def3(jDKI,jS,jK)=Def4(jDKI,jS,jK,1)+multWBI*
     1        (Def4(jDKI,jS,jK,2)-Def4(jDKI,jS,jK,1))
          Vdebt3(jDKI,jS,jK)=Vdebt4(jDKI,jS,jK,1)+multWBI*
     1        (Vdebt4(jDKI,jS,jK,2)-Vdebt4(jDKI,jS,jK,1))
          dVdebt3(jDKI,jS,jK)=dVdebt4(jDKI,jS,jK,1)+multWBI*
     1        (dVdebt4(jDKI,jS,jK,2)-dVdebt4(jDKI,jS,jK,1))
          Vnext3(jDKI,jS,jK)=Vnext4(jDKI,jS,jK,1)+multWBI*
     1        (Vnext4(jDKI,jS,jK,2)-Vnext4(jDKI,jS,jK,1))
          Vdef3(jDKI,jS,jK)=Vdef4(jDKI,jS,jK,1)+multWBI*
     1        (Vdef4(jDKI,jS,jK,2)-Vdef4(jDKI,jS,jK,1))
         end do
          Def2(jDKI,jS)=Def3(jDKI,jS,1)+multK*
     1                 (Def3(jDKI,jS,2)-Def3(jDKI,jS,1))
          Vdebt2(jDKI,jS)=Vdebt3(jDKI,jS,1)+multK*
     1                 (Vdebt3(jDKI,jS,2)-Vdebt3(jDKI,jS,1))
          dVdebt2(jDKI,jS)=dVdebt3(jDKI,jS,1)+multK*
     1                 (dVdebt3(jDKI,jS,2)-dVdebt3(jDKI,jS,1))
          Vnext2(jDKI,jS)=Vnext3(jDKI,jS,1)+multK*
     1                 (Vnext3(jDKI,jS,2)-Vnext3(jDKI,jS,1))
          Vdef2(jDKI,jS)=Vdef3(jDKI,jS,1)+multK*
     1                 (Vdef3(jDKI,jS,2)-Vdef3(jDKI,jS,1))
         end do
          Def1(jDKI)=Def2(jDKI,1)+multS*(Def2(jDKI,2)-Def2(jDKI,1))
          Vdebt1(jDKI)=Vdebt2(jDKI,1)+multS*
     1                (Vdebt2(jDKI,2)-Vdebt2(jDKI,1))
          dVdebt1(jDKI)=dVdebt2(jDKI,1)+multS*
     1                (dVdebt2(jDKI,2)-dVdebt2(jDKI,1))
          Vnext1(jDKI)=Vnext2(jDKI,1)+multS*
     1                (Vnext2(jDKI,2)-Vnext2(jDKI,1))
          Vdef1(jDKI)=Vdef2(jDKI,1)+multS*(Vdef2(jDKI,2)-Vdef2(jDKI,1))
         end do

         Vnext=Vnext1(1)+multDKI*(Vnext1(2)-Vnext1(1))
         Def=Def1(1)+multDKI*(Def1(2)-Def1(1))
         if(Vnext.lt..0001) Def=1.0
         if(Def.lt.0.5) then
          call CHFEV(DKIgrid(iDKItemp),DKIgrid(iDKItemp+1),
     1               Vdebt1(1),Vdebt1(2),
     2               dVdebt1(1),dVdebt1(2),
     3               1,DKItemp,tempR1,extrap,tempI3)
          PriceDebtNext=tempR1
          !PriceDebtNext=Vdebt1(1)+multDKI*(Vdebt1(2)-Vdebt1(1))
          if(PriceDebtNext.lt.0) PriceDebtNext=0
          EpriceDebt=EpriceDebt+TrProb*SDFtemp*
     1              (Agrid(iZ,iZSRnext)**RTS)*
     1              (InterestNext+PriceDebtNext) !PriceDebt is the price of an asset that definitely pays interest next period, and after that with probability 1-ProbExp unless the debt defaults
         else
          Vdef=Vdef1(1)!+multDKI*(Vdef1(2)-Vdef1(1))
          if(Vdef.lt.0) Vdef=0
          EpriceDebt=EpriceDebt+TrProb*SDFtemp*
     1              (Agrid(iZ,iZSRnext)**RTS)*Vdef
          Vnext=0
         end if

 1817    continue
        end do !iZindNext
        end do !iZSRnext
        end do !iZnext

        PriceDebt0(iState,1)=(1.0-ProbExp)*EpriceDebt !note that we are defining PriceDebt to be the ex-dividend price
        if(policy(istate,4).gt.0.5.or.V(istate,1).lt.0.00001) then
         KIdef=RecRate*KIgrid(iKi)
         call findspot(KIgrid,nKI,KIdef,iKI,iKIdef)
         multKIdef=(KIdef-KIgrid(iKiDef))/
     1             (KIgrid(iKiDef+1)-KIgrid(iKiDef))
         if(multKIdef.lt.0.0) multKIdef=0.0
         if(multKIdef.gt.1.0) multKIdef=1.0
         iIndNext=(1-1)*nWBI*nNIlast*nKI*nZind+
     1        (iWBI-1)*nNIlast*nKI*nZind+
     1        (iNIlast-1)*nKI*nZind+
     1        (iKIdef-1)*nZind+iZind
         iStateNextL=(iIndNext-1)*nAgg+iAgg
         iStateNextH=(iIndNext+nZind-1)*nAgg+iAgg
         PriceDebt0(iState,1)=V(iStateNextL,1)+multKIdef*
     1        (V(iStateNextH,1)-V(iStateNextL,1))-DKIgrid(iDKI)
         if(PriceDebt0(iState,1).lt.0.0) PriceDebt0(iState,1)=0.0
        end if

        if(PriceDebt0(iState,1).gt.
     1     PriceDebtRF((iDKI-1)*nAgg+iAgg,1)) then
         PriceDebt0(iState,1)=PriceDebtRF((iDKI-1)*nAgg+iAgg,1)
        end if

      if(iZ.eq.2.and.iK.eq.8.and.iS.eq.3.and.iZind.eq.2.and.
     1 iNIlast.eq.5.and.iWBI.eq.5.and.iKI.eq.22.and.
     1 iDKi.ge.1.and.mod(t,20).eq.0) then
      write(6,'(i4,i3,f10.4,f10.4,f10.4)')
     1 t,iDKI,EpriceDebt,PriceDebt0(iState,1),
     1 PriceDebtRF((iDKI-1)*nAgg+iAgg,1)
      end if

       end do
       end do
       end do
       end do
       end do
      end do !iAgg

c$omp end do
c$omp end parallel

      do iState=1,nAgg*nInd
       PriceDebt(iState,1)=PriceDebt0(iState,1)
      end do

      end do !t

      if(mod(iIter,5).eq.0) then
!       call writedata(PriceDebt,'PrcDbt.txt',nAgg*nInd,1,nAgg*nInd,1)
      end if
      call writedatabinary(PriceDebt,'PrcDbt.dat',nAgg*nInd,1)
      call writedatabinary(PriceDebtNRP,'PrcDNR.dat',nAgg*nInd,1)
      call writedata(PriceDebtRF,'PrcDRF.txt',nAgg*nDKI,1,nAgg*nDKI,1)

      end

!-------------------------------------------------------------------
!-------------------------------------------------------------------
!-------------------------------------------------------------------

      SUBROUTINE simulate(nKI,nK,nS,nZagg,nZsr,nZind,nNIlast,nWBI,nDKI,
     1           deltaKfree,psiKshock,psiKshock2,mu0shock,mu0shock2,
     1           GDPmult,Ngrid,iZlastGrid,nIter,RecRate,CorpTax,
     1           ProbExp)
      USE IFPORT
      implicit none
      integer nKI,nWBI,nDKI,nNIlast,nK,nS,nZagg,nZsr,nZind,nFirms
      integer TotYears0,TotYearsHPF,TotYears1,TotYears2,TotYears,nIter
      parameter(TotYears0=2000,TotYears1=6000,TotYears2=3)
      parameter(nFirms=10000)
      integer i,j,t,iK,iZ,iZlast,iAgg,iZnext,iKnext,iKI,iS,iSnext,iAgg1
      integer iLLL,iLHL,iLLH,iLHH,iHLL,iHHL,iHLH,iHHH,iLL,iLH,iHL,iHH
      integer iIter,nAgg,nInd,iKlast,iInd,burn,iDKI
      integer iZlastGrid(nZagg)
      real TrProbAggSR(nZsr),TrProbAggSRcum(nZsr),psiKshock2(nZind)
      real WBIgrid(nWBI),NIlastGrid(nNIlast),DKIgrid(nDKI)
      real KindInit0(nFirms,300),NIlastInit0(nFirms,300)
      real WBindInit0(nFirms,300),DKindInit0(nFirms,300)
      real KaggInit0(300),SaggInit0(300)
      integer iZaggInit0(300),iZindInit0(nFirms,300)
      integer iNIlast(nFirms)
      integer iKind(nFirms),iZind(nFirms),iZindNext(nFirms)
      integer iZindLast(nFirms),iWBind(nFirms),iDKind(nFirms)
      real NIlast(nFirms),NIlastNext(nFirms),DKindNext(nFirms)
      real WBind(nFirms),WBindNext(nFirms),WBindLast(nFirms)
      real IndexInit(nK*nS*nZagg,3),Ngrid(nZagg),DKind(nFirms)
      real NIlastLast(nFirms),mu0shock(nZagg),mu0shock2(nZind)
      real S,Snext,Slast,xi,psiKshock(nZagg),mu0grid(nZagg,nZind)
      real KIgrid(nKI),Kgrid(nK),Agrid(nZagg,nZsr),Zgrid(nZagg)
      real TrProbAgg(nZagg,nZagg),TrProbAggCum(nZagg,nZagg),deltaKfree
      real TrProbInd(nZind,nZind),ZIgrid(nZind),Sgrid(nS),TaxPaidTot
      real TrProbIndCum(nZind,nZind),INVindLast(nFirms),RecRate,CorpTax
      real beta1,theta,eis,deltaK,psiK,psiKnext,psiK0,v1P,v1N,growth,wo
      real K,Y,INV,INVlast,C,Knext,rho,Wage,WageBill,WageMin,WageMax
      real Kind(nFirms),KindNext(nFirms),Yind(nFirms),KiBar
      real YindLast(nFirms),FixedCostMultInd(nFirms),FixedCost
      integer YtempINT(10000,1)
      real DIVind(nFirms),DIVindLast(nFirms),INVind(nFirms),LaborIndMPL
      real LABORind(nFirms),WAGEBILLind(nFirms)
      real DKindLast(nFirms),DKindPromised(nFirms)
      real Labor,Zind(nFirms),ZIshock(nFirms),ProfitGross,ProfitOper
      real output1(TotYears1,25),output1HPF(1000,25),output4HPF(1000,25)
      real outputRatios(TotYears1,25),TaxPaidInd(nFirms)
      real output2(TotYears2*nIter,26),output4(TotYears1,25)
      real Slm,Klm,R2c,R2w,R2i,R2y,R2cNoS,R2wNoS,R2iNoS,R2yNoS,ProbExp
      real CnoS,WnoS,YnoS,InoS,DebtTotal
      real meanCnoS(nZagg*nK*nS,1),meanWnoS(nZagg*nK*nS,1)
      real meanInoS(nZagg*nK*nS,1),meanYnoS(nZagg*nK*nS,1)
      real RFgrid(nK*nS*nZagg,1)
      real tempR1,tempR2,tempR3,tempR4,tempR5,tempR6,tempR7,tempR8
      real tempR9,tempR10,tempR11,tempR12,tempR13,tempR14,tempR15
      real tempR16,tempR17,tempR18,tempR19,tempR20
      double precision tempF1,tempF2,tempF3,tempF4,tempF5,tempF6
      double precision tempF7,tempF8,tempF9,tempF10,tempF11,tempF12
      double precision tempF13,tempF14,tempF15,tempF16,tempF17,tempF18
      double precision tempF19,tempF20,tempF21
      real sigmaY,sigmaDY,sigmaC,sigmaI
      integer tempI1,tempI2,tempI3,tempI4,tempI5,tempI6,tempI7,tempI8
      integer tempI9,tempI10,tempI11,tempI12
      integer iKtemp,iStemp,iZtemp,countFlag,InitCount
      real Policy(nK*nS*nZagg*nDKI*nKI*nWBI*nNILast*nZind,5)
      real PriceDebtNRP(nK*nS*nZagg*nDKI*nKI*nWBI*nNILast*nZind,1)
      real Zshock(TotYears0+TotYears1+(nIter-1)*TotYears2)
      real V(nK*nS*nZagg*nDKI*nKI*nWBI*nNILast*nZind,1)
      real DerivsVF(nK*nS*nZagg*nDKI*nKI*nWBI*nNILast*nZind)
      real DerivsPD(nK*nS*nZagg*nDKI*nKI*nWBI*nNILast*nZind)
      real DerivsPDNRP(nK*nS*nZagg*nDKI*nKI*nWBI*nNILast*nZind)
      real multK,multS,errF,LaborSupply
      real Klast,Clast,LaborDemand,LaborDemandLast
      real CregC(nK*nS*nZagg,500),CregK(nK*nS*nZagg,500)
      real CregS(nK*nS*nZagg,500),CregY(nK*nS*nZagg,500)
      real CregW(nK*nS*nZagg,500),CregI(nK*nS*nZagg,500)
      real CregS3(nK*nZagg,500),CregY3(nK*nZagg,500)
      real CregC3(nK*nZagg,500),CregK3(nK*nZagg,500)
      real CregW3(nK*nZagg,500),CregI3(nK*nZagg,500),extY3(nK*nZagg,2)
      real extC3(nK*nZagg,2),extW3(nK*nZagg,2),extI3(nK*nZagg,2)
      real SDF,Vnext,CostsInd(nFirms),TFPnext,TFPlast,TFPgr,TFPgrnext
      real DerivsVk(nK*nS*nZagg),DerivsEVTk(nK*nS*nZagg),FixedCostTot
      real VtempK(nK),DtempK(nK),VtempF(nKI),DtempF(nKI)
      real VtempFdk(nDKI),DtempFdk(nDKI)
      real X,Q,DIV,Xlast,Qlast,DIVlast,Rf,TFP,ValAll,ValAllLast,Rk,err
      real EVTsdf(nK*nS*nZagg,1),Vsdf(nK*nS*nZagg,1),CostsTot
      real KindLast(nFirms)
      real meanc(nZagg*nK*nS,3),meancOld(nZagg*nK*nS,3)
      real meanI(nZagg*nK*nS,3),meanIOld(nZagg*nK*nS,3)
      real meanItemp(nZagg*nK*nS,3)
      real meanY(nZagg*nK*nS,3),meanYOld(nZagg*nK*nS,3)
      real meanYtemp(nZagg*nK*nS,3)
      real meanCtemp(nZagg*nK*nS,3),RFlast,CostDefault
      real meanW(nZagg*nK*nS,3),meanWold(nZagg*nK*nS,3)
      real ConvW,ConvC,ConvWn,ConvCn
      real meanWtemp(nZagg*nK*nS,3),LaborIndMult(nFirms)
      double precision EVTsdfDouble(nK*nS*nZagg,1)
      double precision VsdfDouble(nK*nS*nZagg,1),Vtemp
      double precision tempMultV,tempMultEVT,EVT,EVTlast,VtempL,VtempH
      double precision Val(nFirms),ValLast(nFirms)
      real outshort1(TotYears1,1),outshort2(TotYears1,1)
      real outshort3(TotYears1,1),outshort4(TotYears1,1)
      real Ytemp(10000,1),Xtemp(10000,5),coefs(5),coefs1(5)
      real BC0(nZagg),BC1(nZagg),BC2(nZagg),AvgI,AvgY,AvgW,AvgC,STDIK
      real BW0(nZagg),BW1(nZagg),BW2(nZagg)
      real BI0(nZagg),BI1(nZagg),BI2(nZagg)
      integer extrap(2),iunit,iZSRnext
      data iunit /15/
      real TrProbCost(nNIlast,nNIlast)
      real LaborIndTemp(nFirms),WBnext,WageConvGrid(8),WageConvMult
      real TrProbCostCum(nNIlast,nNIlast)
      real MUCgr,U,Ulast,Uc,Uclast,DKindNextPromised(nFirms)
      integer Ccount(nS*nK*nZagg),Ccount2(nS*nK*nZagg),Ccount3(nK*nZagg)
      integer Clabor(nS*nK*nZagg),ComputePolInd(nFirms)
      real DebtDefault(nFirms),DebtDefault0(nFirms),PriceDebtInd(nFirms)
      real Q0(nZind),Q1(nZind),EMQ1(nZind),EMQ1grid(nS*nK*nZagg,nZind)
      real Q0grid(nS*nK*nZagg,nZind),Q1grid(nS*nK*nZagg,nZind)
      real EMQ0grid(nS*nK*nZagg,nZind),mu0,STDdN,STDRi,STDNK
      real LaborIndMin,LaborIndMax,KImin,KImax,WBImin,WBImax,CES,RTS
      real GDPmult,lab0,lab1,CFdebtInd(nFirms),CFdebt,DKImin,DKImax
      real meanCmin(nK*nS*nZagg),meanCmax(nK*nS*nZagg)
      real PriceDebtIndLast(nFirms),InterestInd(nFirms)
      real PriceDebtNRPind(nFirms)
      real PriceDebtIndRFLast(nfirms),PriceDebtIndRF(nfirms),wDebtRF
      real RetEqInd(nFirms),RetDebtInd(nFirms),RetEq,RetDebt,wEq,wDebt
      real PriceDebtRF(nK*nS*nZagg*nDKI,1),PDRF,PDRFlast,RetDebtLTRF
      real DKnext,PriceDebtAvg,DK,PriceDebtRFAvg,RetDebtIndRF(nFirms)
      real PriceDebtNRPavg
      integer DebtExpiryNext(nFirms),DebtExpiry(nFirms)
      integer CountDormant,CountDef
      real outputLaborInd(1000,100),outputWageInd(1000,100)
      real outputSalesInd(1000,100),outputIntInd(1000,100)
      real outputPDInd(1000,100),outputPDRFInd(1000,100)
      real outputDefInd(1000,100),outputRDInd(1000,100)
      real outputKind(1000,100),outputVind(1000,100)
      real outputExpInd(1000,100),outputPDNRPind(1000,100)
      real outputREInd(1000,100)

      Labor=1.0
      nAgg=nK*nS*nZagg
      nInd=nDKI*nWBI*nKI*nZind*nNIlast
      if(nIter.ne.nAgg+2) write(6,*) 'nIter is wrong'
      LaborIndMin=10000
      LaborIndMax=-10000
      KImin=10000
      KImax=-10000
      WBImin=10000
      WBImax=-10000
      DKImin=10000
      DKImax=-10000

      call readparams(nZagg,nZsr,nZind,nNIlast,beta1,theta,eis,deltaK,
     1     psiK0,RTS,v1P,v1N,FixedCost,growth,Agrid,Zgrid,TrProbAgg,
     2     TrProbAggSR,ZIgrid,TrProbInd,TrProbCost,
     1     lab0,lab1,tempR3,mu0,xi,CES)
      call readdata(Kgrid,'Kgrid0.txt',nK,1,nK,1)
      call readdata(Sgrid,'Sgrid0.txt',nS,1,nS,1)
      call readdata(DKIgrid,'DKgrid.txt',nDKi,1,nDKi,1)
      call readdata(WBIgrid,'SIgrid.txt',nWBI,1,nWBI,1)
      call readdata(KIgrid,'KIgrid.txt',nKI,1,nKI,1)
      call readdata(NIlastGrid,'NIgrid.txt',nNIlast,1,nNIlast,1)
      call readdata(RFgrid,'RFgrid.txt',nAgg,1,nAgg,1)
      call readdata(BC0,'BC0000.txt',nZagg,1,nZagg,1)
      call readdata(BC1,'BC1000.txt',nZagg,1,nZagg,1)
      call readdata(BC2,'BC2000.txt',nZagg,1,nZagg,1)
      call readdata(BW0,'BW0000.txt',nZagg,1,nZagg,1)
      call readdata(BW1,'BW1000.txt',nZagg,1,nZagg,1)
      call readdata(BW2,'BW2000.txt',nZagg,1,nZagg,1)
      call readdata(BI0,'BI0000.txt',nZagg,1,nZagg,1)
      call readdata(BI1,'BI1000.txt',nZagg,1,nZagg,1)
      call readdata(BI2,'BI2000.txt',nZagg,1,nZagg,1)
      call readdata(meanCold,'meanC0.txt',nAgg,3,nAgg,3)
      call readdata(meanWold,'meanW0.txt',nAgg,3,nAgg,3)
      call readdata(meanIold,'meanI0.txt',nAgg,3,nAgg,3)
      call readdata(meanYold,'meanY0.txt',nAgg,3,nAgg,3)
      call readdatadouble(VsdfDouble,'Vsdf00.txt',nAgg,1,nAgg,1)
      call readdatadouble(EVTsdfDouble,'EVTsdf.txt',nAgg,1,nAgg,1)

!      call readdata(Policy,'policy.txt',nAgg*nInd,5,nAgg*nInd,5)
!      call readdata(V,'valueF.txt',nAgg*nInd,1,nAgg*nInd,1)
      call readdatabinary(V,'valueF.dat',nAgg*nInd,1)
      call readdatabinary(Policy,'policy.dat',nAgg*nInd,5)
      call readdata(PriceDebtRF,'PrcDRF.txt',nAgg*nDKI,1,nAgg*nDKI,1)
      call readdatabinary(PriceDebtNRP,'PrcDNR.dat',nAgg*nInd,1)

      do iZ=1,nZagg
      do i=1,nZind
       mu0grid(iZ,i)=mu0*mu0shock(iZ)*mu0shock2(i)
      end do
      end do

      tempMultV=1.0
      tempMultEVT=1.0
      tempF1=10.0**(-25.0)
      tempF3=(10.0)**(25.0)
      tempF4=(10.0)**(20.0)
      tempF2=tempF3*tempF4
      if(EVTsdfDouble(1,1).lt.tempF1) then
       tempMultEVT=EVTsdfDouble(1,1)!10.0**(-45.0)
      end if
      if(EVTsdfDouble(1,1).gt.tempF2) then
       tempMultEVT=EVTsdfDouble(1,1)!10.0**(45.0)
      end if
      if(VsdfDouble(1,1).lt.tempF1) then
       tempMultV=VsdfDouble(1,1)!10.0**(-45.0)
      end if
      if(VsdfDouble(1,1).gt.tempF2) then
       tempMultV=VsdfDouble(1,1)!10.0**(45.0)
      end if
      do i=1,nAgg
       tempF1=VsdfDouble(i,1)/tempMultV
       Vsdf(i,1)=tempF1
       tempF1=EVTsdfDouble(i,1)/tempMultEVT
       EVTsdf(i,1)=tempF1
      end do

      do i=1,nZagg
       tempR1=0
       do j=1,nZagg
        tempR1=tempR1+TrProbAgg(i,j)
        TrProbAggCum(i,j)=tempR1
       end do
      end do
      
      tempR1=0
      do j=1,nZsr
       tempR1=tempR1+TrProbAggSR(j)
       TrProbAggSRCum(j)=tempR1
      end do

      do i=1,nZind
       tempR1=0
       do j=1,nZind
        tempR1=tempR1+TrProbInd(i,j)
        TrProbIndCum(i,j)=tempR1
       end do
      end do

      do i=1,nNIlast
       tempR1=0
       do j=1,nNIlast
        tempR1=tempR1+TrProbCost(i,j)
        TrProbCostCum(i,j)=tempR1
       end do
      end do

      do iZ=1,nZagg
      do iS=1,nS
       do iK=1,nK
        iAgg=((iS-1)*nK+iK-1)*nZagg+iZ
        VtempK(iK)=Vsdf(iAgg,1)
       end do
       tempI1=1
       tempI2=0
       call PCHIM(nK,Kgrid,VtempK,DtempK,tempI1,tempI2)
       do iK=1,nK
        iAgg=((iS-1)*nK+iK-1)*nZagg+iZ
        DerivsVk(iAgg)=DtempK(iK)
       end do
       do iK=1,nK
        iAgg=((iS-1)*nK+iK-1)*nZagg+iZ
        VtempK(iK)=EVTsdf(iAgg,1)
       end do
       tempI1=1
       tempI2=0
       call PCHIM(nK,Kgrid,VtempK,DtempK,tempI1,tempI2)
       do iK=1,nK
        iAgg=((iS-1)*nK+iK-1)*nZagg+iZ
        DerivsEVTk(iAgg)=DtempK(iK)
       end do
      end do
      end do

      do tempI5=1,nDKI
      do tempI4=1,nWBI
      do tempI3=1,nNIlast
      do iZ=1,nZagg
      do iS=1,nS
      do iK=1,nK
      do i=1,nZind
       iAgg=((iS-1)*nK+iK-1)*nZagg+iZ
       do iKI=1,nKI
        j=(tempI5-1)*nWBI*nNIlast*nKI*nZind+
     1    (tempI4-1)*nNIlast*nKI*nZind+
     1    (tempI3-1)*nKI*nZind+(iKI-1)*nZind+i
        VtempF(iKI)=V((j-1)*nAgg+iAgg,1)
       end do
       tempI1=1
       tempI2=0
       call PCHIM(nKI,KIgrid,VtempF,DtempF,tempI1,tempI2)
       do iKI=1,nKI
        j=(tempI5-1)*nWBI*nNIlast*nKI*nZind+
     1    (tempI4-1)*nNIlast*nKI*nZind+
     1    (tempI3-1)*nKI*nZind+(iKI-1)*nZind+i
        DerivsVF((j-1)*nAgg+iAgg)=DtempF(iKI)
       end do
      end do
      end do
      end do
      end do
      end do
      end do
      end do
      
      do tempI5=1,nKI
      do tempI4=1,nWBI
      do tempI3=1,nNIlast
      do iZ=1,nZagg
      do iS=1,nS
      do iK=1,nK
      do i=1,nZind
       iAgg=((iS-1)*nK+iK-1)*nZagg+iZ
       do iDKI=1,nDKI
        j=(iDKI-1)*nWBI*nNIlast*nKI*nZind+
     1    (tempI4-1)*nNIlast*nKI*nZind+
     1    (tempI3-1)*nKI*nZind+(tempI5-1)*nZind+i
        VtempFdk(iDKI)=policy((j-1)*nAgg+iAgg,5)
        if(iDKI.eq.1) VtempFdk(iDKI)=0
       end do
       tempI1=1
       tempI2=0
       call PCHIM(nDKI,DKIgrid,VtempFdk,DtempFdk,tempI1,tempI2)
       do iDKI=1,nDKI
        j=(iDKI-1)*nWBI*nNIlast*nKI*nZind+
     1    (tempI4-1)*nNIlast*nKI*nZind+
     1    (tempI3-1)*nKI*nZind+(tempI5-1)*nZind+i
        DerivsPD((j-1)*nAgg+iAgg)=DtempFdk(iDKI)
       end do
      end do
      end do
      end do
      end do
      end do
      end do
      end do
      
      do tempI5=1,nKI
      do tempI4=1,nWBI
      do tempI3=1,nNIlast
      do iZ=1,nZagg
      do iS=1,nS
      do iK=1,nK
      do i=1,nZind
       iAgg=((iS-1)*nK+iK-1)*nZagg+iZ
       do iDKI=1,nDKI
        j=(iDKI-1)*nWBI*nNIlast*nKI*nZind+
     1    (tempI4-1)*nNIlast*nKI*nZind+
     1    (tempI3-1)*nKI*nZind+(tempI5-1)*nZind+i
        VtempFdk(iDKI)=PriceDebtNRP((j-1)*nAgg+iAgg,1)
        if(iDKI.eq.1) VtempFdk(iDKI)=0
       end do
       tempI1=1
       tempI2=0
       call PCHIM(nDKI,DKIgrid,VtempFdk,DtempFdk,tempI1,tempI2)
       do iDKI=1,nDKI
        j=(iDKI-1)*nWBI*nNIlast*nKI*nZind+
     1    (tempI4-1)*nNIlast*nKI*nZind+
     1    (tempI3-1)*nKI*nZind+(tempI5-1)*nZind+i
        DerivsPDNRP((j-1)*nAgg+iAgg)=DtempFdk(iDKI)
       end do
      end do
      end do
      end do
      end do
      end do
      end do
      end do

      call readdata(Zshock,'zshock.txt',
     1              TotYears0+TotYears1+(nIter-1)*TotYears2,1,
     2              TotYears0+TotYears1+(nIter-1)*TotYears2,1)
!      do i=1,totyears*niter
!       zshock(i)=rand()
!      end do

      do iIter=1,nIter

      if(iIter.eq.1) then
       InitCount=0
       do iAgg=1,nAgg
        IndexInit(iAgg,1)=1
        IndexInit(iAgg,2)=10000
        IndexInit(iAgg,3)=1
       end do
      end if

      if(iIter.gt.1.and.iIter.lt.nIter) then
       tempI1=mod(iIter-1-1,nK*nZagg)+1
       iSnext=nint(real(iIter-1-tempI1)/real(nK*nZagg))+1!nint(.5*real(nS))
       iKnext=mod(iiter-2,nK)+1
       tempI2=iIter-1-(iSnext-1)*nK*nZagg
       iZnext=1+real(tempI2-(mod(tempI2-1,nK)+1))/real(nK)
      else
       iKnext=nint(.5*real(nK))
       iSnext=nint(.5*real(nS))
       iZnext=nint(.5*real(nZagg))
      end if
      iZ=iZlastGrid(iZnext)
      TFPnext=1.0
      EVT=EVTsdf(((iSnext-1)*nK+iKnext-1)*nZagg+iZnext,1)*tempMultEVT
      Knext=Kgrid(iKnext)
      Snext=Sgrid(iSnext)
      S=Snext
      call findspot(Kgrid,nK,Knext,iKnext,iKnext)
      call findspot(Sgrid,nS,Snext,iSnext,iSnext)

      LaborDemand=Ngrid(iZ)

      psiK=psiK0*psiKshock(iZnext)
      tempR1=GDPmult*Zgrid(iZnext)*(1.0-psiK)*RTS*(Knext**psiK)
      WBnext=(Snext*tempR1)*LaborDemand
      C=.1*Knext
      ValAll=Knext
      tempR1=0.8
      tempR4=0.0
      tempR5=0.0
      if(Knext-Kgrid(1).lt.tempR1) tempR1=Knext-Kgrid(1)
      if(Kgrid(nK)-Knext.lt.tempR1) tempR1=Kgrid(nK)-Knext
      do i=1,nFirms
       tempR2=(real(i-1)-real(nFirms-1)*.5)/(real(nFirms-1))  !goes from -0.5 to 0.5
       if(tempR2.lt.0) then
        tempR3=-.99/(.5**2.0)
       else
        tempR3=.99/(.5**2.0)
       end if
       KindNext(i)=Knext+tempR1*tempR3*(abs(tempR2)**2.0)
       if(abs(ZIgrid(1)-ZIgrid(nZind)).lt..0001) then
        KindNext(i)=Knext
       end if
       if(KindNext(i).lt..01) KindNext(i)=.01
       NIlastNext(i)=LaborDemand+tempR1*tempR3*(abs(tempR2)**2.0)
       if(NIlastNext(i).lt..01) NIlastNext(i)=.01
       tempR4=tempR4+KindNext(i)/real(nFirms)
       tempR5=tempR5+NIlastNext(i)/real(nFirms)
       PriceDebtInd(i)=1.0
       PriceDebtIndRF(i)=1.0
       DebtExpiryNext(i)=0
      end do

      do i=1,nFirms
       KindNext(i)=KindNext(i)*Knext/tempR4
       NIlastNext(i)=NIlastNext(i)*LaborDemand/tempR5
       call findspot(KIgrid,nKI,KindNext(i),nint(.5*real(nKI)),tempI2)
       iKind(i)=tempI2
       Kind(i)=KindNext(i)
       iZindNext(i)=mod(i,nZind)+1
       iZind(i)=iZindNext(i)
!       NIlastNext(i)=NIlastGrid(1)+
!     1  (NIlastGrid(nNIlast)-NIlastGrid(1))*real(i)/real(nFirms)
       if(nNIlast.eq.1) NIlastNext(i)=NIlastGrid(1)
       INVind(i)=deltaK*KindNext(i)
       Yind(i)=.1*Kind(i)
       WBind(i)=WBnext
       WBindNext(i)=WBind(i)
       DKind(i)=0.0
       DKindNext(i)=0.0
       Val(i)=1.5*Kind(i)
       DivInd(i)=.1*Kind(i)
      end do

      iAgg=(iSnext-1)*nK*nZagg+(iKnext-1)*nZagg+iZnext
      if(iIter.gt.1) then
       tempR1=0
       tempR3=0
       tempR5=0
       tempR7=0
       do i=1,nFirms
        iZindNext(i)=iZindInit0(i,nint(IndexInit(iAgg,1)))
        KindNext(i)=KindInit0(i,nint(IndexInit(iAgg,1)))
        WBindNext(i)=WBindInit0(i,nint(IndexInit(iAgg,1)))
        NIlastNext(i)=NIlastInit0(i,nint(IndexInit(iAgg,1)))
        DKindNext(i)=DKindInit0(i,nint(IndexInit(iAgg,1)))
        tempR3=tempR3+WBindNext(i)/real(nFirms)
        tempR1=tempR1+KindNext(i)/real(nFirms)
        tempR5=tempR5+NIlastNext(i)/real(nFirms)
        !tempR7=tempR7+DKindNext(i)/real(nFirms)
       end do
       tempR2=tempR1
       tempR4=tempR3
       tempR6=tempR5
       !tempR8=tempR7
       do j=1,10
        tempR1=0
        tempR3=0
        tempR5=0
        do i=1,nFirms
         KindNext(i)=KindNext(i)*Knext/tempR2
         if(KindNext(i).gt.KIgrid(nKI).and.j.lt.10) then
          KindNext(i)=KIgrid(nKI)
         end if
         WBindNext(i)=WBindNext(i)*WBnext/tempR4
         if(WBindNext(i).gt.WBIgrid(nWBI).and.j.lt.10) then
          WBindNext(i)=WBIgrid(nWBI)
         end if
         NIlastNext(i)=NIlastNext(i)*LaborDemand/tempR6
         if(NIlastNext(i).gt.NIlastGrid(nNIlast).and.j.lt.10) then
          NIlastNext(i)=NIlastGrid(nNIlast)
         end if
         tempR1=tempR1+KindNext(i)/real(nFirms)
         tempR3=tempR3+WBindNext(i)/real(nFirms)
         tempR5=tempR5+NIlastNext(i)/real(nFirms)
         if(j.eq.10) then
          call findspot(KIgrid,nKI,KindNext(i),nint(.5*nKI),tempI2)
          iKind(i)=tempI2
         end if
        end do
        tempR2=tempR1
        tempR4=tempR3
        tempR6=tempR5
       end do
      end if

      Div=.4
      Rf=1
      psiK=psiK0*psiKshock(iZ)
      psiKnext=psiK0*psiKshock(iZnext)
      Wage=GDPmult*Zgrid(iZnext)*(1.0-psiKnext)*RTS*(Knext**psiKnext)
!      X=psiL*((1.0-psiL)**((1.0-psiL)/psiL))*
!     1   (Zgrid(iZnext)**(1.0/psiL))*(Wage**((psiL-1.0)/psiL))
!      DIV=X*(Knext**(psiK/psiL)-deltaK*Knext-v1P*(deltaK)*(deltaK)*Knext

      if(iIter.eq.1) TotYears=TotYears0
      if(iIter.gt.1.and.iIter.le.nIter-1) TotYears=TotYears2
      if(iIter.eq.nIter) TotYears=TotYears1


      PDRF=1.0
      tempI10=0
      tempI11=0
      CountDormant=0
      CountDef=0
      TFPgrnext=1.0
      TFP=TFPnext

      do t=1,TotYears

      EVTlast=EVT
      INVlast=INV
      Clast=C
      Klast=K
      K=Knext
      Slast=S
      S=Snext
      iZlast=iZ
      iZ=iZnext
      iKlast=iK
      iK=iKnext
      iS=iSnext
      TFPlast=TFP
      TFP=TFPnext
      DivLast=Div
      ValAllLast=ValAll
      LaborDemandLast=LaborDemand
      iAgg=(iS-1)*nK*nZagg+(iK-1)*nZagg+iZ
      RfLast=Rf
      tempR1=0.0
      psiK=psiK0*psiKshock(iZ)
      PDRFlast=PDRF
      TFPgr=TFPgrnext
      DK=DKnext

      do i=1,nFirms
       YindLast(i)=Yind(i)
       iZindLast(i)=iZind(i)
       iZind(i)=iZindNext(i)
       KindLast(i)=Kind(i)
       Kind(i)=KindNext(i)
       INVindLast(i)=INVind(i)
       tempI1=iKind(i)
       call findspot(KIgrid,nKI,Kind(i),tempI1,tempI2)
       iKind(i)=tempI2
       ValLast(i)=Val(i)
       DebtExpiry(i)=DebtExpiryNext(i)
       DivIndLast(i)=DivInd(i)
       Zind(i)=ZIgrid(iZind(i))
       tempR1=tempR1+Zind(i)/real(nFirms)
       NIlastLast(i)=NIlast(i)
       NIlast(i)=NIlastNext(i)
       call findspot(NIlastGrid,nNIlast,NIlast(i),2,tempI2)
       iNIlast(i)=tempI2
       WBindLast(i)=WBind(i)
       WBind(i)=WBindNext(i)
       call findspot(WBIgrid,nWBI,WBind(i),2,tempI2)
       iWBind(i)=tempI2
       DKindLast(i)=DKind(i)
       DKind(i)=DKindNext(i)
       DKindPromised(i)=DKind(i)
       call findspot(DKIgrid,nDKI,DKind(i),2,tempI2)
       iDKind(i)=tempI2
       PriceDebtIndLast(i)=PriceDebtInd(i)
       PriceDebtIndRFLast(i)=PriceDebtIndRF(i)
      end do
      do i=1,nFirms
       Zind(i)=Zind(i)/tempR1
       ZIshock(i)=.5
      end do

      iZnext=1
      if(iIter-1.gt.0.and.iIter-1.le.nIter-2) then
       tempR1=Zshock(TotYears0+(iIter-1)*TotYears2+t)
      else
       tempR1=Zshock(t)
      end if
      !tempR1=rand()
      do i=1,nZagg-1
       if(tempR1.gt.TrProbAggCum(iZ,i)) iZnext=i+1
      end do
      tempR1=rand()
      iZSRnext=1
      do i=1,nZsr-1
       if(tempR1.gt.TrProbAggSRCum(i)) iZSRnext=i+1
      end do
!Use below for iZSRnext perfectly correlated with iZnext (this is the process we have previously used)
!      iZSRnext=iZnext

      TFPgrnext=Agrid(iZ,iZSRnext)
      TFPnext=TFP*TFPgrnext
      do i=1,nint(.5*real(nFirms))
       ZIshock(i)=rand()
       ZIshock(i+nint(.5*real(nFirms)))=1.0-ZIshock(i)
      end do

      do i=1,nFirms
       iZindNext(i)=1
       do j=1,nZind-1
        if(ZIshock(i).gt.TrProbIndCum(iZind(i),j)) iZindNext(i)=j+1
       end do
      end do

      multK=(K-Kgrid(iK))/(Kgrid(iK+1)-Kgrid(iK))
      if(multK.gt.1.0) multK=1.0
      if(multK.lt.0.0) multK=0.0
      multS=(S-Sgrid(iS))/(Sgrid(iS+1)-Sgrid(iS))
      if(multS.gt.1.0) multS=1.0
      if(multS.lt.0.0) multS=0.0
      iLL=((iS-1)*nK+iK-1)*nZagg+iZ
      iLH=iLL+nZagg
      iHL=iLL+nK*nZagg
      iHH=iHL+nZagg
      tempR1=meanCold(iLL,1)
      tempR2=meanCold(iLH,1)
      tempR3=meanCold(iHL,1)
      tempR4=meanCold(iHH,1)
      tempR5=tempR1+multK*(tempR2-tempR1)
      tempR6=tempR3+multK*(tempR4-tempR3)
      tempR8=tempR5+multS*(tempR6-tempR5)   !this is the belief about C this period
      tempR1=RFgrid(iLL,1)+multK*(RFgrid(iLH,1)-RFgrid(iLL,1))
      tempR2=RFgrid(iHL,1)+multK*(RFgrid(iHH,1)-RFgrid(iHL,1))
      RF=tempR1+multS*(tempR2-tempR1)
      i=(2-1)*nAgg
      tempR1=PriceDebtRF(i+iLL,1)+multK*
     1      (PriceDebtRF(i+iLH,1)-PriceDebtRF(i+iLL,1))
      tempR2=PriceDebtRF(i+iHL,1)+multK*
     1      (PriceDebtRF(i+iHH,1)-PriceDebtRF(i+iHL,1))
      PDRF=tempR1+multS*(tempR2-tempR1)

      do i=1,nFirms
       ComputePolInd(i)=1
      end do

      call getpolicy(nKI,nNIlast,nWBI,nDKI,nZind,nS,nK,nZagg,
     1     Kind,NIlast,WBind,DKind,iKind,iNIlast,iWBind,iDKind,iZind,
     1     S,K,iZ,nFirms,Agrid,
     2     Kgrid,Sgrid,Zgrid,KIgrid,NIlastGrid,WBIgrid,DKIgrid,ZIgrid,
     3     Policy,V,DerivsVF,DerivsPD,PriceDebtNRP,DerivsPDNRP,
     3     psiK,RTS,deltaK,INVind,LaborIndMult,
     4     DKindNext,Val,DebtDefault,PriceDebtInd,PriceDebtNRPind,
     5     GDPmult,psiKshock2,ComputePolInd,t)

      CostDefault=0.0
      do i=1,nFirms
       ComputePolInd(i)=0
       InterestInd(i)=DKind(i)
       if(DebtDefault(i).gt.0.5.or.Val(i).lt.0.0001) then
        if(Val(i).lt.0.0001.and.DebtDefault(i).le.0.5) then
         DebtDefault(i)=1.0
        end if
        ComputePolInd(i)=1
        CostDefault=CostDefault+(1.0-RecRate)*Kind(i)/real(nFirms)
        Kind(i)=RecRate*Kind(i)
        tempI1=iKind(i)
        call findspot(KIgrid,nKI,Kind(i),tempI1,tempI2)
        iKind(i)=tempI2
        DKind(i)=0.0
        iDKind(i)=1
        InterestInd(i)=0.0
       end if
      end do

      call getpolicy(nKI,nNIlast,nWBI,nDKI,nZind,nS,nK,nZagg,
     1     Kind,NIlast,WBind,DKind,iKind,iNIlast,iWBind,iDKind,iZind,
     1     S,K,iZ,nFirms,Agrid,
     2     Kgrid,Sgrid,Zgrid,KIgrid,NIlastGrid,WBIgrid,DKIgrid,ZIgrid,
     3     Policy,V,DerivsVF,DerivsPD,PriceDebtNRP,DerivsPDNRP,
     3     psiK,RTS,deltaK,INVind,LaborIndMult,
     4     DKindNext,Val,DebtDefault0,PriceDebtInd,PriceDebtNRPind,
     5     GDPmult,psiKshock2,ComputePolInd,t)

      DKnext=0
      PriceDebtAvg=0
      PriceDebtRFAvg=0
      PriceDebtNRPavg=0
      do i=1,nFirms
       tempR1=rand()
       PriceDebtIndRF(i)=PDRF*DKindNext(i)/DKIgrid(2) !note: PDRF is price of debt that may expire next period, KKindNext has not yet been divided by Agrid^RTS so its normalized to current period
       if(DKind(i).lt.0.0001) then
        PriceDebtIndRF(i)=PriceDebtIndRF(i)/(1.0-ProbExp)
       end if
 
       DebtExpiryNext(i)=0
       DKindNextPromised(i)=DKindNext(i)
       if(DKind(i).gt.0.0001) then
        PriceDebtInd(i)=PriceDebtInd(i)*(1.0-ProbExp)
        PriceDebtNRPind(i)=PriceDebtNRPind(i)*(1.0-ProbExp)
        if(tempR1.lt.ProbExp) then
         DKindNext(i)=0
         DebtExpiryNext(i)=1
        end if
       end if
       DKindNext(i)=DKindNext(i)/(TFPgrnext**RTS)
       DKnext=DKnext+DKindNext(i)/real(nFirms)
       PriceDebtAvg=PriceDebtAvg+PriceDebtInd(i)/real(nFirms)
       PriceDebtRFAvg=PriceDebtRFAvg+PriceDebtIndRF(i)/real(nFirms)
       PriceDebtNRPavg=PriceDebtNRPavg+PriceDebtNRPind(i)/real(nFirms)
       if(DKind(i).lt.0.0001.or.PriceDebtIndRFLast(i).le.0.0001) then
        if(DebtExpiry(i).eq.1.or.PriceDebtIndRFLast(i).le.0.0001) then
         RetDebtIndRF(i)=0.0   !Debt expires --> return on analogous risk free debt is zero
        else
         tempR1=PDRF*DKindPromised(i)/DKIgrid(2)
         RetDebtIndRF(i)=(TFPgr**RTS)*(DKindPromised(i)+tempR1)/
     1                   PriceDebtIndRFLast(i)  !Debt defaults --> need price of non-defaulting debt
        end if
       else
        RetDebtIndRF(i)=(TFPgr**RTS)*(DKind(i)+PriceDebtIndRF(i))/
     1                   PriceDebtIndRFLast(i)
       end if
      end do

      tempR1=0
      do i=1,nFirms
       psiK=psiK0*psiKshock(iZ)*psiKshock2(iZind(i))
       tempR1=tempR1+(Zind(i)**(1.0/(1.0-(1.0-psiK)*RTS)))*
     1               (Kind(i)**(psiK/(1.0-(1.0-psiK)*RTS)))/real(nFirms)
      end do
      Wage=(tempR1**(1.0-(1.0-psiK)*RTS))*
     1     GDPmult*Zgrid(iZ)*((1.0-psiK)*RTS)

      LaborSupply=Ngrid(iZ)

      do i=1,8
       WageConvGrid(i)=1.0
      end do
      WageConvMult=0.1
      tempR2=10000
      do j=1,150
       LaborDemand=0
       do i=1,nFirms
        psiK=psiK0*psiKshock(iZ)*psiKshock2(iZind(i))
        LaborInd(i)=(Wage**(-1.0/(1.0-(1.0-psiK)*RTS)))*LaborIndMult(i)
        if(LaborInd(i).gt.NIlastGrid(nNIlast))
     1     LaborInd(i)=NIlastGrid(nNIlast)
        if(Val(i).lt.0.003) then
         INVind(i)=0.0
         LaborInd(i)=0.0
        end if
        LaborDemand=LaborDemand+LABORind(i)/real(nFirms)
       end do
       if(t.lt.25) then
        Wage=Wage+WageConvMult*K*(LaborDemand-LaborSupply)
       else
        Wage=Wage+WageConvMult*K*(LaborDemand-LaborSupply)
       end if
       if(Wage.lt..01) Wage=.01
!!here tempR3=w(t)=(mu*N(t-1)*s(t)+(N(t)-mu*N(t-1))*wage(t))/N(t)
!!where w(t)=W(t)/Z(t)^RTS is the detrended average wage
!!      s(t)=w(t-1)/A(t)^RTS is today's state, which is last period's average wage detrended by today's productivity
!!      N(t)=f(w(t))

       LaborSupply=Ngrid(iZ)

       WageConvGrid(1)=WageConvGrid(2)
       WageConvGrid(2)=WageConvGrid(3)
       WageConvGrid(3)=WageConvGrid(4)
       WageConvGrid(4)=WageConvGrid(5)
       WageConvGrid(5)=WageConvGrid(6)
       WageConvGrid(6)=WageConvGrid(7)
       WageConvGrid(7)=WageConvGrid(8)
       WageConvGrid(8)=LaborDemand-LaborSupply
       if(abs(WageConvGrid(8)).gt.abs(WageConvGrid(1))
     1    .or.
     1    (WageConvGrid(8)*WageConvGrid(7).lt.0.and.
     1     WageConvGrid(7)*WageConvGrid(6).lt.0.and.
     1     WageConvGrid(6)*WageConvGrid(5).lt.0.and.
     1     WageConvGrid(5)*WageConvGrid(4).lt.0.and.
     1     WageConvGrid(4)*WageConvGrid(3).lt.0.and.
     1     WageConvGrid(3)*WageConvGrid(2).lt.0.and.
     1     WageConvGrid(2)*WageConvGrid(1).lt.0)) then
        WageConvMult=WageConvMult*0.85
       end if

       if(j.gt.25.and.(abs(LaborDemand-LaborSupply).lt..0005.or.
     1    abs(tempR2-LaborDemand).lt..00001)) goto 1212
        tempR2=LaborDemand
      end do
 1212 continue
      if(abs(LaborDemand-LaborSupply).gt..0005) then
       if((iIter.eq.1.or.iIter.eq.nIter).and.t.gt.25) then
       write(6,'(a,i4,i3,f8.4,f8.4,f9.5)')
     1  'labor market not cleared ',t,iZ,K,S,LaborDemand
       end if
       do i=1,nFirms
        LaborInd(i)=LaborInd(i)*LaborSupply/LaborDemand
        if(Val(i).lt.0.003) then
         INVind(i)=0.0
         LaborInd(i)=0.0
        end if
       end do
      end if

      C=0.0
      CFdebt=0.0
      Knext=0.0
      DIV=0.0
      INV=0.0
      Y=0.0
      TaxPaidTot=0.0
      WageBill=0.0
      ValAll=0.0
      CostsTot=0.0
      FixedCostTot=0
      ProfitGross=0
      ProfitOper=0
      CountDormant=0
      CountDef=0
      wEq=0
      wDebt=0
      wDebtRF=0
      RetEq=0
      RetDebt=0
      RetDebtLTRF=0
      DebtTotal=0


c$omp parallel
c$omp& default(none)
c$omp& shared(i,iZ,RTS,Val,ValLast,DivIndLast,ValAll,iIter,
c$omp& Agrid,NIlastNext,LABORind,GDPmult,Zgrid,psiK0,K,iZnext,CorpTax,t,
c$omp& WageBillInd,mu0,NIlast,S,WBind,Wage,Yind,CES,Zind,mu0grid,
c$omp& deltaKfree,INVind,Kind,LaborIndMin,LaborIndMax,InterestInd,
c$omp& FixedCost,v1p,v1n,xi,DivInd,ProfitGross,ProfitOper,DKindNext,
c$omp& RFlast,FixedCostMultInd,CostsInd,psiKshock2,TaxPaidInd,CFdebtInd,
c$omp& KindLast,KindNext,deltaK,iZindLast,iZind,ZIgrid,psiKshock,
c$omp& PriceDebtIndLast,RetEqInd,RetDebtInd,PriceDebtInd,DebtDefault,
c$omp& multS,multK,iLL,iLH,iHL,iHH,DKind,TFPgrnext,TFPgr,DebtExpiry)
c$omp& private(psiK,tempR1,tempR2,tempR3,KiBar)
c$omp do

      do i=1,nFirms
       psiK=psiK0*psiKshock(iZ)
       NIlastNext(i)=LABORind(i)
       tempR1=GDPmult*Zgrid(iZ)*(1.0-psiK)*RTS*(K**psiK)
       WageBillInd(i)=mu0grid(iZ,iZind(i))*WBind(i)+
     1               (LaborInd(i)-mu0grid(iZ,iZind(i))*NIlast(i))*Wage
       KiBar=Kind(i)
       if(KiBar.lt.0.5) KiBar=0.5
       if(Val(i).lt..003) then
        FixedCostMultInd(i)=0
        Yind(i)=0
        CostsInd(i)=0
        WageBillInd(i)=0
       else
        psiK=psiK0*psiKshock(iZ)*psiKshock2(iZind(i))
        FixedCostMultInd(i)=K
        if(abs(CES).gt..001) then
         Yind(i)=Zind(i)*GDPmult*Zgrid(iZ)*
     1          (psiK*(Kind(i)**CES)+
     2          (1.0-psiK)*(LaborInd(i)**(CES*RTS)))**(1.0/CES)-
     2           WageBillInd(i)-FixedCost*FixedCostMultInd(i)
        else
         Yind(i)=Zind(i)*GDPmult*Zgrid(iZ)*(Kind(i)**psiK)*
     1          (LaborInd(i)**((1.0-psiK)*RTS))-
     1           WageBillInd(i)-FixedCost*FixedCostMultInd(i)
        end if
        CostsInd(i)=v1P*((INVind(i)-deltaKfree*Kind(i))**2.0)/KiBar
       end if
       Kindnext(i)=((1-deltaK)*Kind(i)+INVind(i))/
     1             (TFPgrnext**RTS)
       if(KindNext(i).lt..001) KindNext(i)=.001
       if(KindNext(i).le..001.and.INVind(i).lt.0) INVind(i)=0
       TaxPaidInd(i)=CorpTax*(Yind(i)-deltaK*Kind(i)-InterestInd(i))
       if(TaxPaidInd(i).lt.0.0) TaxPaidInd(i)=0.0*TaxPaidInd(i)
       if(InterestInd(i).gt.0.0001) then
        CFdebtInd(i)=InterestInd(i)
       else
        CFdebtInd(i)=-PriceDebtInd(i)
       end if
       DIVind(i)=Yind(i)-INVind(i)-CostsInd(i)-TaxPaidInd(i)-
     1           CFdebtInd(i)
       if(DebtDefault(i).gt.0.5.and.DebtExpiry(i).ne.1) then
        RetEqInd(i)=0.0
        if(PriceDebtIndLast(i).gt..0001) then
         RetDebtInd(i)=(TFPgr**RTS)*Val(i)/PriceDebtIndLast(i)
        else
         RetDebtInd(i)=0.0
        end if
!        if(Val(i).gt.DebtInd0(i)) then
!         RetDebtInd(i)=1.0/PriceDebtIndLast(i)
!         write(6,'(a,i4,i5,i5,f8.4,f8.4)')
!     1   'default problem 1',iIter,t,i,Val(i),DebtInd0(i)
!        end if
       else
        if(ValLast(i)-DivIndLast(i).gt..0001) then
         RetEqInd(i)=(TFPgr**RTS)*Val(i)/(ValLast(i)-DivIndLast(i))
        else
         RetEqInd(i)=0.0
        end if
        if(InterestInd(i).le.0.0001) then
         RetDebtInd(i)=0.0
        else
         RetDebtInd(i)=(TFPgr**RTS)*(PriceDebtInd(i)+InterestInd(i))/
     1                  PriceDebtIndLast(i)
        end if
!        if(Val(i).lt.0.or.ValLast(i)-DivIndLast(i).lt.0) then
!         write(6,'(a,i4,i5,i5,f8.4,f8.4,f8.4)')
!     1    'default problem 2',iIter,t,i,ValLast(i),DivIndLast(i),Val(i)
!        end if
       end if
      end do

c$omp end do
c$omp end parallel


      do i=1,nFirms
       ProfitGross=ProfitGross+
     1            (Yind(i)+FixedCost*FixedCostMultInd(i))/real(nFirms) !Yind(i)+FixedCost*tempR1=Gross Profit (X takes care of variable costs such as wages)
       ProfitOper=ProfitOper+Yind(i)/real(nFirms)  !Yind(i)=Operational Profit = Gross Profit - Operational Costs
       FixedCostTot=FixedCostTot+
     1              FixedCost*FixedCostMultInd(i)/real(nFirms)
       CostsTot=CostsTot+CostsInd(i)/real(nFirms)
       TaxPaidTot=TaxPaidTot+TaxPaidInd(i)/real(nFirms)
       !C=C+(DIVind(i)+WAGEBILLind(i)+TaxPaidInd(i))/real(nFirms)
       Knext=Knext+KindNext(i)/real(nFirms)
       CFdebt=CFdebt+CFdebtInd(i)/real(nFirms)
       DIV=DIV+DIVind(i)/real(nFirms)
       INV=INV+INVind(i)/real(nFirms)
       ValAll=ValAll+Val(i)/real(nFirms)
       Y=Y+(Yind(i)+WAGEBILLind(i)+
     1      FixedCost*FixedCostMultInd(i))/real(nFirms)
       WageBill=WageBill+WAGEBILLind(i)/real(nFirms)
       DebtTotal=DebtTotal+PriceDebtInd(i)/real(nFirms)
       if((iIter.eq.1.or.iIter.eq.nIter).and.t.gt.100) then
        if(LaborInd(i).lt.LaborIndMin) LaborIndMin=LaborInd(i)
        if(LaborInd(i).gt.LaborIndMax) LaborIndMax=LaborInd(i)
        if(Kind(i).lt.KImin) KImin=Kind(i)
        if(Kind(i).gt.KImax) KImax=Kind(i)
        if(WBind(i).lt.WBImin) WBImin=WBind(i)
        if(WBind(i).gt.WBImax) WBImax=WBind(i)
        if(DKind(i).lt.DKImin) DKImin=DKind(i)
        if(DKind(i).gt.DKImax) DKImax=DKind(i)
       end if
       RetEq=RetEq+RetEqInd(i)*(ValLast(i)-DivIndLast(i))
       wEq=wEq+(ValLast(i)-DivIndLast(i))
       RetDebt=RetDebt+RetDebtInd(i)*PriceDebtIndLast(i)
       RetDebtLTRF=RetDebtLTRF+RetDebtIndRF(i)*PriceDebtIndRFLast(i)
       wDebt=wDebt+PriceDebtIndLast(i)
       wDebtRF=wDebtRF+PriceDebtIndRFLast(i)
       CountDormant=CountDormant+ComputePolInd(i)
       tempR1=0
       if(PriceDebtIndLast(i).gt.0.0001) then
        CountDef=CountDef+ComputePolInd(i)
        tempR1=ComputePolInd(i)
       end if
       if(t.le.1000.and.iIter.eq.nIter.and.i.le.100) then
        outputKind(t,i)=Kind(i)
        outputVind(t,i)=Val(i)
        outputLaborInd(t,i)=LaborInd(i)
        if(LaborInd(i).gt.0.0001) then
         outputWageInd(t,i)=WageBillInd(i)/LaborInd(i)
        else
         outputWageInd(t,i)=Wage
        end if
        outputSalesInd(t,i)=Yind(i)+WageBillInd(i)+
     1                      FixedCost*FixedCostMultInd(i)
        outputIntInd(t,i)=DKindNextPromised(i)!InterestInd(i)
        outputPDInd(t,i)=PriceDebtInd(i)
        outputPDRFInd(t,i)=PriceDebtIndRF(i)
        outputDefInd(t,i)=tempR1!DebtDefault(i)
        outputRDInd(t,i)=RetDebtInd(i)
        outputREInd(t,i)=RetEqInd(i)
        outputExpInd(t,i)=real(DebtExpiry(i))
        outputPDNRPind(t,i)=PriceDebtNRPind(i)
       end if
      end do
      !C=C+CostsTot+FixedCostTot
      C=DIV+CFdebt+WageBill+TaxPaidTot+CostsTot+FixedCostTot     !wastecost
      if(C.lt..01) C=.01
      RetEq=RetEq/wEq
      if(wDebt.gt.0.001) then
       RetDebt=RetDebt/wDebt
      else
       RetDebt=RFlast
      end if
      if(wDebtRF.gt.0.001) then
       RetDebtLTRF=RetDebtLTRF/wDebtRF
      else
       RetDebtLTRF=RFlast
      end if

      tempI10=tempI10+CountDormant
      if(CountDormant.gt.tempI11) tempI11=CountDormant

      call findspot(Kgrid,nK,Knext,iK,iKnext)
      psiK=psiK0*psiKshock(iZ)
      tempR1=GDPmult*Zgrid(iZ)*(1.0-psiK)*RTS*(K**psiK)
      psiKnext=psiK0*psiKshock(iZnext)
      tempR2=GDPmult*Zgrid(iZnext)*
     1      (1.0-psiKnext)*RTS*(Knext**psiKnext)
      Snext=(mu0*mu0shock(iZ)*S*tempR1*LaborDemandLast+
     1       Wage*(LaborDemand-mu0*mu0shock(iZ)*LaborDemandLast))/
     1      ((TFPgrnext**RTS)*tempR2*LaborDemand)
      call findspot(Sgrid,nS,Snext,iS,iSnext)
      do i=1,nFirms
       if(Val(i).gt..01.or.PriceDebtIndLast(i).gt.0.001) then
        WBindNext(i)=WageBillInd(i)/(TFPgrnext**RTS)
       else
        WBindNext(i)=WBIgrid(1)
       end if
      end do

      call CHFEV(Kgrid(iK),Kgrid(iK+1),
     1           Vsdf(iLL,1),Vsdf(iLH,1),
     2           DerivsVk(iLL),DerivsVk(iLH),
     3           1,K,tempR10,extrap,tempI3)  !tempR1=J(t)
      call CHFEV(Kgrid(iK),Kgrid(iK+1),
     1           Vsdf(iHL,1),Vsdf(iHH,1),
     2           DerivsVk(iHL),DerivsVk(iHH),
     3           1,K,tempR11,extrap,tempI3)  !tempR1=J(t)
      tempR1=tempR10+multS*(tempR11-tempR10)
      tempR1=tempR1*(1.0-(1.0/eis))
      Vtemp=tempR1*tempMultV
      call CHFEV(Kgrid(iK),Kgrid(iK+1),
     1           EVTsdf(iLL,1),EVTsdf(iLH,1),
     2           DerivsEVTk(iLL),DerivsEVTk(iLH),
     3           1,Klast,tempR10,extrap,tempI3) !tempR2=Et[V^(1-theta)]
      call CHFEV(Kgrid(iK),Kgrid(iK+1),
     1           EVTsdf(iHL,1),EVTsdf(iHH,1),
     2           DerivsEVTk(iHL),DerivsEVTk(iHH),
     3           1,K,tempR11,extrap,tempI3) !tempR2=Et[V^(1-theta)]
      tempR2=tempR10+multS*(tempR11-tempR10)
      EVT=tempR2*tempMultEVT
      if(LaborDemand.lt.0.9999) then
       U=C+lab0*(1.0-LaborDemand)**lab1
      else
       U=C+lab0*(1.0-0.9999)**lab1
      end if
      if(LaborDemandLast.lt.0.9999) then
       Ulast=Clast+lab0*(1.0-LaborDemandLast)**lab1
      else
       Ulast=Clast+lab0*(1.0-0.9999)**lab1
      end if
      Uc=1.0
      Uclast=1.0
      MUCgr=((U/Ulast)**(-1.0/eis))*(Uc/Uclast)!(C/Clast)**(-1.0/eis)
      if(abs(eis-1.0).gt..00001.and.abs(theta-1.0).gt..00001) then
       SDF=beta1*MUCgr*
     1     (TFPgr**(-theta*RTS))*
     2     (Vtemp**(((1.0/eis)-theta)/(1.0-(1.0/eis))))*
     3     (EVTlast**((theta-(1.0/eis))/(1.0-theta)))
      else
       SDF=beta1*MUCgr
      end if

      if(iIter-1.gt.0.and.iIter-1.le.nIter-2) then
      tempR1=RTS*log(TFP)
      output2((iIter-2)*TotYears2+t,1)=iZ
      output2((iIter-2)*TotYears2+t,2)=log(K)+tempR1
      output2((iIter-2)*TotYears2+t,3)=log(C)+tempR1
      output2((iIter-2)*TotYears2+t,4)=log(INV)+tempR1 !sometimes INV<0, in that case log(INV) as in column 4 not good so have column 16 instead
      if(INV.lt..001) then
       output2((iIter-2)*TotYears2+t,4)=log(.001)+tempR1
      end if
      output2((iIter-2)*TotYears2+t,5)=log(Y)+tempR1
      output2((iIter-2)*TotYears2+t,6)=X
      output2((iIter-2)*TotYears2+t,7)=log(ValAll)+tempR1
      output2((iIter-2)*TotYears2+t,8)=log(DIV)+tempR1
      output2((iIter-2)*TotYears2+t,9)=RetEq !this is equal to 1-deltaK+psiK*(K**(psiK-1.0)) when v=0
      output2((iIter-2)*TotYears2+t,10)=SDF
      output2((iIter-2)*TotYears2+t,11)=tempR1
      output2((iIter-2)*TotYears2+t,12)=EVT !note, this is used to calculate SDF so do not change location in output1 unless change code above
      output2((iIter-2)*TotYears2+t,13)=log(WageBill)+tempR1
      output2((iIter-2)*TotYears2+t,14)=RF !note, this is RF determinted this period, to be compared with realized return for next period
      output2((iIter-2)*TotYears2+t,15)=RetDebt
      output2((iIter-2)*TotYears2+t,16)=INV !sometimes INV<0, in that case log(INV) as in column 4 not good, so have column 16 instead
      output2((iIter-2)*TotYears2+t,17)=0
      output2((iIter-2)*TotYears2+t,18)=0
      output2((iIter-2)*TotYears2+t,19)=ValAll
      output2((iIter-2)*TotYears2+t,20)=0
      output2((iIter-2)*TotYears2+t,21)=0
      output2((iIter-2)*TotYears2+t,22)=Wage  !spot wage
      output2((iIter-2)*TotYears2+t,23)=0
      output2((iIter-2)*TotYears2+t,24)=0
      output2((iIter-2)*TotYears2+t,25)=log(S)+tempR1
      output2((iIter-2)*TotYears2+t,26)=0.0
      end if

      if(iIter.eq.nIter) then
      tempR1=RTS*log(TFP)
      output1(t,1)=iZ
      output1(t,2)=log(K)+tempR1
      output1(t,3)=log(C)+tempR1
      output1(t,4)=log(INV)+tempR1 !sometimes INV<0, in that case log(INV) as in column 4 not good so have column 16 instead
      if(INV.lt..001) then
       output1(t,4)=log(.001)+tempR1
      end if
      output1(t,5)=log(Y)+tempR1
      output1(t,6)=log(DebtTotal)+tempR1
      output1(t,7)=log(ValAll)+tempR1
      output1(t,8)=log(DIV)+tempR1
      if(DIV.lt.0) output1(t,8)=-10.0+tempR1
      output1(t,9)=RetEq !this is equal to 1-deltaK+psiK*(K**(psiK-1.0)) when v=0
      output1(t,10)=SDF
      output1(t,11)=tempR1
      output1(t,12)=EVT !note, this is used to calculate SDF so do not change location in output1 unless change code above
      output1(t,13)=log(WageBill)+tempR1  !average wage  WageBill=Wage+mu*(S-Wage)
      output1(t,14)=Rf!log(ValAll)+tempR1
      output1(t,15)=RetDebt
      output1(t,16)=INV !sometimes INV<0, in that case log(INV) as in column 4 not good, so have column 16 instead
      output1(t,17)=real(CountDormant)/real(nFirms)
      output1(t,18)=RetDebtLTRF
      output1(t,19)=ValAll-Div
      output1(t,20)=real(CountDef)/real(nFirms)
      output1(t,21)=DK
      output1(t,22)=Wage   !spot wage
      output1(t,23)=DKnext*(TFPgrnext**RTS)/PriceDebtAvg
      output1(t,24)=DKnext*(TFPgrnext**RTS)/PriceDebtRFAvg!DKIgrid(2)/PDRF
      output1(t,25)=log(ProfitOper)+tempR1
      if(ProfitOper.lt.0) output1(t,25)=-10.0+tempR1

      outputRatios(t,1)=ValAll/Div
      if(DIV.lt..01) outputRatios(t,1)=ValAll/.01
      outputRatios(t,2)=INV/Y
      outputRatios(t,3)=INV/K

      output4(t,1)=ProfitGross ! Quantity*(MR-MC)
      output4(t,2)=ProfitOper ! ProfitGross-OperCost, since no taxes or interest this is also equal to NetIncome (in newer accounting rules NetIncome=Profit=BottomLine)
      output4(t,3)=FixedCostTot
      output4(t,4)=S
      output4(t,5)=log(Wage)+tempR1   !spot wage
      output4(t,6)=log(WageBill+FixedCostTot)+tempR1 !actual average wage, including operating costs
      output4(t,7)=DIV
      output4(t,8)=LaborDemand
      output4(t,9)=log(S)+tempR1
      output4(t,10)=log((WageBill+FixedCostTot)/Y)
      output4(t,17)=0
      output4(t,18)=0
      output4(t,19)=0
      output4(t,20)=0
      output4(t,21)=0
      output4(t,22)=0
      output4(t,23)=0
      output4(t,24)=0
      output4(t,25)=CostsTot/(INV+CostsTot)
      end if

      if(iIter.eq.1.and.t.gt.100) then
       countFlag=0
       do iZtemp=1,nZagg
       do iStemp=1,nS
       do iKtemp=1,nK
        iAgg=(iStemp-1)*nK*nZagg+(iKtemp-1)*nZagg+iZtemp
        tempR1=(abs(Kgrid(iKtemp)-K)/Kgrid(iKtemp))+
     1         (abs(Sgrid(iStemp)-S)/Sgrid(iStemp))
        if(iZ.eq.iZtemp.and.tempR1.lt.IndexInit(iAgg,2).and.
     1     InitCount.lt.300) then
         if(countFlag.eq.0) then
          countflag=1
          InitCount=InitCount+1
         end if
         IndexInit(iAgg,1)=InitCount
         IndexInit(iAgg,2)=tempR1
         IndexInit(iAgg,3)=t
         KaggInit0(InitCount)=K
         SaggInit0(InitCount)=S
         iZaggInit0(InitCount)=iZ
         do i=1,nFirms
          KindInit0(i,InitCount)=Kind(i)
          NIlastInit0(i,InitCount)=NIlast(i)
          WBindInit0(i,InitCount)=WBind(i)
          DKindInit0(i,InitCount)=DKind(i)
          iZindInit0(i,InitCount)=iZind(i)
         end do
        end if
       end do
       end do
       end do
      end if

      end do  !t


 9339 continue


      if(iIter.eq.1.or.iIter.eq.nIter) then
      write(6,*)
     1 real(tempI10)/real(nFirms*TotYears),real(tempI11)/real(nFirms)
      end if

      end do  !iter

      tempR1=10000
      tempR2=-10000
      tempR3=10000
      tempR4=-10000
      do t=1,TotYears1
       K=exp(output1(t,2)-output1(t,11))
       S=output4(t,4)
       if(S.lt.tempR1) tempR1=S
       if(S.gt.tempR2) tempR2=S
       if(K.lt.tempR3) tempR3=K
       if(K.gt.tempR4) tempR4=K
      end do
      write(6,'(f8.4,f8.4,a,f8.4,f8.4)')
     1 tempR3,tempR4,' Is this inside Kgrid? ',Kgrid(1),Kgrid(nK)
      write(6,'(f8.4,f8.4,a,f8.4,f8.4)')
     1 tempR1,tempR2,' Is this inside Sgrid? ',Sgrid(1),Sgrid(nS)
      write(6,'(f8.4,f8.4,a,f8.4,f8.4)')
     1 KImin,KImax,' Is this inside KIgrid? ',KIgrid(1),KIgrid(nKI)
      write(6,'(f8.4,f8.4,a,f8.4,f8.4)')
     1 LaborIndMin,LaborIndMax,' Is this inside NIgrid? ',
     2 NIlastGrid(1),NIlastGrid(nNIlast)
      write(6,'(f8.4,f8.4,a,f8.4,f8.4)')
     1 WBImin,WBImax,' Is this inside WBIgrid? ',
     1 WBIgrid(1),WBIgrid(nWBI)
      write(6,'(f8.4,f8.4,a,f8.4,f8.4)')
     1 DKImin,DKImax,' Is this inside DKIgrid? ',
     1 DKIgrid(1),DKIgrid(nDKI)

      !code will not compile if do not hardcode certain matrix in HPfilter
      !therefore TotYearsHPF must be 1000, if not, must make changes to HPfilter
      !note that inside HPfilter we are first constructing Y=y*TFP^q, then filtering
      !q=(1-psiL)/(1-psiK)
      TotYearsHPF=1000
      tempI1=1001  !first year
      tempI2=tempI1+TotYearsHPF-1
      if(deltaK.le..0251) then
       tempR1=-1600.0
      else
       tempR1=-15.0
      end if
      call HPfilter(TotYears1,25,tempI1,tempI2,tempR1,
     1               output1,output1HPF)!
      call HPfilter(TotYears1,25,tempI1,tempI2,tempR1,
     1               output4,output4HPF)!

      ConvC=0.0
      ConvW=0.0
      ConvCn=0.0
      Slm=.4*(Sgrid(nS)-Sgrid(1))/real(nS-1)
      Klm=.15*(Kgrid(nK)-Kgrid(1))/real(nK-1)!.03

      do iAgg=1,nAgg
       meanc(iagg,1)=0.0
       meanc(iagg,2)=0.0
       meanc(iagg,3)=0.0
       Ccount(iAgg)=0
       Ccount2(iAgg)=0
       Clabor(iAgg)=0
      end do
      do iAgg1=1,nZagg*nK
       Ccount3(iAgg1)=0
       extC3(iAgg1,1)=10000
       extC3(iAgg1,2)=-10000
       extW3(iAgg1,1)=10000
       extW3(iAgg1,2)=-10000
       extI3(iAgg1,1)=10000
       extI3(iAgg1,2)=-10000
       extY3(iAgg1,1)=10000
       extY3(iAgg1,2)=-10000
      end do

      do t=1,(nIter-2)*TotYears2
       iZ=output2(t,1)
       K=exp(output2(t,2)-output2(t,11))!output2(t,22)
       S=exp(output2(t,25)-output2(t,11))
       C=exp(output2(t,3)-output2(t,11))
       INV=exp(output2(t,4)-output2(t,11))
       Y=exp(output2(t,5)-output2(t,11))
       Wage=output2(t,22)!exp(output2(t,13)-output2(t,11))
       call findspot(Kgrid,nK,K,nint(.5*real(nK)),iK)
       if(abs(K-Kgrid(iK)).lt.Klm) iKtemp=iK
       if(abs(K-Kgrid(iK+1)).lt.Klm) iKtemp=iK+1
       call findspot(Sgrid,nS,S,nint(.5*real(nS)),iS)
       if(abs(S-Sgrid(iS)).lt.Slm) iStemp=iS
       if(abs(S-Sgrid(iS+1)).lt.Slm) iStemp=iS+1
       if((abs(K-Kgrid(iK)).lt.Klm.or.abs(K-Kgrid(iK+1)).lt.Klm).and.
     1    (abs(S-Sgrid(iS)).lt.Slm.or.abs(S-Sgrid(iS+1)).lt.Slm)) then
        iAgg=((iStemp-1)*nK+iKtemp-1)*nZagg+iZ
        meanC(iagg,1)=meanc(iagg,1)+C
        meanC(iagg,2)=meanc(iagg,2)+(C**2.0)
        meanC(iagg,3)=meanc(iagg,3)+1.0
!        meanW(iagg,1)=meanW(iagg,1)+Wage
!        meanW(iagg,2)=meanW(iagg,2)+(Wage**2.0)
!        meanW(iagg,3)=meanW(iagg,3)+1.0
        ConvC=ConvC+abs(meanCold(iAgg,1)-C)
        ConvCn=ConvCn+1.0
!        ConvW=ConvW+abs(meanWold(iAgg,1)-Wage)
        if(Ccount(iAgg).lt.500) then
         Ccount(iAgg)=Ccount(iAgg)+1.0
         CregC(iAgg,Ccount(iAgg))=C
         CregI(iAgg,Ccount(iAgg))=INV
         CregY(iAgg,Ccount(iAgg))=Y
         CregK(iAgg,Ccount(iAgg))=K
         CregS(iAgg,Ccount(iAgg))=S
         CregW(iAgg,Ccount(iAgg))=Wage
         if(abs(output2(t,26)).gt..005) then
          Clabor(iAgg)=Clabor(iAgg)+1.0
         end if
        end if
       end if
      end do
      do iAgg=1,nAgg
       if(meanC(iAgg,3).gt.0) then
        meanC(iAgg,1)=meanC(iAgg,1)/meanC(iAgg,3)
        meanC(iAgg,2)=meanC(iAgg,1)**2.0
        meanC(iAgg,3)=1
!        meanW(iAgg,1)=meanW(iAgg,1)/meanW(iAgg,3)
!        meanW(iAgg,2)=meanW(iAgg,1)**2.0
!        meanW(iAgg,3)=1
       else
        meanC(iAgg,1)=0
        meanC(iAgg,2)=0
        meanC(iAgg,3)=0
!        meanW(iAgg,1)=0
!        meanW(iAgg,2)=0
!        meanW(iAgg,3)=0
       end if
      end do

!the piece below stores all the realizations of C,K,S,Wage,INV near each gridpoint (iZ,iK) (note that iS is ignored)
!it also computes the maximum and minimum around these points
      AvgW=0.0
      AvgC=0.0
      AvgI=0.0
      AvgY=0.0
      tempI2=0.0
      do t=1,TotYears1
       iZ=output1(t,1)
       K=exp(output1(t,2)-output1(t,11))
       S=output4(t,4)!exp(output1(t,25)-output1(t,11))
       C=exp(output1(t,3)-output1(t,11))
       INV=exp(output1(t,4)-output1(t,11))
       Y=exp(output1(t,5)-output1(t,11))
       Wage=output1(t,22)!exp(output1(t,13)-output1(t,11))
       AvgC=AvgC+C
       AvgW=AvgW+Wage
       AvgI=AvgI+INV
       AvgY=AvgY+Y
       tempI2=tempI2+1

       do iK=1,nK
        if(abs(K-Kgrid(iK)).lt.Klm) then
         iAgg1=(iK-1)*nZagg+iZ
        if(Ccount3(iAgg1).lt.500) then
         Ccount3(iAgg1)=Ccount3(iAgg1)+1.0
         CregC3(iAgg1,Ccount3(iAgg1))=C
         CregK3(iAgg1,Ccount3(iAgg1))=K
         CregS3(iAgg1,Ccount3(iAgg1))=S
         CregW3(iAgg1,Ccount3(iAgg1))=Wage
         CregI3(iAgg1,Ccount3(iAgg1))=INV
         CregY3(iAgg1,Ccount3(iAgg1))=Y
         if(C.lt.extC3(iAgg1,1)) extC3(iAgg1,1)=C
         if(C.gt.extC3(iAgg1,2)) extC3(iAgg1,2)=C
         if(Wage.lt.extW3(iAgg1,1)) extW3(iAgg1,1)=Wage
         if(Wage.gt.extW3(iAgg1,2)) extW3(iAgg1,2)=Wage
         if(INV.lt.extI3(iAgg1,1)) extI3(iAgg1,1)=INV
         if(INV.gt.extI3(iAgg1,2)) extI3(iAgg1,2)=INV
         if(Y.lt.extY3(iAgg1,1)) extY3(iAgg1,1)=Y
         if(Y.gt.extY3(iAgg1,2)) extY3(iAgg1,2)=Y
        end if
        end if
       end do
      end do
      AvgC=AvgC/real(tempI2)
      AvgW=AvgW/real(tempI2)
      AvgI=AvgI/real(tempI2)
      AvgY=AvgY/real(tempI2)

!fill in max and min near gridpoint for off-equilibrium gridpoints
      do iZ=1,nZagg
      do iK=1,nK
       iAgg1=(iK-1)*nZagg+iZ
       if(abs(extC3(iAgg1,1)).gt.500) then
        tempI2=10000
        do i=1,nK
         tempI1=(i-1)*nZagg+iZ
         if(abs(extC3(tempI1,1)).lt.500.and.abs(i-iK).lt.tempI2) then
          tempI2=abs(i-iK)
          extC3(iAgg1,1)=extC3(tempI1,1)
          extC3(iAgg1,2)=extC3(tempI1,2)
          extW3(iAgg1,1)=extW3(tempI1,1)
          extW3(iAgg1,2)=extW3(tempI1,2)
          extI3(iAgg1,1)=extI3(tempI1,1)
          extI3(iAgg1,2)=extI3(tempI1,2)
          extY3(iAgg1,1)=extY3(tempI1,1)
          extY3(iAgg1,2)=extY3(tempI1,2)
         end if
        end do
       end if
      end do
      end do

      wo=0.95!0.97!0.995  !abc

      do i=1,5
       coefs(i)=0
      end do
!      write(6,*) 'Wage: iZ   A0      A1      R^2     n'
      do iZ=1,nZagg
       do t=1,10000
        Ytemp(t,1)=0
        Xtemp(t,1)=0
        Xtemp(t,2)=0
        Xtemp(t,3)=0
        Xtemp(t,4)=0
        Xtemp(t,5)=0
       end do
       i=0
       do t=1,TotYears1-1
        if(output1(t,1).eq.iZ.and.t.gt.2.and.i.lt.10000.and.
     1     exp(output1(t,2)-output1(t,11)).lt.Kgrid(nK)) then
         i=i+1
         K=exp(output1(t,2)-output1(t,11))
         Ytemp(i,1)=exp(output1(t,5)-output1(t,11))!exp(output1(t,13)-output1(t,11))! Spot Wage
         Xtemp(i,1)=1.0
         psiK=psiK0*psiKshock(iZ)
         Xtemp(i,2)=GDPmult*Zgrid(iZ)*(K**psiK)  !K
         Xtemp(i,3)=output4(t,4)!exp(output1(t,25)-output1(t,11)) !S
         Xtemp(i,4)=0
         Xtemp(i,5)=0
        end if
       end do
       call regress(Ytemp,Xtemp,10000,i,5,3,coefs,tempF1)
       call regress(Ytemp,Xtemp,10000,i,5,3,coefs1,tempF2)
       if(tempF1.lt.tempF2.and.tempF2.lt.1.0.and.
     1    (1.0-tempF2)/(1-tempF1).lt..75) then
        do j=1,5
         coefs(j)=coefs1(j)
        end do
       end if
       write(6,'(a,i4,f9.5,f9.5,f9.5,f9.5,i6)')
     1 'y ',iZ,(coefs(j),j=1,3),tempF1,i
!       if(i.gt.5) then
!        BW0(iZ)=coefs(1)!*(1.0-wo)+BW0(iZ)*wo
!        BW1(iZ)=coefs(2)!*(1.0-wo)+BW1(iZ)*wo
!        BW2(iZ)=coefs(3)!*(1.0-wo)+BW2(iZ)*wo
!       end if
      end do

      !predict aggregate investment from aggregate variables
      do i=1,5
       coefs(i)=0
      end do
!      write(6,*) 'INV: iZ  A0      A1      A2      R^2     n'
      do iZ=1,nZagg
       do t=1,10000
        Ytemp(t,1)=0
        Xtemp(t,1)=0
        Xtemp(t,2)=0
        Xtemp(t,3)=0
        Xtemp(t,4)=0
        Xtemp(t,5)=0
       end do
       i=0
       do t=1,TotYears1-1
        if(output1(t,1).eq.iZ.and.t.gt.2.and.i.lt.10000.and.
     1     exp(output1(t,2)-output1(t,11)).lt.Kgrid(nK)) then
         i=i+1
         K=exp(output1(t,2)-output1(t,11))
         C=exp(output1(t,3)-output1(t,11))
         S=output4(t,4)!exp(output1(t,25)-output1(t,11))
         psiK=psiK0*psiKshock(iZ)
         tempR1=GDPmult*Zgrid(nint(output1(t,1)))*(K**psiK)-C !this is Y-C if all firms are same, close to Y-C if not
         if(v1P.gt..0001) then
          !tempR2=(-1.0+(1.0+4.0*(v1P/K)*tempR1)**.5)/(2.0*v1P/K)
          if(1.0+4.0*(v1P/K)*(tempR1-deltaKfree*K).lt.0.0) then
           tempR2=deltaKfree*K-1.0/(2.0*v1P/K)
          else
           if((-1.0+(1.0+4.0*(v1P/K)*(tempR1-deltaKfree*K))**.5)/
     1        (2.0*v1P/K).gt.0) then
            tempR2=deltaKfree*K+(-1.0+
     1        (1.0+4.0*(v1P/K)*(tempR1-deltaKfree*K))**.5)/(2.0*v1P/K)
           else
            if(1.0+4.0*(v1N/K)*(tempR1-deltaKfree*K).lt.0.0) then
             tempR2=deltaKfree*K-1.0/(2.0*v1N/K)
            else
             tempR2=deltaKfree*K+(-1.0+
     1        (1.0+4.0*(v1N/K)*(tempR1-deltaKfree*K))**.5)/(2.0*v1N/K)
            end if
           end if
          end if
         else
          tempR2=tempR1
         end if
        !tempR2=INV exactly when all firms same or when firms different but no costs, tempR2 close to INV otherwise
         Ytemp(i,1)=output1(t,16)!exp(output1(t,4)-output1(t,11))
! output1(t,16)=exp(output1(t,4)-output1(t,11)) except when output1(t,16)<0, RHS=-inf
         Xtemp(i,1)=1.0
         Xtemp(i,2)=tempR2
         Xtemp(i,3)=S
         Xtemp(i,4)=0
         Xtemp(i,5)=0
        end if
       end do
       call regress(Ytemp,Xtemp,10000,i,5,3,coefs,tempF1)
       call regress(Ytemp,Xtemp,10000,i,5,3,coefs1,tempF2)
       if(tempF1.lt.tempF2.and.tempF2.lt.1.0.and.
     1    (1.0-tempF2)/(1-tempF1).lt..75) then
        do j=1,5
         coefs(j)=coefs1(j)
        end do
       end if
       write(6,'(a,i4,f9.5,f9.5,f9.5,f9.5,i6)')
     1 'i ',iZ,(coefs(j),j=1,3),tempF1,i
       if(i.gt.5) then
        BI0(iZ)=coefs(1)*(1.0-wo)+BI0(iZ)*wo
        BI1(iZ)=coefs(2)*(1.0-wo)+BI1(iZ)*wo
        BI2(iZ)=coefs(3)*(1.0-wo)+BI2(iZ)*wo
       end if
      end do

      do i=1,5
       coefs(i)=0
      end do
!      write(6,*) 'Wage: iZ   A0      A1      R^2     n'
      do iZ=1,nZagg
       do t=1,10000
        Ytemp(t,1)=0
        Xtemp(t,1)=0
        Xtemp(t,2)=0
        Xtemp(t,3)=0
        Xtemp(t,4)=0
        Xtemp(t,5)=0
       end do
       i=0
       do t=1,TotYears1-1
        if(output1(t,1).eq.iZ.and.t.gt.2.and.i.lt.10000.and.
     1     exp(output1(t,2)-output1(t,11)).lt.Kgrid(nK)) then
         i=i+1
         K=exp(output1(t,2)-output1(t,11))
         Ytemp(i,1)=output1(t,22)!exp(output1(t,13)-output1(t,11))! Spot Wage
         Xtemp(i,1)=1.0
         psiK=psiK0*psiKshock(iZ)
         Xtemp(i,2)=(1.0-psiK)*RTS*GDPmult*Zgrid(iZ)*(K**psiK)  !K
         Xtemp(i,3)=output4(t,4)!exp(output1(t,25)-output1(t,11)) !S
         Xtemp(i,4)=0
         Xtemp(i,5)=0
        end if
       end do
       call regress(Ytemp,Xtemp,10000,i,5,3,coefs,tempF1)
       call regress(Ytemp,Xtemp,10000,i,5,3,coefs1,tempF2)
       if(tempF1.lt.tempF2.and.tempF2.lt.1.0.and.
     1    (1.0-tempF2)/(1-tempF1).lt..75) then
        do j=1,5
         coefs(j)=coefs1(j)
        end do
       end if
       write(6,'(a,i4,f9.5,f9.5,f9.5,f9.5,i6)')
     1 'w ',iZ,(coefs(j),j=1,3),tempF1,i
       if(i.gt.5) then
        BW0(iZ)=coefs(1)!*(1.0-wo)+BW0(iZ)*wo
        BW1(iZ)=coefs(2)!*(1.0-wo)+BW1(iZ)*wo
        BW2(iZ)=coefs(3)!*(1.0-wo)+BW2(iZ)*wo
       end if
      end do

      do i=1,5
       coefs(i)=0
      end do
!      write(6,*) 'C: iZ   A0      A1       R^2     n    CnvxAdj'
      do iZ=1,nZagg
       do t=1,10000!TotYears*nIter
        Ytemp(t,1)=0
        Xtemp(t,1)=0
        Xtemp(t,2)=0
        Xtemp(t,3)=0
        Xtemp(t,4)=0
        Xtemp(t,5)=0
       end do
       i=0
       do t=1,TotYears1-1
        if(output1(t,1).eq.iZ.and.t.gt.2.and.i.lt.10000.and.
     1     exp(output1(t,2)-output1(t,11)).lt.Kgrid(nK)) then
         i=i+1
         Ytemp(i,1)=output1(t,3)-output1(t,11) !log(C)
         Xtemp(i,1)=1.0
         Xtemp(i,2)=output1(t,2)-output1(t,11) !log(K)
         Xtemp(i,3)=log(output4(t,4))!output1(t,25)-output1(t,11) !log(S)
         Xtemp(i,4)=0
         Xtemp(i,5)=0
        end if
       end do
       call regress(Ytemp,Xtemp,10000,i,5,3,coefs,tempF1)
       call regress(Ytemp,Xtemp,10000,i,5,3,coefs1,tempF2)
       if(tempF1.lt.tempF2.and.tempF2.lt.1.0.and.
     1    (1.0-tempF2)/(1-tempF1).lt..75) then
        do j=1,5
         coefs(j)=coefs1(j)
        end do
       end if

       tempF2=0.0
       tempF3=0.0
       do t=1,i
        tempF2=tempF2+exp(Ytemp(i,1))/real(i)
        tempF3=tempF3+exp(coefs(1))*exp(Xtemp(i,2)*coefs(2))*
     1         exp(Xtemp(i,3)*coefs(3))/real(i)
       end do
       coefs(1)=coefs(1)*tempF2/tempF3
       write(6,'(a,i4,f9.5,f9.5,f9.5,f9.5,i6,f9.5)')
     1 'c ',iZ,(coefs(j),j=1,3),tempF1,i,tempF2/tempF3
       if(i.gt.5) then
        BC0(iZ)=coefs(1)!*(1.0-wo)+BC0(iZ)*wo
        BC1(iZ)=coefs(2)!*(1.0-wo)+BC1(iZ)*wo
        BC2(iZ)=coefs(3)!*(1.0-wo)+BC2(iZ)*wo
       end if
      end do

      coefs(1)=0
      coefs(2)=0
      coefs(3)=0
      tempR2=0.0
      tempR8=0.0
      tempI1=0.0
      do iZ=1,nZagg
      do iS=1,nS
      do iK=1,nK
       iAgg=((iS-1)*nK+iK-1)*nZagg+iZ
       iAgg1=(iK-1)*nZagg+iZ

       if(Ccount3(iAgg1).lt.20) then
        tempR10=0
        tempR11=0
        tempR12=0
        tempR13=0
        do i=1,Ccount(iAgg)
         tempR10=tempR10+CregC(iAgg,i)
         tempR11=tempR11+CregW(iAgg,i)
         tempR12=tempR12+CregI(iAgg,i)
         tempR13=tempR13+CregY(iAgg,i)
        end do
        meanC(iAgg,1)=tempR10/real(Ccount(iAgg))
        meanW(iAgg,1)=tempR11/real(Ccount(iAgg))
        meanI(iAgg,1)=tempR12/real(Ccount(iAgg))
        meanY(iAgg,1)=tempR13/real(Ccount(iAgg))
        meanCnoS(iAgg,1)=tempR10/real(Ccount(iAgg))
        meanWnoS(iAgg,1)=tempR11/real(Ccount(iAgg))
        meanInoS(iAgg,1)=tempR12/real(Ccount(iAgg))
        meanYnoS(iAgg,1)=tempR13/real(Ccount(iAgg))
       else
        do i=1,Ccount3(iAgg1)
         Ytemp(i,1)=CregC3(iAgg1,i)
         Xtemp(i,1)=1
         Xtemp(i,2)=CregK3(iAgg1,i)
         Xtemp(i,3)=CregS3(iAgg1,i)
        end do
        call regress(Ytemp,Xtemp,10000,Ccount3(iAgg1),5,3,coefs,tempF1)
        meanC(iAgg,1)=coefs(1)+coefs(2)*Kgrid(iK)+coefs(3)*Sgrid(iS)
        if(meanC(iAgg,1).lt.extC3(iAgg1,1)-0.01) 
     1 meanC(iAgg,1)=extC3(iAgg1,1)-0.01
        if(meanC(iAgg,1).gt.extC3(iAgg1,2)+0.01) 
     1 meanC(iAgg,1)=extC3(iAgg1,2)+0.01
        call regress(Ytemp,Xtemp,10000,Ccount3(iAgg1),5,2,coefs,tempF1)
        meanCnoS(iAgg,1)=coefs(1)+coefs(2)*Kgrid(iK)
        if(meanCnoS(iAgg,1).lt.extC3(iAgg1,1)-0.01)
     1     meanCnoS(iAgg,1)=extC3(iAgg1,1)-0.01
        if(meanCnoS(iAgg,1).gt.extC3(iAgg1,2)+0.01)
     1     meanCnoS(iAgg,1)=extC3(iAgg1,2)+0.01
        do i=1,Ccount3(iAgg1)
         Ytemp(i,1)=CregI3(iAgg1,i)
         Xtemp(i,1)=1
         Xtemp(i,2)=CregK3(iAgg1,i)
         Xtemp(i,3)=CregS3(iAgg1,i)
        end do
        call regress(Ytemp,Xtemp,10000,Ccount3(iAgg1),5,3,coefs,tempF1)
        meanI(iAgg,1)=coefs(1)+coefs(2)*Kgrid(iK)+coefs(3)*Sgrid(iS)
        if(meanI(iAgg,1).lt.extI3(iAgg1,1)-0.01) 
     1 meanI(iAgg,1)=extI3(iAgg1,1)-0.01
        if(meanI(iAgg,1).gt.extI3(iAgg1,2)+0.01) 
     1 meanI(iAgg,1)=extI3(iAgg1,2)+0.01
        call regress(Ytemp,Xtemp,10000,Ccount3(iAgg1),5,2,coefs,tempF1)
        meanInoS(iAgg,1)=coefs(1)+coefs(2)*Kgrid(iK)
        if(meanInoS(iAgg,1).lt.extI3(iAgg1,1)-0.01)
     1     meanInoS(iAgg,1)=extI3(iAgg1,1)-0.01
        if(meanInoS(iAgg,1).gt.extI3(iAgg1,2)+0.01)
     1     meanInoS(iAgg,1)=extI3(iAgg1,2)+0.01

        do i=1,Ccount3(iAgg1)
         Ytemp(i,1)=CregY3(iAgg1,i)
         Xtemp(i,1)=1
         Xtemp(i,2)=CregK3(iAgg1,i)
         Xtemp(i,3)=CregS3(iAgg1,i)
        end do
        call regress(Ytemp,Xtemp,10000,Ccount3(iAgg1),5,3,coefs,tempF1)
        meanY(iAgg,1)=coefs(1)+coefs(2)*Kgrid(iK)+coefs(3)*Sgrid(iS)
        if(meanY(iAgg,1).lt.extY3(iAgg1,1)) meanY(iAgg,1)=extY3(iAgg1,1)
        if(meanY(iAgg,1).gt.extY3(iAgg1,2)) meanY(iAgg,1)=extY3(iAgg1,2)
        call regress(Ytemp,Xtemp,10000,Ccount3(iAgg1),5,2,coefs,tempF1)
        meanYnoS(iAgg,1)=coefs(1)+coefs(2)*Kgrid(iK)
        if(meanYnoS(iAgg,1).lt.extY3(iAgg1,1))
     1     meanYnoS(iAgg,1)=extY3(iAgg1,1)
        if(meanYnoS(iAgg,1).gt.extY3(iAgg1,2))
     1     meanYnoS(iAgg,1)=extY3(iAgg1,2)

        do i=1,Ccount3(iAgg1)
         Ytemp(i,1)=CregW3(iAgg1,i)
         Xtemp(i,1)=1
         Xtemp(i,2)=CregK3(iAgg1,i)
         Xtemp(i,3)=CregS3(iAgg1,i)
        end do
        call regress(Ytemp,Xtemp,10000,Ccount3(iAgg1),5,3,coefs,tempF1)
        meanW(iAgg,1)=coefs(1)+coefs(2)*Kgrid(iK)+coefs(3)*Sgrid(iS)
        if(meanW(iAgg,1).lt.extW3(iAgg1,1)) meanW(iAgg,1)=extW3(iAgg1,1)
        if(meanW(iAgg,1).gt.extW3(iAgg1,2)) meanW(iAgg,1)=extW3(iAgg1,2)
        call regress(Ytemp,Xtemp,10000,Ccount3(iAgg1),5,2,coefs,tempF1)
        meanWnoS(iAgg,1)=coefs(1)+coefs(2)*Kgrid(iK)
        if(meanWnoS(iAgg,1).lt.extW3(iAgg1,1))
     1     meanWnoS(iAgg,1)=extW3(iAgg1,1)
        if(meanWnoS(iAgg,1).gt.extW3(iAgg1,2))
     1     meanWnoS(iAgg,1)=extW3(iAgg1,2)
       end if



      end do
      end do
      end do
      tempR2=tempR2/real(tempI1)
      tempR8=tempR8/real(tempI1)


      tempR4=0
      tempR5=0
      tempR9=0
      tempR10=0
      tempR11=0
      tempR12=0
      tempR13=0
      tempR14=0
      tempR15=0
      tempR16=0
      tempR17=0
      tempR18=0
      tempR19=0
      tempR20=0
      do t=26,TotYears1
       iZ=output1(t,1)
       K=exp(output1(t,2)-output1(t,11))
       S=output4(t,4)!exp(output1(t,25)-output1(t,11))
       call findspot(Kgrid,nK,K,nint(.5*real(nK)),iK)
       call findspot(Sgrid,nS,S,nint(.5*real(nS)),iS)
       multK=(K-Kgrid(iK))/(Kgrid(iK+1)-Kgrid(iK))
       if(multK.gt.1.0) multK=1.0
       if(multK.lt.0.0) multK=0.0
       multS=(S-Sgrid(iS))/(Sgrid(iS+1)-Sgrid(iS))
       if(multS.gt.1.0) multS=1.0
       if(multS.lt.0.0) multS=0.0
       iLL=((iS-1)*nK+iK-1)*nZagg+iZ
       iLH=iLL+nZagg
       iHL=iLL+nK*nZagg
       iHH=iHL+nZagg

       tempR6=meanC(iLL,1)+multK*(meanC(iLH,1)-meanC(iLL,1))
       tempR7=meanC(iHL,1)+multK*(meanC(iHH,1)-meanC(iHL,1))
       C=tempR6+multS*(tempR7-tempR6)
       tempR6=meanCnoS(iLL,1)+multK*(meanCnoS(iLH,1)-meanCnoS(iLL,1))
       tempR7=meanCnoS(iHL,1)+multK*(meanCnoS(iHH,1)-meanCnoS(iHL,1))
       CnoS=tempR6+multS*(tempR7-tempR6)

       tempR6=meanW(iLL,1)+multK*(meanW(iLH,1)-meanW(iLL,1))
       tempR7=meanW(iHL,1)+multK*(meanW(iHH,1)-meanW(iHL,1))
       Wage=tempR6+multS*(tempR7-tempR6)
       tempR6=meanWnoS(iLL,1)+multK*(meanWnoS(iLH,1)-meanWnoS(iLL,1))
       tempR7=meanWnoS(iHL,1)+multK*(meanWnoS(iHH,1)-meanWnoS(iHL,1))
       WnoS=tempR6+multS*(tempR7-tempR6)

       tempR6=meanI(iLL,1)+multK*(meanI(iLH,1)-meanI(iLL,1))
       tempR7=meanI(iHL,1)+multK*(meanI(iHH,1)-meanI(iHL,1))
       INV=tempR6+multS*(tempR7-tempR6)
       tempR6=meanInoS(iLL,1)+multK*(meanInoS(iLH,1)-meanInoS(iLL,1))
       tempR7=meanInoS(iHL,1)+multK*(meanInoS(iHH,1)-meanInoS(iHL,1))
       InoS=tempR6+multS*(tempR7-tempR6)

       tempR6=meanY(iLL,1)+multK*(meanY(iLH,1)-meanY(iLL,1))
       tempR7=meanY(iHL,1)+multK*(meanY(iHH,1)-meanY(iHL,1))
       Y=tempR6+multS*(tempR7-tempR6)
       tempR6=meanYnoS(iLL,1)+multK*(meanYnoS(iLH,1)-meanYnoS(iLL,1))
       tempR7=meanYnoS(iHL,1)+multK*(meanYnoS(iHH,1)-meanYnoS(iHL,1))
       YnoS=tempR6+multS*(tempR7-tempR6)

       tempR4=tempR4+(exp(output1(t,3)-output1(t,11))-AvgC)**2.0
       tempR5=tempR5+(exp(output1(t,3)-output1(t,11))-C)**2.0
       tempR17=tempR17+(exp(output1(t,3)-output1(t,11))-CnoS)**2.0

       tempR9=tempR9+(output1(t,22)-AvgW)**2.0
       tempR10=tempR10+(output1(t,22)-Wage)**2.0
       tempR18=tempR18+(output1(t,22)-WnoS)**2.0

       tempR13=tempR13+(exp(output1(t,4)-output1(t,11))-AvgI)**2.0
       tempR14=tempR14+(exp(output1(t,4)-output1(t,11))-INV)**2.0
       tempR19=tempR19+(exp(output1(t,4)-output1(t,11))-InoS)**2.0

       tempR15=tempR15+(exp(output1(t,5)-output1(t,11))-AvgY)**2.0
       tempR16=tempR16+(exp(output1(t,5)-output1(t,11))-Y)**2.0
       tempR20=tempR20+(exp(output1(t,5)-output1(t,11))-YnoS)**2.0
      end do
      R2c=1.0-tempR5/tempR4
      R2w=1.0-tempR10/tempR9
      R2i=1.0-tempR14/tempR13
      R2y=1.0-tempR16/tempR15
      R2cNoS=1.0-tempR17/tempR4
      R2wNoS=1.0-tempR18/tempR9
      R2iNoS=1.0-tempR19/tempR13
      R2yNoS=1.0-tempR20/tempR15
      write(6,*) 'With    S: ',R2c,R2w,R2i,R2y
      write(6,*) 'Without S: ',R2cNoS,R2wNoS,R2iNoS,R2yNoS
      if(R2cNoS.gt.R2c) then
       write(6,*) 'C: without S ',R2cNoS,'with S ',R2c
       do i=1,nAgg
        meanC(i,1)=meanCnoS(i,1)
       end do
      end if
      if(R2wNoS.gt.R2w) then
       write(6,*) 'W: without S ',R2wNoS,'with S ',R2w
       do i=1,nAgg
        meanW(i,1)=meanWnoS(i,1)
       end do
      end if
      if(R2iNoS.gt.R2i) then
       write(6,*) 'I: without S ',R2iNoS,'with S ',R2i
       do i=1,nAgg
        meanI(i,1)=meanInoS(i,1)
       end do
      end if
      if(R2yNoS.gt.R2y) then
       write(6,*) 'Y: without S ',R2yNoS,'with S ',R2y
       do i=1,nAgg
        meanY(i,1)=meanYnoS(i,1)
       end do
      end if


      tempR4=0
      tempR5=0
      tempR9=0
      tempR10=0
      tempR11=0
      tempR12=0
      tempR13=0
      tempR14=0
      tempR15=0
      tempR16=0
      do t=26,TotYears1
       iZ=output1(t,1)
       K=exp(output1(t,2)-output1(t,11))
       S=output4(t,4)!exp(output1(t,25)-output1(t,11))
       call findspot(Kgrid,nK,K,nint(.5*real(nK)),iK)
       call findspot(Sgrid,nS,S,nint(.5*real(nS)),iS)
       multK=(K-Kgrid(iK))/(Kgrid(iK+1)-Kgrid(iK))
       if(multK.gt.1.0) multK=1.0
       if(multK.lt.0.0) multK=0.0
       multS=(S-Sgrid(iS))/(Sgrid(iS+1)-Sgrid(iS))
       if(multS.gt.1.0) multS=1.0
       if(multS.lt.0.0) multS=0.0
       iLL=((iS-1)*nK+iK-1)*nZagg+iZ
       iLH=iLL+nZagg
       iHL=iLL+nK*nZagg
       iHH=iHL+nZagg
       tempR6=meanCold(iLL,1)+multK*(meanCold(iLH,1)-meanCold(iLL,1))
       tempR7=meanCold(iHL,1)+multK*(meanCold(iHH,1)-meanCold(iHL,1))
       C=tempR6+multS*(tempR7-tempR6)
       tempR6=meanWold(iLL,1)+multK*(meanWold(iLH,1)-meanWold(iLL,1))
       tempR7=meanWold(iHL,1)+multK*(meanWold(iHH,1)-meanWold(iHL,1))
       Wage=tempR6+multS*(tempR7-tempR6)
       tempR6=meanIold(iLL,1)+multK*(meanIold(iLH,1)-meanIold(iLL,1))
       tempR7=meanIold(iHL,1)+multK*(meanIold(iHH,1)-meanIold(iHL,1))
       INV=tempR6+multS*(tempR7-tempR6)
       tempR6=meanYold(iLL,1)+multK*(meanYold(iLH,1)-meanYold(iLL,1))
       tempR7=meanYold(iHL,1)+multK*(meanYold(iHH,1)-meanYold(iHL,1))
       Y=tempR6+multS*(tempR7-tempR6)
       tempR4=tempR4+(exp(output1(t,3)-output1(t,11))-AvgC)**2.0
       tempR5=tempR5+(exp(output1(t,3)-output1(t,11))-C)**2.0
       tempR9=tempR9+(output1(t,22)-AvgW)**2.0
       tempR10=tempR10+(output1(t,22)-Wage)**2.0
       tempR13=tempR13+(exp(output1(t,4)-output1(t,11))-AvgI)**2.0
       tempR14=tempR14+(exp(output1(t,4)-output1(t,11))-INV)**2.0
       tempR15=tempR15+(exp(output1(t,5)-output1(t,11))-AvgY)**2.0
       tempR16=tempR16+(exp(output1(t,5)-output1(t,11))-Y)**2.0
      end do
      R2c=1.0-tempR5/tempR4
      R2w=1.0-tempR10/tempR9
      R2i=1.0-tempR14/tempR13
      R2y=1.0-tempR16/tempR15

      write(6,'(a,f11.5,a,f11.5,a,f11.5,a,f11.5)')
     1 'ConvC ',ConvC,' StD ',tempR2,' R2 ',R2c
      write(6,'(a,f11.5,a,f11.5,a,f11.5a,f11.5)')
     1 'ConvW ',ConvW,' StD ',tempR8,' R2 ',R2w
      write(6,'(a,f11.5,a,f11.5,a,f11.5a,f11.5)')
     1 'ConvI ',ConvW,' StD ',tempR8,' R2 ',R2i
      write(6,'(a,f11.5,a,f11.5,a,f11.5a,f11.5)')
     1 'ConvY ',ConvW,' StD ',tempR8,' R2 ',R2y

      do i=1,nAgg
       meanCtemp(i,1)=meanCold(i,1)
       meanCtemp(i,2)=meanCold(i,2)
       meanCtemp(i,3)=meanCold(i,3)
       meanWtemp(i,1)=meanWold(i,1)
       meanWtemp(i,2)=meanWold(i,2)
       meanWtemp(i,3)=meanWold(i,3)
       meanItemp(i,1)=meanIold(i,1)
       meanItemp(i,2)=meanIold(i,2)
       meanItemp(i,3)=meanIold(i,3)
       meanYtemp(i,1)=meanYold(i,1)
       meanYtemp(i,2)=meanYold(i,2)
       meanYtemp(i,3)=meanYold(i,3)
      end do


      do iZ=1,nZagg
      do iS=1,nS
      do iK=1,nK
       iAgg=((iS-1)*nK+iK-1)*nZagg+iZ
       if(iK.eq.1.or.iK.eq.nK) then
        if(iK.eq.1) then
         tempR1=meanC(iAgg+nZagg,1)-meanCold(iAgg+nZagg,1)
         tempR4=meanW(iAgg+nZagg,1)-meanWold(iAgg+nZagg,1)
         tempR7=meanI(iAgg+nZagg,1)-meanIold(iAgg+nZagg,1)
         tempR10=meanY(iAgg+nZagg,1)-meanYold(iAgg+nZagg,1)
        end if
        if(iK.eq.nK) then
         tempR1=meanC(iAgg-nZagg,1)-meanCold(iAgg-nZagg,1)
         tempR4=meanW(iAgg-nZagg,1)-meanWold(iAgg-nZagg,1)
         tempR7=meanI(iAgg-nZagg,1)-meanIold(iAgg-nZagg,1)
         tempR10=meanY(iAgg-nZagg,1)-meanYold(iAgg-nZagg,1)
        end if
        tempR3=.67*(meanC(iAgg,1)-meanCold(iAgg,1))+.33*tempR1
        tempR6=.67*(meanW(iAgg,1)-meanWold(iAgg,1))+.33*tempR4
        tempR9=.67*(meanI(iAgg,1)-meanIold(iAgg,1))+.33*tempR7
        tempR12=.67*(meanY(iAgg,1)-meanYold(iAgg,1))+.33*tempR10
       else
        tempR3=meanC(iAgg,1)-meanCold(iAgg,1)    !aaaa
        tempR6=meanW(iAgg,1)-meanWold(iAgg,1)
        tempR9=meanI(iAgg,1)-meanIold(iAgg,1)
        tempR12=meanY(iAgg,1)-meanYold(iAgg,1)
       end if
       meanCtemp(iAgg,1)=meanCold(iAgg,1)+tempR3*(1.0-wo)!+tempR5*.02
       meanCtemp(iAgg,2)=meanC(iAgg,2)
       meanCtemp(iAgg,3)=meanC(iAgg,3)*(1.0-wo)+meanCold(iAgg,3)*wo
       meanWtemp(iAgg,1)=meanWold(iAgg,1)+tempR6*(1.0-wo)!+tempR5*.02
       meanWtemp(iAgg,2)=meanW(iAgg,2)
       meanWtemp(iAgg,3)=meanW(iAgg,3)*(1.0-wo)+meanWold(iAgg,3)*wo
       meanItemp(iAgg,1)=meanIold(iAgg,1)+tempR9*(1.0-wo)!+tempR5*.02
       meanItemp(iAgg,2)=meanI(iAgg,2)
       meanItemp(iAgg,3)=meanI(iAgg,3)*(1.0-wo)+meanIold(iAgg,3)*wo
       meanYtemp(iAgg,1)=meanYold(iAgg,1)+tempR12*(1.0-wo)!+tempR5*.02
       meanYtemp(iAgg,2)=meanY(iAgg,2)
       meanYtemp(iAgg,3)=meanY(iAgg,3)*(1.0-wo)+meanYold(iAgg,3)*wo
      end do
      end do
      end do



      tempR1=0.0
      tempR2=0.0
      tempR3=0.0
      do i=1,nAgg
       tempR1=tempR1+meanCtemp(i,1)-meanCold(i,1)
       tempR2=tempR2+abs(meanCtemp(i,1)-meanCold(i,1))
       if(abs(meanCtemp(i,1)-meanCold(i,1)).gt.tempR3) then
        tempR3=abs(meanCtemp(i,1)-meanCold(i,1))
        iAgg=i
        tempR5=meanCtemp(i,1)
        tempR6=meanCold(i,1)
       end if
      end do
      tempR4=real(nAgg)
      write(6,'(a,f9.5,a,f9.5,a,f9.5,i7,f9.5,f9.5)')
     1 'dC avg ',tempR1/tempR4,' avg abs ',
     1 tempR2/tempR4,' max ',tempR3,iAgg,tempR5,tempR6
      tempR1=0.0
      tempR2=0.0
      tempR3=0.0
      do i=1,nAgg
       tempR1=tempR1+meanItemp(i,1)-meanIold(i,1)
       tempR2=tempR2+abs(meanItemp(i,1)-meanIold(i,1))
       if(abs(meanItemp(i,1)-meanIold(i,1)).gt.tempR3) then
        tempR3=abs(meanItemp(i,1)-meanIold(i,1))
        iAgg=i
        tempR5=meanItemp(i,1)
        tempR6=meanIold(i,1)
       end if
      end do
      tempR4=real(nAgg)
      write(6,'(a,f9.5,a,f9.5,a,f9.5,i7,f9.5,f9.5)')
     1 'dI avg ',tempR1/tempR4,' avg abs ',
     1 tempR2/tempR4,' max ',tempR3,iAgg,tempR5,tempR6
      tempR1=0.0
      tempR2=0.0
      tempR3=0.0
      do i=1,nAgg
       tempR1=tempR1+meanYtemp(i,1)-meanYold(i,1)
       tempR2=tempR2+abs(meanYtemp(i,1)-meanYold(i,1))
       if(abs(meanYtemp(i,1)-meanYold(i,1)).gt.tempR3) then
        tempR3=abs(meanYtemp(i,1)-meanYold(i,1))
        iAgg=i
        tempR5=meanYtemp(i,1)
        tempR6=meanYold(i,1)
       end if
      end do
      tempR4=real(nAgg)
      write(6,'(a,f9.5,a,f9.5,a,f9.5,i7,f9.5,f9.5)')
     1 'dY avg ',tempR1/tempR4,' avg abs ',
     1 tempR2/tempR4,' max ',tempR3,iAgg,tempR5,tempR6
      tempR1=0.0
      tempR2=0.0
      tempR3=0.0
      do i=1,nAgg
       tempR1=tempR1+meanWtemp(i,1)-meanWold(i,1)
       tempR2=tempR2+abs(meanWtemp(i,1)-meanWold(i,1))
       if(abs(meanWtemp(i,1)-meanWold(i,1)).gt.tempR3) then
        tempR3=abs(meanWtemp(i,1)-meanWold(i,1))
        iAgg=i
        tempR5=meanWtemp(i,1)
        tempR6=meanWold(i,1)
       end if
      end do
      tempR4=real(nAgg)
      write(6,'(a,f9.5,a,f9.5,a,f9.5,i7,f9.5,f9.5)')
     1 'dW avg ',tempR1/tempR4,' avg abs ',
     1 tempR2/tempR4,' max ',tempR3,iAgg,tempR5,tempR6



      do i=1,nAgg
       meanCold(i,1)=meanCtemp(i,1)
       meanCold(i,2)=meanC(i,1)
       meanCold(i,3)=meanCold(i,2)
       meanWold(i,1)=meanWtemp(i,1)
       meanWold(i,2)=0!meanWtemp(i,2)
       meanWold(i,3)=0!meanWtemp(i,3)
       meanIold(i,1)=meanItemp(i,1)
       meanIold(i,2)=0!meanItemp(i,2)
       meanIold(i,3)=0!meanItemp(i,3)
       meanYold(i,1)=meanYtemp(i,1)
       meanYold(i,2)=0!meanYtemp(i,2)
       meanYold(i,3)=0!meanYtemp(i,3)
      end do






      iZ=2
      do iS=nint(.5*real(nS)),nint(.5*real(nS))
      do iK=1,nK
       iAgg=((iS-1)*nK+iK-1)*nZagg+iZ
       write(6,'(i4,f6.2,f6.3,f6.3,f6.3,f6.3,f6.3,f6.3,
     1 f6.3,f6.3,f6.3,f6.3,f6.3,f6.3,f6.3,f6.3,f6.3,f6.3,f6.3,f6.3)')
     1 iK,Kgrid(iK),meanC(iAgg-1,1),meanC(iAgg,1),meanC(iAgg+1,1),
     2 meanCold(iAgg-1,1),meanCold(iAgg,1),meanCold(iAgg+1,1),
     3 meanW(iAgg-1,1),meanW(iAgg,1),meanW(iAgg+1,1),
     2 meanWold(iAgg-1,1),meanWold(iAgg,1),meanWold(iAgg+1,1),
     3 meanY(iAgg-1,1),meanY(iAgg,1),meanY(iAgg+1,1),
     2 meanYold(iAgg-1,1),meanYold(iAgg,1),meanYold(iAgg+1,1)
      end do
      end do

      do iZ=1,nZagg
      do iK=1,nK
      do iS=2,nS
       iAgg=((iS-1)*nK+iK-1)*nZagg+iZ
       if(real(clabor(iAgg))/real(ccount(iAgg)).gt..5.and.
     1    meanW(iAgg,1).gt.meanW(iAgg-nK*nZagg,1)) then
        meanW(iAgg,1)=.99*meanW(iAgg-nK*nZagg,1)
       end if
      end do
      end do
      end do


      write(6,*)
     1 'x        E[x]   StD[ln(x)]  AC(ln(x)) Cr[ln(Y),ln(x)] Sk[ln(x)]
     2 Kt[ln(x)]'

      j=0
      do i=1,TotYears1
       if(i.gt.100) then
        j=j+1
        outshort1(j,1)=exp(RTS*output1(i,11))
        outshort2(j,1)=exp(RTS*output1(i,11))
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      TFP=tempF1
      j=0
      do i=1,TotYears1
       if(i.gt.100) then
        j=j+1
        outshort1(j,1)=exp(output1(i,2)-output1(i,11))
        outshort2(j,1)=exp(output1(i,2)-output1(i,11))
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF11=tempF1
      tempF4=exp(.5*log(tempF3-tempF1*tempF1))
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      j=0
      do i=1,TotYearsHPF
       if(i.gt.150.and.i.lt.TotYearsHPF-150) then
       j=j+1
       outshort1(j,1)=output1HPF(i,2)
       outshort2(j,1)=output1HPF(i,2)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF4=exp(.5*log(tempF3-tempF1*tempF1))
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      write(6,'(A,f11.5,f11.5,f11.5)')
     1 'K   ',tempF11,tempF4,tempF5
      j=0
      do i=1,TotYears1
       if(i.gt.100) then
       j=j+1
       outshort1(j,1)=output1(i,5)-output1(i-1,5)
       outshort2(j,1)=output1(i,5)-output1(i-1,5)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF11=tempF1
      sigmaDY=exp(.5*log(tempF3-tempF1*tempF1))
      j=0
      do i=1,TotYears1
       if(i.gt.100) then
       j=j+1
       outshort1(j,1)=exp(output1(i,5)-output1(i,11))
       outshort2(j,1)=exp(output1(i,5)-output1(i,11))
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF11=tempF1
      tempF4=exp(.5*log(tempF3-tempF1*tempF1))
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      j=0
      do i=1,TotYearsHPF
       if(i.gt.150.and.i.lt.TotYearsHPF-150) then
       j=j+1
       outshort1(j,1)=output1HPF(i,5)
       outshort2(j,1)=output1HPF(i,5)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF4=exp(.5*log(tempF3-tempF1*tempF1))
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      write(6,'(A,f11.5,f11.5,f11.5,f11.5)')
     1 'Y   ',tempF11,tempF4,tempF5,1.0
      sigmaY=tempF4
      j=0
      do i=1,TotYears1
       if(i.gt.100) then
       j=j+1
       outshort1(j,1)=exp(output1(i,3)-output1(i,11))
       outshort2(j,1)=exp(output1(i,3)-output1(i,11))
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF11=tempF1
      tempF4=exp(.5*log(tempF3-tempF1*tempF1))
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      j=0
      do i=1,TotYearsHPF
       if(i.gt.150.and.i.lt.TotYearsHPF-150) then
       j=j+1
       outshort1(j,1)=output1HPF(i,3)
       outshort2(j,1)=output1HPF(i,3)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF4=exp(.5*log(tempF3-tempF1*tempF1))
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      sigmaC=tempF4
      j=0
      do i=1,TotYearsHPF
       if(i.gt.150.and.i.lt.TotYearsHPF-150) then
       j=j+1
       outshort1(j,1)=output1HPF(i,3)
       outshort2(j,1)=output1HPF(i,5)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF14,tempF15,tempF16,
     1 tempF17,tempF18,tempF19,tempF20,j)
      tempF21=tempF16-tempF14*tempF15
      write(6,'(A,f11.5,f11.5,f11.5,f11.5,f11.5,f11.5)')
     1 'C   ',tempF11,tempF4,tempF5,tempF21/(sigmaC*sigmaY),
     2  sign(1.0,real(tempF12-(tempF1**3.0)))*
     3  abs(tempF12-(tempF1**3.0))**(1.0/3.0),
     4  (tempF13-(tempF1**4.0))**(1.0/4.0)

      j=0
      do i=1,TotYears1
       if(i.gt.100) then
       j=j+1
       outshort1(j,1)=exp(output1(i,4)-output1(i,11))
       outshort2(j,1)=exp(output1(i,4)-output1(i,11))
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF11=tempF1
      tempF4=exp(.5*log(tempF3-tempF1*tempF1))
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      j=0
      do i=1,TotYearsHPF
       if(i.gt.150.and.i.lt.TotYearsHPF-150) then
       j=j+1
       outshort1(j,1)=output1HPF(i,4)
       outshort2(j,1)=output1HPF(i,4)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF4=exp(.5*log(tempF3-tempF1*tempF1))
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      sigmaI=tempF4
      j=0
      do i=1,TotYearsHPF
       if(i.gt.150.and.i.lt.TotYearsHPF-150) then
       j=j+1
       outshort1(j,1)=output1HPF(i,4)
       outshort2(j,1)=output1HPF(i,5)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF14,tempF15,tempF16,
     1 tempF17,tempF18,tempF19,tempF20,j)
      tempF21=tempF16-tempF14*tempF15
      write(6,'(A,f11.5,f11.5,f11.5,f11.5,f11.5,f11.5)')
     1 'I   ',tempF11,tempF4,tempF5,tempF21/(sigmaI*sigmaY),
     2  sign(1.0,real(tempF12-(tempF1**3.0)))*
     3  abs(tempF12-(tempF1**3.0))**(1.0/3.0),
     4  (tempF13-(tempF1**4.0))**(1.0/4.0)

      j=0
      do i=1,TotYears1
       if(i.gt.100) then
       j=j+1
       outshort1(j,1)=exp(output4(i,8))
       outshort2(j,1)=exp(output4(i,8))
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF11=tempF1
      tempF4=exp(.5*log(tempF3-tempF1*tempF1))
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      j=0
      do i=1,TotYearsHPF
       if(i.gt.150.and.i.lt.TotYearsHPF-150) then
       j=j+1
       outshort1(j,1)=output4HPF(i,8)
       outshort2(j,1)=output4HPF(i,8)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF4=exp(.5*log(tempF3-tempF1*tempF1))
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      j=0
      do i=1,TotYearsHPF
       if(i.gt.150.and.i.lt.TotYearsHPF-150) then
       j=j+1
       outshort1(j,1)=output4HPF(i,8)
       outshort2(j,1)=output1HPF(i,5)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF14,tempF15,tempF16,
     1 tempF17,tempF18,tempF19,tempF20,j)
      tempF21=tempF16-tempF14*tempF15
      write(6,'(A,f11.5,f11.5,f11.5,f11.5,f11.5,f11.5)')
     1 'N   ',tempF11,tempF4,tempF5,tempF21/(tempF4*sigmaY),
     2  sign(1.0,real(tempF12-(tempF1**3.0)))*
     3  abs(tempF12-(tempF1**3.0))**(1.0/3.0),
     4  (tempF13-(tempF1**4.0))**(1.0/4.0)

      j=0
      do i=1,TotYears1
       if(i.gt.100) then
       j=j+1
       outshort1(j,1)=exp(output4(i,6)-output1(i,5))
       outshort2(j,1)=exp(output4(i,6)-output1(i,5))
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF11=tempF1
      tempF4=exp(.5*log(tempF3-tempF1*tempF1))
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      j=0
      do i=1,TotYearsHPF
       if(i.gt.150.and.i.lt.TotYearsHPF-150) then
       j=j+1
       outshort1(j,1)=output4HPF(i,10)
       outshort2(j,1)=output4HPF(i,10)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF4=exp(.5*log(tempF3-tempF1*tempF1))
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      j=0
      do i=1,TotYearsHPF
       if(i.gt.150.and.i.lt.TotYearsHPF-150) then
       j=j+1
       outshort1(j,1)=output4HPF(i,10)
       outshort2(j,1)=output1HPF(i,5)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF14,tempF15,tempF16,
     1 tempF17,tempF18,tempF19,tempF20,j)
      tempF21=tempF16-tempF14*tempF15
      write(6,'(A,f11.5,f11.5,f11.5,f11.5,f11.5,f11.5)')
     1 'Cmp/Y',tempF11,tempF4,tempF5,tempF21/(tempF4*sigmaY),
     2  sign(1.0,real(tempF12-(tempF1**3.0)))*
     3  abs(tempF12-(tempF1**3.0))**(1.0/3.0),
     4  (tempF13-(tempF1**4.0))**(1.0/4.0)

      j=0
      do i=1,TotYears1
       if(i.gt.100) then
       j=j+1
       outshort1(j,1)=exp(output4(i,6)-output1(i,11))
       outshort2(j,1)=exp(output4(i,6)-output1(i,11))
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF11=tempF1
      tempF4=exp(.5*log(tempF3-tempF1*tempF1))
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      j=0
      do i=1,TotYearsHPF
       if(i.gt.150.and.i.lt.TotYearsHPF-150) then
       j=j+1
       outshort1(j,1)=output4HPF(i,6)
       outshort2(j,1)=output4HPF(i,6)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF4=exp(.5*log(tempF3-tempF1*tempF1))
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      j=0
      do i=1,TotYearsHPF
       if(i.gt.150.and.i.lt.TotYearsHPF-150) then
       j=j+1
       outshort1(j,1)=output4HPF(i,6)
       outshort2(j,1)=output1HPF(i,5)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF14,tempF15,tempF16,
     1 tempF17,tempF18,tempF19,tempF20,j)
      tempF21=tempF16-tempF14*tempF15
      write(6,'(A,f11.5,f11.5,f11.5,f11.5,f11.5,f11.5)')
     1 'Cmp ',tempF11,tempF4,tempF5,tempF21/(tempF4*sigmaY),
     2  sign(1.0,real(tempF12-(tempF1**3.0)))*
     3  abs(tempF12-(tempF1**3.0))**(1.0/3.0),
     4  (tempF13-(tempF1**4.0))**(1.0/4.0)

      j=0
      do i=1,TotYears1
       if(i.gt.100) then
       j=j+1
       outshort1(j,1)=exp(output4(i,9)-output1(i,11))
       outshort2(j,1)=exp(output4(i,9)-output1(i,11))
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF11=tempF1
      tempF4=exp(.5*log(tempF3-tempF1*tempF1))
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      j=0
      do i=1,TotYearsHPF
       if(i.gt.150.and.i.lt.TotYearsHPF-150) then
       j=j+1
       outshort1(j,1)=output4HPF(i,9)
       outshort2(j,1)=output4HPF(i,9)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF4=exp(.5*log(tempF3-tempF1*tempF1))
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      j=0
      do i=1,TotYearsHPF
       if(i.gt.150.and.i.lt.TotYearsHPF-150) then
       j=j+1
       outshort1(j,1)=output4HPF(i,9) !this is S(t) which is the average wage at t-1
       outshort2(j,1)=output1HPF(i-1,5)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF14,tempF15,tempF16,
     1 tempF17,tempF18,tempF19,tempF20,j)
      tempF21=tempF16-tempF14*tempF15
      write(6,'(A,f11.5,f11.5,f11.5,f11.5,f11.5,f11.5)')
     1 'WgA ',tempF11,tempF4,tempF5,tempF21/(tempF4*sigmaY),
     2  sign(1.0,real(tempF12-(tempF1**3.0)))*
     3  abs(tempF12-(tempF1**3.0))**(1.0/3.0),
     4  (tempF13-(tempF1**4.0))**(1.0/4.0)

      j=0
      do i=1,TotYears1
       if(i.gt.100) then
       j=j+1
       outshort1(j,1)=exp(output4(i,5)-output1(i,11))
       outshort2(j,1)=exp(output4(i,5)-output1(i,11))
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF11=tempF1
      tempF4=exp(.5*log(tempF3-tempF1*tempF1))
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      j=0
      do i=1,TotYearsHPF
       if(i.gt.150.and.i.lt.TotYearsHPF-150) then
       j=j+1
       outshort1(j,1)=output4HPF(i,5)
       outshort2(j,1)=output4HPF(i,5)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF4=exp(.5*log(tempF3-tempF1*tempF1))
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      j=0
      do i=1,TotYearsHPF
       if(i.gt.150.and.i.lt.TotYearsHPF-150) then
       j=j+1
       outshort1(j,1)=output4HPF(i,5)
       outshort2(j,1)=output1HPF(i,5)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF14,tempF15,tempF16,
     1 tempF17,tempF18,tempF19,tempF20,j)
      tempF21=tempF16-tempF14*tempF15
      write(6,'(A,f11.5,f11.5,f11.5,f11.5,f11.5,f11.5)')
     1 'WgS ',tempF11,tempF4,tempF5,tempF21/(tempF4*sigmaY),
     2  sign(1.0,real(tempF12-(tempF1**3.0)))*
     3  abs(tempF12-(tempF1**3.0))**(1.0/3.0),
     4  (tempF13-(tempF1**4.0))**(1.0/4.0)

      j=0
      do i=1,TotYears1
       if(i.gt.100) then
       j=j+1
       outshort1(j,1)=output1(i,5)-output1(i-1,5)
       outshort2(j,1)=output1(i,5)-output1(i-1,5)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF4=exp(.5*log(tempF3-tempF1*tempF1))
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      j=0
      do i=1,TotYearsHPF
       if(i.gt.150.and.i.lt.TotYearsHPF-150) then
       j=j+1
       outshort1(j,1)=output1(i,5)-output1(i-1,5)
       outshort2(j,1)=output1(i,5)-output1(i-1,5)!output1HPF(i,5)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF14,tempF15,tempF16,
     1 tempF17,tempF18,tempF19,tempF20,j)
      tempF21=tempF16-tempF14*tempF15
      write(6,'(A,f11.5,f11.5,f11.5,f11.5)')
     1 'dY  ',tempF1,tempF4,tempF5,
     2 tempF21/(sigmaDY*tempF4)

      j=0
      do i=1,TotYears1
       if(i.gt.100) then
       j=j+1
       outshort1(j,1)=output1(i,3)-output1(i-1,3)
       outshort2(j,1)=output1(i,3)-output1(i-1,3)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF4=exp(.5*log(tempF3-tempF1*tempF1))
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      j=0
      do i=1,TotYearsHPF
       if(i.gt.150.and.i.lt.TotYearsHPF-150) then
       j=j+1
       outshort1(j,1)=output1(i,3)-output1(i-1,3)
       outshort2(j,1)=output1(i,5)-output1(i-1,5)!output1HPF(i,5)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF14,tempF15,tempF16,
     1 tempF17,tempF18,tempF19,tempF20,j)
      tempF21=tempF16-tempF14*tempF15
      write(6,'(A,f11.5,f11.5,f11.5,f11.5)')
     1 'dC  ',tempF1,tempF4,tempF5,
     2 tempF21/(sigmaDY*tempF4)

      j=0
      do i=1,TotYears1
       if(i.gt.100) then
       j=j+1
       outshort1(j,1)=output1(i,4)-output1(i-1,4)
       outshort2(j,1)=output1(i,4)-output1(i-1,4)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF4=exp(.5*log(tempF3-tempF1*tempF1))
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      j=0
      do i=1,TotYearsHPF
       if(i.gt.150.and.i.lt.TotYearsHPF-150) then
       j=j+1
       outshort1(j,1)=output1(i,4)-output1(i-1,4)
       outshort2(j,1)=output1(i,5)-output1(i-1,5)!output1HPF(i,5)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF14,tempF15,tempF16,
     1 tempF17,tempF18,tempF19,tempF20,j)
      tempF21=tempF16-tempF14*tempF15
      write(6,'(A,f11.5,f11.5,f11.5,f11.5,f11.5,f11.5)')
     1 'dI  ',tempF1,tempF4,tempF5,
     2 tempF21/(sigmaDY*tempF4),
     2  sign(1.0,real(tempF12-(tempF1**3.0)))*
     3  abs(tempF12-(tempF1**3.0))**(1.0/3.0),
     4  (tempF13-(tempF1**4.0))**(1.0/4.0)

      j=0
      do i=1,TotYears1
       if(i.gt.100) then
       j=j+1
       outshort1(j,1)=output1(i,2)-output1(i,5)
       outshort2(j,1)=output1(i,2)-output1(i,5)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF4=exp(.5*log(tempF3-tempF1*tempF1))
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      j=0
      do i=1,TotYearsHPF
       if(i.gt.150.and.i.lt.TotYearsHPF-150) then
       j=j+1
       outshort1(j,1)=output1(i,2)-output1(i,5)
       outshort2(j,1)=output1HPF(i,5)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF14,tempF15,tempF16,
     1 tempF17,tempF18,tempF19,tempF20,j)
      tempF21=tempF16-tempF14*tempF15
      write(6,'(A,f11.5,f11.5,f11.5,f11.5,f11.5,f11.5)')
     1 'K/Y ',exp(tempF1),tempF4,tempF5,tempF21/(sigmaY*tempF4),
     2  sign(1.0,real(tempF12-(tempF1**3.0)))*
     3  abs(tempF12-(tempF1**3.0))**(1.0/3.0),
     4  (tempF13-(tempF1**4.0))**(1.0/4.0)

      j=0
      do i=1,TotYears1
       if(i.gt.100) then
       j=j+1
       outshort1(j,1)=outputRatios(i,3)!exp(output1(i,4)-output1(i,2))
       outshort2(j,1)=outputRatios(i,3)!exp(output1(i,4)-output1(i,2))
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF4=exp(.5*log(tempF3-tempF1*tempF1))
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      j=0
      do i=1,TotYearsHPF
       if(i.gt.150.and.i.lt.TotYearsHPF-150) then
       j=j+1
       outshort1(j,1)=outputRatios(i,3)!output1(i,4)-output1(i,2)
       outshort2(j,1)=output1HPF(i,5)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF14,tempF15,tempF16,
     1 tempF17,tempF18,tempF19,tempF20,j)
      tempF21=tempF16-tempF14*tempF15
      write(6,'(A,f11.5,f11.5,f11.5,f11.5,f11.5,f11.5)')
     1 'I/K ',tempF1,tempF4,tempF5,tempF21/(sigmaY*tempF4),
     2  sign(1.0,real(tempF12-(tempF1**3.0)))*
     3  abs(tempF12-(tempF1**3.0))**(1.0/3.0),
     4  (tempF13-(tempF1**4.0))**(1.0/4.0)

      j=0
      do i=1,TotYears1
       if(i.gt.100) then
       j=j+1
       outshort1(j,1)=outputRatios(i,2)!output1(i,4)-output1(i,5)
       outshort2(j,1)=outputRatios(i,2)!output1(i,4)-output1(i,5)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF4=exp(.5*log(tempF3-tempF1*tempF1))
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      j=0
      do i=1,TotYearsHPF
       if(i.gt.150.and.i.lt.TotYearsHPF-150) then
       j=j+1
       outshort1(j,1)=outputRatios(i,2)!output1(i,4)-output1(i,5)
       outshort2(j,1)=output1HPF(i,5)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF14,tempF15,tempF16,
     1 tempF17,tempF18,tempF19,tempF20,j)
      tempF21=tempF16-tempF14*tempF15
      write(6,'(A,f11.5,f11.5,f11.5,f11.5,f11.5,f11.5)')
     1 'I/Y ',tempF1,tempF4/tempF1,tempF5,tempF21/(sigmaY*tempF4),
     2  sign(1.0,real(tempF12-(tempF1**3.0)))*
     3  abs(tempF12-(tempF1**3.0))**(1.0/3.0),
     4  (tempF13-(tempF1**4.0))**(1.0/4.0)

      j=0
      do i=1,TotYears1
       if(i.gt.100.and.output1(i,8).gt.-10000.0) then
       j=j+1
       outshort1(j,1)=outputRatios(i,1)  !output1(i,7)-output1(i,8)
       outshort2(j,1)=outputRatios(i,1)  !output1(i,7)-output1(i,8)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF4=exp(.5*log(tempF3-tempF1*tempF1))
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      j=0
      tempR1=0
      do i=1,TotYearsHPF
       if(i.gt.150.and.i.lt.TotYearsHPF-150) then
       j=j+1
       outshort1(j,1)=outputRatios(i,1)!output1(i,7)-output1(i,8)
       outshort2(j,1)=output1HPF(i,5)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF14,tempF15,tempF16,
     1 tempF17,tempF18,tempF19,tempF20,j)
      tempF21=tempF16-tempF14*tempF15
      write(6,'(A,f11.5,f11.5,f11.5,f11.5,f11.5)')
     1 'P/D ',tempF1,tempF4,tempF5,tempF21/(sigmaY*tempF4)

      j=0
      do i=1,TotYears1
       if(i.gt.100.and.output1(i,8).gt.-10000.0) then
       j=j+1
       outshort1(j,1)=output4(i,25)
       outshort2(j,1)=output4(i,25)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF4=exp(.5*log(tempF3-tempF1*tempF1))
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      write(6,'(A,f11.5,f11.5,f11.5)')
     1 'Ct/I',tempF1,tempF4,tempF5

      j=0
      do i=1,TotYears1
       if(i.gt.100.and.output1(i,8).gt.-10000.0) then
       j=j+1
       outshort1(j,1)=exp(output1(i,25)-output1(i,5))/
     1                exp(output1(i-1,25)-output1(i-1,5))
       outshort2(j,1)=exp(output1(i,25)-output1(i,5))/
     1                exp(output1(i-1,25)-output1(i-1,5))
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF11=tempF1
      j=0
      do i=1,TotYears1
       if(i.gt.100.and.output1(i,8).gt.-10000.0) then
       j=j+1
       outshort1(j,1)=output1(i,25)-output1(i-1,25)
       outshort2(j,1)=output1(i,25)-output1(i-1,25)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF4=exp(.5*log(tempF3-tempF1*tempF1))
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      j=0
      do i=1,TotYears1
       if(i.gt.150.and.i.lt.TotYearsHPF-150) then
       j=j+1
       outshort1(j,1)=output1(i,25)-output1(i-1,25)
       outshort2(j,1)=output1(i,5)-output1(i-1,5)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF14,tempF15,tempF16,
     1 tempF17,tempF18,tempF19,tempF20,j)
      tempF21=tempF16-tempF14*tempF15
      write(6,'(A,f11.5,f11.5,f11.5,f11.5,f11.5)')
     1 'dOpP',tempF1,tempF4,tempF5,tempF21/(sigmaDY*tempF4)
      j=0
      do i=1,TotYearsHPF
       if(i.gt.100.and.output1(i,8).gt.-10000.0) then
       j=j+1
       outshort1(j,1)=output4(i,2)
       outshort2(j,1)=output4(i,2)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF11=tempF1
      j=0
      do i=1,TotYearsHPF
       if(i.gt.100.and.output1(i,8).gt.-10000.0) then
       j=j+1
       outshort1(j,1)=output1HPF(i,25)
       outshort2(j,1)=output1HPF(i,25)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF4=exp(.5*log(tempF3-tempF1*tempF1))
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      j=0
      do i=1,TotYearsHPF
       if(i.gt.150.and.i.lt.TotYearsHPF-150) then
       j=j+1
       outshort1(j,1)=output1HPF(i,25)
       outshort2(j,1)=output1HPF(i,5)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF14,tempF15,tempF16,
     1 tempF17,tempF18,tempF19,tempF20,j)
      tempF21=tempF16-tempF14*tempF15
      write(6,'(A,f11.5,f11.5,f11.5,f11.5,f11.5)')
     1 'OpP ',tempF11,tempF4,tempF5,tempF21/(sigmaY*tempF4)
      j=0
      do i=1,TotYears1
       if(i.gt.100.and.output1(i,8).gt.-10000.0) then
       j=j+1
       outshort1(j,1)=exp(output1(i,8)-output1(i,5))/
     1                exp(output1(i-1,8)-output1(i-1,5))
       outshort2(j,1)=exp(output1(i,8)-output1(i,5))/
     1                exp(output1(i-1,8)-output1(i-1,5))
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF11=tempF1
      j=0
      do i=1,TotYears1
       if(i.gt.100.and.output1(i,8).gt.-10000.0) then
       j=j+1
       outshort1(j,1)=output1(i,8)-output1(i-1,8)
       outshort2(j,1)=output1(i,8)-output1(i-1,8)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF4=exp(.5*log(tempF3-tempF1*tempF1))
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      j=0
      do i=1,TotYears1
       if(i.gt.150.and.i.lt.TotYearsHPF-150) then
       j=j+1
       outshort1(j,1)=output1(i,8)-output1(i-1,8)
       outshort2(j,1)=output1(i,5)-output1(i-1,5)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF14,tempF15,tempF16,
     1 tempF17,tempF18,tempF19,tempF20,j)
      tempF21=tempF16-tempF14*tempF15
      write(6,'(A,f11.5,f11.5,f11.5,f11.5,f11.5)')
     1 'dDIV',tempF11,tempF4,tempF5,tempF21/(sigmaDY*tempF4)
      j=0
      do i=1,TotYearsHPF
       if(i.gt.100.and.output1(i,8).gt.-10000.0) then
       j=j+1
       outshort1(j,1)=output4(i,7)
       outshort2(j,1)=output4(i,7)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF11=tempF1
      j=0
      do i=1,TotYearsHPF
       if(i.gt.100.and.output1(i,8).gt.-10000.0) then
       j=j+1
       outshort1(j,1)=output1HPF(i,8)
       outshort2(j,1)=output1HPF(i,8)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF4=exp(.5*log(tempF3-tempF1*tempF1))
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      j=0
      do i=1,TotYearsHPF
       if(i.gt.150.and.i.lt.TotYearsHPF-150) then
       j=j+1
       outshort1(j,1)=output1HPF(i,8)
       outshort2(j,1)=output1HPF(i,5)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF14,tempF15,tempF16,
     1 tempF17,tempF18,tempF19,tempF20,j)
      tempF21=tempF16-tempF14*tempF15
      write(6,'(A,f11.5,f11.5,f11.5,f11.5,f11.5)')
     1 'DIV ',tempF11,tempF4,tempF5,tempF21/(sigmaY*tempF4)
      j=0
      do i=1,TotYears1
       if(i.gt.100) then
       j=j+1
       outshort1(j,1)=exp(output1(i,6)-output1(i,2))
       outshort2(j,1)=exp(output1(i,6)-output1(i,2))
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF4=(tempF3-tempF1*tempF1)**0.5
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      j=0
      do i=1,TotYearsHPF
       if(i.gt.150.and.i.lt.TotYearsHPF-150) then
       j=j+1
       outshort1(j,1)=exp(output1(i,6)-output1(i,2))
       outshort2(j,1)=output1(i,5)-output1(i-1,5)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF14,tempF15,tempF16,
     1 tempF17,tempF18,tempF19,tempF20,j)
      tempF21=tempF16-tempF14*tempF15
      write(6,'(A,f11.5,f11.5,f11.5,f11.5,f11.5,f11.5)')
     1 'D/K ',tempF1,tempF4,tempF5,tempF21/(sigmaDY*tempF4),
     2  sign(1.0,real(tempF12-(tempF1**3.0)))*
     3  abs(tempF12-(tempF1**3.0))**(1.0/3.0),
     4  (tempF13-(tempF1**4.0))**(1.0/4.0)
      j=0
      do i=1,TotYears1
       if(i.gt.100) then
       j=j+1
       outshort1(j,1)=exp(output1(i,6)-output1(i,7))
       outshort2(j,1)=exp(output1(i,6)-output1(i,7))
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF4=(tempF3-tempF1*tempF1)**0.5
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      j=0
      do i=1,TotYearsHPF
       if(i.gt.150.and.i.lt.TotYearsHPF-150) then
       j=j+1
       outshort1(j,1)=exp(output1(i,6)-output1(i,7))
       outshort2(j,1)=output1(i,5)-output1(i-1,5)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF14,tempF15,tempF16,
     1 tempF17,tempF18,tempF19,tempF20,j)
      tempF21=tempF16-tempF14*tempF15
      write(6,'(A,f11.5,f11.5,f11.5,f11.5,f11.5,f11.5)')
     1 'D/V ',tempF1,tempF4,tempF5,tempF21/(sigmaDY*tempF4),
     2  sign(1.0,real(tempF12-(tempF1**3.0)))*
     3  abs(tempF12-(tempF1**3.0))**(1.0/3.0),
     4  (tempF13-(tempF1**4.0))**(1.0/4.0)
      j=0
      do i=1,TotYears1
       if(i.gt.100) then
       j=j+1
       outshort1(j,1)=output1(i,17)
       outshort2(j,1)=output1(i,17)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF4=(tempF3-tempF1*tempF1)**0.5
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      j=0
      do i=1,TotYearsHPF
       if(i.gt.150.and.i.lt.TotYearsHPF-150) then
       j=j+1
       outshort1(j,1)=output1(i,17)
       outshort2(j,1)=output1(i,5)-output1(i-1,5)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF14,tempF15,tempF16,
     1 tempF17,tempF18,tempF19,tempF20,j)
      tempF21=tempF16-tempF14*tempF15
      write(6,'(A,f11.5,f11.5,f11.5,f11.5,f11.5,f11.5)')
     1 'Drm ',tempF1,tempF4,tempF5,tempF21/(sigmaDY*tempF4),
     2  sign(1.0,real(tempF12-(tempF1**3.0)))*
     3  abs(tempF12-(tempF1**3.0))**(1.0/3.0),
     4  (tempF13-(tempF1**4.0))**(1.0/4.0)
      j=0
      do i=1,TotYears1
       if(i.gt.100) then
       j=j+1
       outshort1(j,1)=output1(i,20)
       outshort2(j,1)=output1(i,20)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF4=(tempF3-tempF1*tempF1)**0.5
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      j=0
      do i=1,TotYearsHPF
       if(i.gt.150.and.i.lt.TotYearsHPF-150) then
       j=j+1
       outshort1(j,1)=output1(i,20)
       outshort2(j,1)=output1(i,5)-output1(i-1,5)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF14,tempF15,tempF16,
     1 tempF17,tempF18,tempF19,tempF20,j)
      tempF21=tempF16-tempF14*tempF15
      write(6,'(A,f11.5,f11.5,f11.5,f11.5,f11.5,f11.5)')
     1 'Def ',tempF1,tempF4,tempF5,tempF21/(sigmaDY*tempF4),
     2  sign(1.0,real(tempF12-(tempF1**3.0)))*
     3  abs(tempF12-(tempF1**3.0))**(1.0/3.0),
     4  (tempF13-(tempF1**4.0))**(1.0/4.0)
      j=0
      do i=1,TotYears1
       if(i.gt.100) then
       j=j+1
       outshort1(j,1)=output1(i,23)-output1(i,24)
       outshort2(j,1)=output1(i,23)-output1(i,24)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempF4=(tempF3-tempF1*tempF1)**0.5
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      j=0
      do i=1,TotYearsHPF
       if(i.gt.150.and.i.lt.TotYearsHPF-150) then
       j=j+1
       outshort1(j,1)=output1(i,23)-output1(i,24)
       outshort2(j,1)=output1(i,5)-output1(i-1,5)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF14,tempF15,tempF16,
     1 tempF17,tempF18,tempF19,tempF20,j)
      tempF21=tempF16-tempF14*tempF15
      write(6,'(A,f11.5,f11.5,f11.5,f11.5,f11.5,f11.5)')
     1 'CS  ',tempF1,tempF4,tempF5,tempF21/(sigmaDY*tempF4),
     2  sign(1.0,real(tempF12-(tempF1**3.0)))*
     3  abs(tempF12-(tempF1**3.0))**(1.0/3.0),
     4  (tempF13-(tempF1**4.0))**(1.0/4.0)



      j=0
      do i=1,TotYears1
       if(i.gt.100) then
       j=j+1
       outshort1(j,1)=output1(i-1,14)*output1(i,10)-1.0
       outshort2(j,1)=output1(i-1,14)*output1(i,10)-1.0
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      errF=tempF1
      j=0
      do i=1,TotYears1
       if(i.gt.100) then
       j=j+1
       outshort1(j,1)=output1(i,10)
       outshort2(j,1)=output1(i,10)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      tempR1=1.0/tempF1
      write(6,'(a,f9.5,a,f9.5)')
     1 'Asset Pricing: E[M]^-1',tempR1,' E[MRf-1]=',errF
      write(6,*) '       K    V/K   E[R-Rf]  StD[R-Rf]   AC[R]   E[MR-1]
     1   SR     a      b'
      j=0
      do i=1,TotYears1
       if(i.gt.100) then
       j=j+1
       outshort1(j,1)=output1(i-1,14)*output1(i,10)-1.0
       outshort2(j,1)=output1(i-1,14)*output1(i,10)-1.0
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      errF=tempF1
      j=0
      do i=1,TotYears1
       if(i.gt.100) then
       j=j+1
       outshort1(j,1)=output1(i,14)
       outshort2(j,1)=output1(i,14)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      Rf=tempF1
      tempF4=exp(.5*log(tempF3-tempF1*tempF1))
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      write(6,'(A,f9.5,f9.5,f9.5,f9.5)')
     1 'Rf                ',Rf-1,tempF4,tempF5,
     2 errF

      do t=1,10000
       Ytemp(t,1)=0
       Xtemp(t,1)=0
       Xtemp(t,2)=0
       Xtemp(t,3)=0
       Xtemp(t,4)=0
       Xtemp(t,5)=0
      end do
      i=0
      do t=1,TotYears1-1
       if(t.gt.10.and.i.lt.10000) then
        i=i+1
        Ytemp(i,1)=output1(t,18)-output1(t-1,14)
        Xtemp(i,1)=1.0
        Xtemp(i,2)=output1(t,9)-output1(t-1,14)
        Xtemp(i,3)=0!output1(t,2)*output1(t,2)
        Xtemp(i,4)=0
        Xtemp(i,5)=0
       end if
      end do
      call regress(Ytemp,Xtemp,10000,i,5,2,coefs,tempF1)
      j=0
      do i=1,TotYears1
       if(i.gt.100) then
       j=j+1
       outshort1(j,1)=output1(i,18)*output1(i,10)-1.0
       outshort2(j,1)=output1(i,18)*output1(i,10)-1.0
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      err=tempF1
      j=0
      do i=1,TotYears1
       if(i.gt.100) then
       j=j+1
       outshort1(j,1)=output1(i,18)-output1(i-1,14)
       outshort2(j,1)=output1(i,18)-output1(i-1,14)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      Rk=tempF1
      tempF4=exp(.5*log(tempF3-tempF1*tempF1))
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      write(6,'(A,f9.5,f9.5,f9.5,f9.5,f8.4,f7.3,f7.3)')
     1 'Rdrf              ',Rk,tempF4,tempF5,err,
     2 (Rk-(err-errF))/tempF4,coefs(1),coefs(2)


      do t=1,10000
       Ytemp(t,1)=0
       Xtemp(t,1)=0
       Xtemp(t,2)=0
       Xtemp(t,3)=0
       Xtemp(t,4)=0
       Xtemp(t,5)=0
      end do
      i=0
      do t=1,TotYears1-1
       if(t.gt.10.and.i.lt.10000) then
        i=i+1
        Ytemp(i,1)=output1(t,15)-output1(t-1,14)
        Xtemp(i,1)=1.0
        Xtemp(i,2)=output1(t,9)-output1(t-1,14)
        Xtemp(i,3)=0!output1(t,2)*output1(t,2)
        Xtemp(i,4)=0
        Xtemp(i,5)=0
       end if
      end do
      call regress(Ytemp,Xtemp,10000,i,5,2,coefs,tempF1)
      j=0
      do i=1,TotYears1
       if(i.gt.100) then
       j=j+1
       outshort1(j,1)=output1(i,15)*output1(i,10)-1.0
       outshort2(j,1)=output1(i,15)*output1(i,10)-1.0
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      err=tempF1
      j=0
      do i=1,TotYears1
       if(i.gt.100) then
       j=j+1
       outshort1(j,1)=output1(i,15)-output1(i-1,14)
       outshort2(j,1)=output1(i,15)-output1(i-1,14)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      Rk=tempF1
      tempF4=exp(.5*log(tempF3-tempF1*tempF1))
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      write(6,'(A,f9.5,f9.5,f9.5,f9.5,f8.4,f7.3,f7.3)')
     1 'Rd                ',Rk,tempF4,tempF5,err,
     2 (Rk-(err-errF))/tempF4,coefs(1),coefs(2)

      do t=1,10000
       Ytemp(t,1)=0
       Xtemp(t,1)=0
       Xtemp(t,2)=0
       Xtemp(t,3)=0
       Xtemp(t,4)=0
       Xtemp(t,5)=0
      end do
      i=0
      do t=1,TotYears1-1
       if(t.gt.10.and.i.lt.10000) then
        i=i+1
        Ytemp(i,1)=output1(t,9)-output1(t-1,14)
        Xtemp(i,1)=1.0
        Xtemp(i,2)=output1(t,9)-output1(t-1,14)
        Xtemp(i,3)=0!output1(t,2)*output1(t,2)
        Xtemp(i,4)=0
        Xtemp(i,5)=0
       end if
      end do
      call regress(Ytemp,Xtemp,10000,i,5,2,coefs,tempF1)
      j=0
      tempR1=0
      do i=1,TotYears1
       if(i.gt.100) then
       j=j+1
       outshort1(j,1)=output1(i,10)*output1(i,9)-1.0
       outshort2(j,1)=output1(i,10)*output1(i,9)-1.0
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      err=tempF1
      j=0
      do i=1,TotYears1
       if(i.gt.100) then
       j=j+1
       outshort1(j,1)=exp(output1(i,2)-output1(i,11))
       outshort2(j,1)=exp(output1(i,2)-output1(i,11))
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      K=tempF1
      j=0
      tempR1=0
      do i=1,TotYears1
       if(i.gt.100) then
       j=j+1
       !outshort1(j,1)=exp(output1(i,7)-output1(i,2))
       !outshort2(j,1)=exp(output1(i,7)-output1(i,2))
       outshort1(j,1)=output1(i,19)/exp(output1(i,2)-output1(i,11))
       outshort2(j,1)=output1(i,19)/exp(output1(i,2)-output1(i,11))
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      ValAll=tempF1
      tempF4=exp(.5*log(tempF3-tempF1*tempF1))
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      j=0
      do i=1,TotYears1
       if(i.gt.100) then
       j=j+1
       outshort1(j,1)=output1(i,9)-output1(i-1,14)
       outshort2(j,1)=output1(i,9)-output1(i-1,14)
       end if
      end do
      call summarystats(outshort1,outshort2,tempF1,tempF2,tempF3,
     1 tempF9,tempF10,tempF12,tempF13,j)
      Rk=tempF1
      tempF4=exp(.5*log(tempF3-tempF1*tempF1))
      tempF5=(tempF9-tempF1*tempF1)/(tempF4*tempF4)
      write(6,'(A,f7.3,f7.3,f9.5,f9.5,f9.5,f9.5,f8.4,f7.3,f7.3)')
     1 'All ',K,ValAll,Rk,tempF4,tempF5,err,
     2 (Rk-(err-errF))/tempF4,coefs(1),coefs(2)

      call writedata(BI0,'BI0000.txt',nZagg,1,nZagg,1)
      call writedata(BI1,'BI1000.txt',nZagg,1,nZagg,1)
      call writedata(BI2,'BI2000.txt',nZagg,1,nZagg,1)
      call writedata(BC0,'BC0000.txt',nZagg,1,nZagg,1)
      call writedata(BC1,'BC1000.txt',nZagg,1,nZagg,1)
      call writedata(BC2,'BC2000.txt',nZagg,1,nZagg,1)
      call writedata(BW0,'BW0000.txt',nZagg,1,nZagg,1)
      call writedata(BW1,'BW1000.txt',nZagg,1,nZagg,1)
      call writedata(BW2,'BW2000.txt',nZagg,1,nZagg,1)
      call writedata(meanCold,'meanC0.txt',nAgg,3,nAgg,3)
      call writedata(meanWold,'meanW0.txt',nAgg,3,nAgg,3)
      call writedata(meanIold,'meanI0.txt',nAgg,3,nAgg,3)
      call writedata(meanYold,'meanY0.txt',nAgg,3,nAgg,3)
      call writeoutput(output1,output4,
     1     'output.txt',TotYears1,25,TotYears1,25,50,50)
      call writeoutputInd(outputLaborInd,outputWageInd,
     1 outputSalesInd,outputIntInd,outputPDind,outputPDRFind,
     1 outputDefInd,outputRDind,outputREind,
     1 outputKind,outputVind,outputExpInd,outputPDNRPind,
     1 'outInd.txt',1000,100,1000,100)

      end

!------------------------------------------------------------------------
!this takes in INV(K) and C(K) from simulatoin to calculate Knext(K), J(K), and SDF(K)
!this is identical to RepAgent.f:DP, however there is no choice as optimal consumption
!comes from simulation
      SUBROUTINE DPrepagent(nK,nS,nZagg,nZsr,nZind,nNIlast,deltaKfree,
     1                      psiKshock,mu0shock,GDPmult,Ngrid,iZlastGrid)
      implicit none
      integer nK,nS,nZagg,nZsr,nZind,nAgg,t,TotYears,nNIlast
      parameter (TotYears=5000)
      integer i,j,iK,iZ,iAgg,iZnext,iKtemp,iS,iSnext,iZind,iZiNext
      real Kgrid(nK),Agrid(nZagg,nZsr),Zgrid(nZagg),deltaKfree
      real TrProbAgg(nZagg,nZagg),TrProbInd(nZind,nZind),ZIgrid(nZind)
      real beta1,theta,eis,deltaK,psiK,psiK0,growth,v1P,v1N,FixedCost
      real K,Y,C,Knext,INV,Labor,Costs,Ktemp,Cnext,INVnext,multK
      real S,Snext,multS,tempC,mu0,psiKshock(nZagg),psiKnext,GDPmult
      real tempR1,tempR2,tempR3,tempR4,tempR5,tempR6,tempR7,tempR8
      integer tempI1,tempI2,tempI3,tempI4,tempI5
      integer iKnext,iNext,iZlastGrid(nZagg)
      integer iLL,iLH,iHL,iHH
      real VtempK(nK),DtempK(nK),DerivsAllK(nK*nS*nZagg)
      real V(nK*nS*nZagg,1),Cagg(nK*nS*nZagg),INVgrid(nK*nS*nZagg)
      real RFgrid(nK*nS*nZagg,1),RFinv,CaggNext(nK*nS*nZagg,nZagg)
      integer extrap(2)
      real Knextgrid(nK*nS*nZagg,nZsr),Snextgrid(nK*nS*nZagg,nZsr)
      real Smultgrid(nK*nS*nZagg,nZsr),Kmultgrid(nK*nS*nZagg,nZsr)
      integer Kspotgrid(nK*nS*nZagg,nZsr),Sspotgrid(nK*nS*nZagg,nZsr)
      double precision EVTsdf(nK*nS*nZagg,1),Vsdf(nK*nS*nZagg,1)
      double precision Vmax(nK*nS*nZagg,1),Vnext,EVTtemp
      double precision Utility(nK*nS*nZagg),minval,U
      double precision paramR1,paramR2,paramR3,paramR4
      real SDF(nK*nS*nZagg*nZagg*nZsr,1)
      real SDFold(nK*nS*nZagg*nZagg*nZsr,1)
      integer mytime(3),iAggNext,iZlast,iZSRnext
      real BE0(nZagg),BE1(nZagg),BE2(nZagg),Ngrid(nZagg)
      real BC0(nZagg),BC1(nZagg),BC2(nZagg),BW2(nZagg),Sgrid(nS)
      real BI0(nZagg),BI1(nZagg),BI2(nZagg),BW0(nZagg),BW1(nZagg)
      real Policy(nK*nS*nZagg,1),meanC(nK*nS*nZagg,3),Wage,X
      real MUCgr(nK*nS*nZagg*nZagg*nZsr,1),meanW(nK*nS*nZagg,3)
      real Ulast,Uc,Uclast,mu0shock(nZagg)
      real WageNext,meanI(nK*nS*nZagg,3),TrProbAggSR(nZsr)
      real TrProbCost(nNIlast,nNIlast),meanY(nK*nS*nZagg,3)
      real Q3(nK*nS*nZagg),EMQ3(nK*nS*nZagg),Q3temp(nK*nS*nZagg)
      real Q0(nK*nS*nZagg,nZind),Q1(nK*nS*nZagg,nZind),Q1next,Q0next
      real Q0temp(nK*nS*nZagg,nZind),Q1temp(nK*nS*nZagg,nZind)
      real EMQ0(nK*nS*nZagg,nZind),EMQ1(nK*nS*nZagg,nZind)
      real RTS,CES,xi,EMWP,TrProb
      real lab0,lab1
      real LaborDemand,LaborDemandLast,LaborDemandNext

      Labor=1.0
      nAgg=nZagg*nK*nS
      call readparams(nZagg,nZsr,nZind,nNIlast,beta1,theta,eis,deltaK,
     1     psiK0,RTS,v1P,v1N,FixedCost,growth,Agrid,Zgrid,TrProbAgg,
     2     TrProbAggSR,ZIgrid,TrProbInd,TrProbCost,
     1     lab0,lab1,tempR3,mu0,xi,CES)
      call readdata(BW0,'BW0000.txt',nZagg,1,nZagg,1)
      call readdata(BW1,'BW1000.txt',nZagg,1,nZagg,1)
      call readdata(BW2,'BW2000.txt',nZagg,1,nZagg,1)
      call readdata(BI0,'BI0000.txt',nZagg,1,nZagg,1)
      call readdata(BI1,'BI1000.txt',nZagg,1,nZagg,1)
      call readdata(BI2,'BI2000.txt',nZagg,1,nZagg,1)
      call readdata(BC0,'BC0000.txt',nZagg,1,nZagg,1)
      call readdata(BC1,'BC1000.txt',nZagg,1,nZagg,1)
      call readdata(BC2,'BC2000.txt',nZagg,1,nZagg,1)
      call readdata(SDF,'SDF000.txt',nAgg*nZagg*nZsr,1,
     1              nAgg*nZagg*nZsr,1)
      call readdata(SDFold,'SDF000.txt',nAgg*nZagg*nZsr,1,
     1              nAgg*nZagg*nZsr,1)
      call readdata(Kgrid,'Kgrid0.txt',nK,1,nK,1)
      call readdata(Sgrid,'Sgrid0.txt',nS,1,nS,1)
      call readdata(meanC,'meanC0.txt',nAgg,3,nAgg,3)
      call readdata(meanW,'meanW0.txt',nAgg,3,nAgg,3)
      call readdata(meanI,'meanI0.txt',nAgg,3,nAgg,3)
      call readdata(meanY,'meanY0.txt',nAgg,3,nAgg,3)

      !minval=-((.25*.04)**(2.0*(1.0-9.0)))/((1.0-.96)*.001)
      if(abs(eis-1.0).gt..00001) then
       tempR1=(.0001**(1.0-(1.0/eis)))/(1.0-(1.0/eis))
      else
       tempR1=log(.0001)
      end if
      if(tempR1.gt.0.0) then
       minval=0.0
      else
       minval=tempR1*1000.0
      end if

      paramR1=(1.0-(1.0/eis))/(1.0-theta)
      if(abs((1.0/eis)-theta).lt..00001) paramR1=1.0
      paramR2=1.0/paramR1
      paramR3=(1.0-beta1)*(1.0-theta)
      paramR4=(1.0-(1.0/eis))
      if(abs(eis-1.0).lt..00001) paramR4=1.0

      !calculate next year's state given policies (from simulate)
      do iS=1,nS
      do iK=1,nK
      do iZ=1,nZagg
       iAgg=((iS-1)*nK+iK-1)*nZagg+iZ
       iZlast=iZlastGrid(iZ)
       Q0(iAgg,1)=0
       Q1(iAgg,1)=0
       Q3(iAgg)=0
       Q3temp(iAgg)=0
       K=Kgrid(iK)
       S=Sgrid(iS)
       psiK=psiK0*psiKshock(iZ)
       Wage=BW0(iZ)+
     1      BW1(iZ)*(GDPmult*Zgrid(iZ)*(1.0-psiK)*RTS*(K**psiK))+
     1      BW2(iZ)*S
       if(Wage.lt..01) Wage=.01
       Wage=meanW(iAgg,1)
       Y=GDPmult*Zgrid(iZ)*(K**psiK) !note, Y is not necesseraly equal to GDP when heterogenous firms
       if(abs(eis-1.0).gt..00001) then
        !V(iAgg,1)=(2.813*(10.0**10.0))*(K**(1.0-theta))/(1.0-theta)!(Y**(1.0-(1.0/eis)))/(1.0-(1.0/eis))
        V(iAgg,1)=(Y**(1.0-(1.0/eis)))/(1.0-(1.0/eis))
       else
        V(iAgg,1)=log(Y)
       end if
       EVTsdf(iAgg,1)=1.0
       !C=exp(BC0(iZ))*(K**BC1(iZ))*(S**BC2(iZ))
       C=meanC(iAgg,1)
       if(C.lt..001) C=.001
       !tempR1=GDPmult*Zgrid(iZ)*(1.0-psiK)*RTS*(K**psiK)
       INV=meanY(iAgg,1)-C
       !INV=meanI(iAgg,1) !wastecost
       INVgrid(iAgg)=INV

       LaborDemandLast=Ngrid(iZlast)
       LaborDemand=Ngrid(iZ)

       if(LaborDemand.lt.0.9999) then
        tempC=C+lab0*(1.0-LaborDemand)**lab1
       else
        tempC=C+lab0*(1.0-0.9999)**lab1
       end if
       if(tempC.lt..01) tempC=.01
       if(abs(eis-1.0).gt..00001) then
        Utility(iAgg)=(tempC**(1.0-(1.0/eis)))/(1.0-(1.0/eis))
       else
        Utility(iAgg)=log(tempC)
       end if
       if(tempC.lt.0.or.C.lt.0) Utility(iAgg)=minval
       Knext=(1.0-deltaK)*K+INV
       if(Knext.lt..001) Knext=.001


       do iZnext=1,nZagg
       do iZSRnext=1,nZsr
        iNext=(iAgg-1)*nZagg*nZsr+(iZnext-1)*nZsr+iZSRnext
        Ktemp=Knext/(Agrid(iZ,iZSRnext)**RTS)
        psiKnext=psiK0!*psiKshock(iZnext)
        tempR1=GDPmult*(1.0-psiK)*RTS*(K**psiK)
        tempR2=GDPmult*(1.0-psiKnext)*RTS*(Ktemp**psiKnext)

        KnextGrid(iAgg,iZSRnext)=Ktemp
        call findspot(Kgrid,nK,Ktemp,nint(.5*real(nK)),tempI1)
        KspotGrid(iAgg,iZSRnext)=tempI1
        if(Ktemp.lt.0.0) then
         KnextGrid(iAgg,iZSRnext)=.0001*Kgrid(1)
        end if
        Snext=(mu0*mu0shock(iZ)*S*tempR1*LaborDemandLast+
     1         Wage*(LaborDemand-mu0*mu0shock(iZ)*LaborDemandLast))/
     1        ((Agrid(iZ,iZSRnext)**RTS)*tempR2*LaborDemand)
        SnextGrid(iAgg,iZSRnext)=Snext
        call findspot(Sgrid,nS,Snext,iS,iSnext)
        SspotGrid(iAgg,iZSRnext)=iSnext
        multS=(Snext-Sgrid(iSnext))/(Sgrid(iSnext+1)-Sgrid(iSnext))
        if(multS.gt.1.0) multS=1.0
        if(multS.lt.0.0) multS=0.0
        SmultGrid(iAgg,iZSRnext)=multS
        call findspot(Kgrid,nK,Ktemp,iKnext,tempI1)
        multK=(Ktemp-Kgrid(tempI1))/(Kgrid(tempI1+1)-Kgrid(tempI1))
        if(multK.gt.1.0) multK=1.0
        if(multK.lt.0.0) multK=0.0
        KmultGrid(iAgg,iZSRnext)=multK
        iLL=((iSnext-1)*nK+tempI1-1)*nZagg+iZnext
        iLH=iLL+nZagg
        iHL=iLL+nK*nZagg
        iHH=iHL+nZagg
        tempR1=meanC(iLL,1)+multK*(meanC(iLH,1)-meanC(iLL,1))
        tempR2=meanC(iHL,1)+multK*(meanC(iHH,1)-meanC(iHL,1))
        Cnext=tempR1+multS*(tempR2-tempR1)
        if(Cnext.lt..001) Cnext=.001
        tempR1=meanW(iLL,1)+multK*(meanW(iLH,1)-meanW(iLL,1))
        tempR2=meanW(iHL,1)+multK*(meanW(iHH,1)-meanW(iHL,1))
        WageNext=tempR1+multS*(tempR2-tempR1)
        tempR1=GDPmult*Zgrid(iZnext)*
     1        (1.0-psiKnext)*RTS*(Knext**psiKnext)

        LaborDemandNext=Ngrid(iZnext)
        Cagg(iAgg)=C
        CaggNext(iAgg,iZnext)=Cnext
        if(Cnext.lt..01.or.C.le..01) then
         MUCgr(iNext,1)=1.0
        else
         if(LaborDemand.lt.0.9999) then
          Ulast=C+lab0*(1.0-LaborDemand)**lab1
         else
          Ulast=C+lab0*(1.0-0.9999)**lab1
         end if
         if(LaborDemandNext.lt.0.9999) then
          U=Cnext+lab0*(1.0-LaborDemandNext)**lab1
         else
          U=Cnext+lab0*(1.0-0.9999)**lab1
         end if
         Uc=1.0
         Uclast=1.0
         MUCgr(iNext,1)=((U/Ulast)**(-1.0/eis))*(Uc/Uclast)!(Cnext/C)**(-1.0/eis)  !habit w/ C-phi*H
        end if
       end do
       end do
       
      end do
      end do
      end do

      do t=1,TotYears

      do i=1,nAgg
       Vmax(i,1)=minval
       EMQ3(i)=0
      end do

! use Hermite cubic splines to create a vector of derivatives of V with respect to K
! in order to interpolate later
      do iZ=1,nZagg
      do iS=1,nS
       do iK=1,nK
        iAgg=((iS-1)*nK+iK-1)*nZagg+iZ
        VtempK(iK)=V(iAgg,1)
       end do
       tempI1=1
       tempI2=0
       call PCHIM(nK,Kgrid,VtempK,DtempK,tempI1,tempI2)
       do iK=1,nK
        iAgg=((iS-1)*nK+iK-1)*nZagg+iZ
        DerivsAllK(iAgg)=DtempK(iK)
       end do
      end do
      end do

      do iS=1,nS
      do iK=1,nK
       K=Kgrid(iK)
       S=Sgrid(iS)
       do iZ=1,nZagg
        iAgg=((iS-1)*nK+iK-1)*nZagg+iZ
        C=Cagg(iAgg)
        INV=INVgrid(iAgg)
        U=Utility(iAgg)

        Vnext=0.0
        RFinv=0.0
        EMWP=0.0
        do iZnext=1,nZagg
        do iZSRnext=1,nZsr
         TrProb=TrProbAgg(iZ,iZnext)*TrProbAggSR(iZSRnext)
!Use below for iZSRnext perfectly correlated with iZnext (this is the process we have previously used)
!         if(iZSRnext.eq.iZnext) then
!          TrProb=TrProbAgg(iZ,iZnext)
!         else
!          TrProb=0.0
!         end if

         if(TrProb.gt..0001) then

         iNext=(iAgg-1)*nZagg*nZsr+(iZnext-1)*nZsr+iZSRnext
         Ktemp=KnextGrid(iAgg,iZSRnext)
         iKtemp=KspotGrid(iAgg,iZSRnext)
         Snext=SnextGrid(iAgg,iZSRnext)
         iSnext=SspotGrid(iAgg,iZSRnext)
         multS=SmultGrid(iAgg,iZSRnext)
         multK=KmultGrid(iAgg,iZSRnext)
         iLL=((iSnext-1)*nK+iKtemp-1)*nZagg+iZnext
         iLH=iLL+nZagg
         iHL=iLL+nZagg*nK
         iHH=iHL+nZagg
         call CHFEV(Kgrid(iKtemp),Kgrid(iKtemp+1),
     1              V(iLL,1),V(iLH,1),
     2              DerivsAllK(iLL),DerivsAllK(iLH),
     3              1,Ktemp,tempR1,extrap,tempI3)
         if(Ktemp.lt.Kgrid(1)) then
          tempR1=minval+(V(iLL,1)-minval)*(Ktemp-0.0)/(Kgrid(1)-0.0)
         end if
         call CHFEV(Kgrid(iKtemp),Kgrid(iKtemp+1),
     1              V(iHL,1),V(iHH,1),
     2              DerivsAllK(iHL),DerivsAllK(iHH),
     3              1,Ktemp,tempR2,extrap,tempI3)
         if(Ktemp.lt.Kgrid(1)) then
          tempR2=minval+(V(iHL,1)-minval)*(Ktemp-0.0)/(Kgrid(1)-0.0)
         end if
         tempR3=tempR1+multS*(tempR2-tempR1)
         Vnext=Vnext+TrProb*((paramR4*tempR3)**paramR2)*
     1         (Agrid(iZ,iZSRnext)**((1.0-theta)*RTS))     !psiK

!here tempR1=J, Vnext=E[((1-rho)*J)^[(1-theta)/(1-rho)]]
         if(abs(eis-1.0).gt..00001.and.abs(theta-1.0).gt..00001) then
          SDF(iNext,1)=
     1       beta1*MUCgr(iNext,1)*
     2      (Agrid(iZ,iZSRnext)**(-theta*RTS))*
     3      ((tempR3*paramR4)**(((1.0/eis)-theta)/(1.0-(1.0/eis))))*
     4      (EVTsdf(iAgg,1)**((theta-(1.0/eis))/(1.0-theta)))
         else
          SDF(iNext,1)=
     1       beta1*MUCgr(iNext,1)*
     2      (Agrid(iZ,iZSRnext)**(-theta*RTS))
         end if

         RFinv=RFinv+TrProb*SDF(iNext,1)
         tempR1=Q3(iLL)+multK*(Q3(iLH)-Q3(iLL))
         tempR2=Q3(iHL)+multK*(Q3(iHH)-Q3(iHL))
         tempR3=tempR1+multS*(tempR2-tempR1)
         EMQ3(iAgg)=EMQ3(iAgg)+TrProb*SDF(iNext,1)*tempR3
         end if !TrProb
        end do !iZSRnext
        end do  !iZnext

        !paramR1=(1-(1/eis))/(1-theta)
        !paramR2=1/paramR1=(1-theta)/(1-(1/eis))
        !paramR3=(1-beta1)*(1-theta)
        !paramR4=(1-(1/eis))
        !paramR5=(1-psiL)/(1-psiK)

        !EVTtemp=Vnext*((1-beta1)**paramR2) !this is for sdf
        EVTtemp=Vnext  !this is for euler eq w/ Jhat

        Vnext=U+beta1*(1.0/paramR4)*(Vnext**paramR1) !here Vnext=E[J^[(1-theta)/(1-rho)]]
        Q3temp(iAgg)=mu0*(-1.0+EMQ3(iAgg))

!standard formulation:
! V(t)^(1-rho)=(1-beta)*U(t)+beta*E[V(t+1)^(1-theta)]^((1-rho)/(1-theta)) where rho=1/eis
!if you set J(t)=[V(t)^(1-rho)]/[(1-rho)(1-beta)] then this can be rewritten as:
! J(t)=U(t)+beta*E[J(t)^((1-theta)/(1-rho))]^((1-rho)/(1-theta)) where U(t)=[C(t)^(1-rho)]/(1-rho)
!Note that J(t) is monotonically increasing in V(t) as long as beta<1
!However, sometimes J(t) is negative and then raised to a negative power, for this need to go a step back and write as:
!J(t)=U(t)+beta*(1/(1-rho))*E[((1-rho)*J(t))^((1-theta)/(1-rho))]^((1-rho)/(1-theta))
!now whenever rho>1, J(t)<0, so (1-rho)*J(t)>0
!To calculate M(t+1) need E[V(t+1)^(1-theta)]=E[((1-rho)(1-beta)J(t+1))^((1-theta)/(1-rho)))
!this is equal to tempR1*(1-beta)^((1-theta)/(1-rho))
        if(RFinv.gt.0.0) then
         RFgrid(iAgg,1)=1.0/RFinv
        else
         RFgrid(iAgg,1)=1.0
        end if
        Vmax(iAgg,1)=Vnext
        if(abs(eis-1.0).gt..00001.and.abs(theta-1.0).gt..00001) then
         EVTsdf(iAgg,1)=EVTtemp !Et[V^(1-theta)]=E[((1-rho)(1-beta)J(t+1))^((1-theta)/(1-rho)))]
        else
         EVTsdf(iAgg,1)=1.0
        end if
        Vsdf(iAgg,1)=V(iAgg,1) !read above why using V and not Vmax

       end do !iZ

      end do !iK
      end do

      do i=1,nAgg
       V(i,1)=Vmax(i,1)
       Q3(i)=Q3temp(i)
      end do

      if(t.eq.5001) then
      iZ=1
      iS=nint(.51*real(nS))
      do iK=1,nK
       iAgg=((iS-1)*nK+iK-1)*nZagg+iZ
       K=Kgrid(iK)
       psiK=psiK0*psiKshock(iZ)
       Y=GDPmult*Zgrid(iZ)*K**psiK
       write(6,'(i4,f8.4,f8.4,f10.5,f10.5,f20.15)')
     1  iK,K,INVgrid(iAgg),Vmax(iAgg,1),
     2  Vsdf(iAgg,1),1000000000000.0*EVTsdf(iAgg,1)
      end do
      end if

      end do !end t


      tempR1=0.0
      tempR2=0.0
      tempR3=0.0
      do i=1,nAgg*nZagg*nZsr
       tempR1=tempR1+SDF(i,1)-SDFold(i,1)
       tempR2=tempR2+abs(SDF(i,1)-SDFold(i,1))
       if(abs(SDF(i,1)-SDFold(i,1)).gt.tempR3) then
        tempR3=abs(SDF(i,1)-SDFold(i,1))
        iAgg=i
        tempR5=SDF(i,1)
        tempR6=SDFold(i,1)
       end if
      end do
      tempR4=real(nAgg*nZagg*nZsr)
      write(6,'(a,f9.5,a,f9.5,a,f9.5,i7,f9.5,f9.5)')
     1 'dSDF avg ',tempR1/tempR4,' avg abs ',
     1 tempR2/tempR4,' max ',tempR3,iAgg,tempR5,tempR6

      call writedata(Q3,'Q3grid.txt',nAgg,1,nAgg,1)
      call writedata(RFgrid,'RFgrid.txt',nAgg,1,nAgg,1)
      call writedata(V,'value0.txt',nAgg,1,nAgg,1)
      call writedata(SDF,'SDF000.txt',nAgg*nZagg*nZsr,1,
     1               nAgg*nZagg*nZsr,1)
      call writedatadouble(Vsdf,'Vsdf00.txt',nAgg,1,nAgg,1)
      call writedatadouble(EVTsdf,'EVTsdf.txt',nAgg,1,nAgg,1)

      end



!---------------------------------------------
!Increasing sort
      SUBROUTINE SORT(Dist,N,SortIndx)
      implicit none

      integer N,i,tempI1,SortIndx(N)
      real Dist(N),temp

      do i=1,N
       SortIndx(i)=i
      end do
      i=1
      do while(i.lt.N)
1021   continue
       if(Dist(i).le.Dist(i+1)) then
        goto 1022
       else
        temp=Dist(i+1)
        tempI1=SortIndx(i+1)
        Dist(i+1)=Dist(i)
        SortIndx(i+1)=SortIndx(i)
        Dist(i)=temp
        SortIndx(i)=tempI1
        if(i.gt.1) then
         i=i-1
        end if
        goto 1021
       end if
1022   continue
       i=i+1
      end do

      end

!-----------------------------------------------------------
!This writes a matlab file with all relevant data to be read by matlab
!for simulating the model
      SUBROUTINE writematlab(filename,nK,nS,nZagg,Kgrid,policy,V)
       implicit none
       integer iunit,i,j,nK,nZagg,nS
       real policy(nK*nS*nZagg,1),v(nK*nS*nZagg,1)
       real Kgrid(nK)
       character(len=10) filename
       data iunit /14/

       open(unit=iunit,file=filename,status='old',form='FORMATTED')

       write(iunit,*) 'nK=',nK,'nS=',nS,';nZagg=',nZagg,';'
       write(iunit,*) 'Kgrid=['
       do i=1,nK
       write(iunit,*) Kgrid(i)
       end do
       write(iunit,*) '];'
       write(iunit,*) 'policy=['
       do i=1,nK*nS*nZagg
       write(iunit,*) (policy(i,j),j=1,1)
       end do
       write(iunit,*) '];'
       write(iunit,*) 'value=['
       do i=1,nK*nS*nZagg
       write(iunit,*) V(i,1)
       end do
       write(iunit,*) '];'

       close(iunit)

       end
!-------------------------------------------------------------------
!This reads the relevant parameters
      SUBROUTINE readparams(nZagg,nZsr,nZind,nNIlast,beta1,theta,eis,
     1      deltaK,psiK,psiL,v1P,v1N,FixedCost,growth,
     1      Agrid,Zgrid,TrProbAgg,TrProbAggSR,
     2      ZIgrid,TrProbInd,TrProbCost,lab0,lab1,lab2,mu0,xi,CES)
      implicit none
      integer nZagg,nZsr,nZind,iunit,i,j,nNIlast
      real beta1,theta,chi,eis,deltaK,psiK,psiL,v1P,v1N,FixedCost
      real growth,TrProbAgg(nZagg,nZagg),Zgrid(nZagg)
      real Agrid(nZagg,nZsr),readZsr(nZsr),TrProbAggSR(nZsr)
      real readnum(13),readZagg(nZagg),readZind(nZind),readnum3(3)
      real TrProbInd(nZind,nZind),ZIgrid(nZind),readCost(nNIlast)
      real TrProbCost(nNIlast,nNIlast)
      real lab0,lab1,lab2,mu0,xi,CES
      data iunit /14/

      open(unit=iunit,file='parameterRA.txt',status='old',
     1     form='FORMATTED')

      read(iunit,*,end=1001) readnum
      beta1=readnum(1)
      theta=readnum(2)
      eis=readnum(3)
      deltaK=readnum(4)
      psiK=readnum(5)
      psiL=readnum(6)
      v1P=readnum(7)
      v1N=readnum(8)
      FixedCost=readnum(9)
      growth=readnum(10)
      mu0=readnum(11)
      xi=readnum(12)
      CES=readnum(13)
      read(iunit,*,end=1001) readZsr
      do j=1,nZsr
       TrProbAggSR(j)=readZsr(j)
      end do
      do i=1,nZagg
       read(iunit,*,end=1001) readZsr
       do j=1,nZsr
        Agrid(i,j)=readZsr(j)
       end do
      end do
      read(iunit,*,end=1001) readZagg
      do i=1,nZagg
       Zgrid(i)=readZagg(i)
      end do
      do i=1,nZagg
       read(iunit,*,end=1001) readZagg
       do j=1,nZagg
        TrProbAgg(i,j)=readZagg(j)
       end do
      end do
      read(iunit,*,end=1001) readZind
      do i=1,nZind
       ZIgrid(i)=readZind(i)
      end do
      do i=1,nZind
       read(iunit,*,end=1001) readZind
       do j=1,nZind
        TrProbInd(i,j)=readZind(j)
       end do
      end do
      read(iunit,*,end=1001) readnum3
      lab0=readnum3(1)
      lab1=readnum3(2)
      lab2=readnum3(3)
!      do i=1,nNIlast
!       read(iunit,*,end=1001) readCost
!       do j=1,nNIlast
!        TrProbCost(i,j)=readCost(j)
!       end do
!      end do
      close(iunit)

 1001 continue

      end

!----------------------------------------------------------------
!this reads a nlength by nwidth matrix from the file 'filename'
      SUBROUTINE readdata(arrout,filename,nlength,nwidth,mlength,mwidth)
       implicit none
       integer nlength,iunit,nwidth,i,j,mlength,mwidth
       character(len=10) filename
       real readnum(nwidth)
       real arrout(mlength,mwidth)
       data iunit /10/

       open(unit=iunit,file=filename,status='old',form='FORMATTED')

       do i=1,nlength
        read(iunit,*,end=1011) readnum
        do j=1,nwidth
         arrout(i,j)=readnum(j)
        end do
       end do

 1011  continue

       close(iunit)

       return
       end

!--------------------------------------------------------------
!This writes an ngrid by nwidth matrix to the file 'filename'
      SUBROUTINE writedatabinary(arrout,filename,nlength,nwidth)
       implicit none
       integer nlength,nwidth,iunit
       character(len=10) filename
       real arrout(nlength,nwidth)
       data iunit /11/

       open(unit=iunit,file=filename,status='old',form='UNFORMATTED')
       write(iunit) arrout
       close(iunit)

       end

!--------------------------------------------------------------
!This writes an ngrid by nwidth matrix to the file 'filename'
      SUBROUTINE readdatabinary(arrout,filename,nlength,nwidth)
       implicit none
       integer nlength,nwidth,iunit
       character(len=10) filename
       real arrout(nlength,nwidth)
       data iunit /11/

       open(unit=iunit,file=filename,status='old',form='UNFORMATTED')
       read(iunit) arrout
       close(iunit)
      
       end

!--------------------------------------------------------------
!This writes an ngrid by nwidth matrix to the file 'filename'
      SUBROUTINE writedata(arrout,filename,nlength,nwidth,mlength,
     1 mwidth)
       implicit none
       integer nlength,nwidth,iunit,i,j,mlength,mwidth
       character(len=10) filename
       real arrout(mlength,mwidth)
       data iunit /11/

       open(unit=iunit,file=filename,status='old',form='FORMATTED')

       if(nwidth.ne.12.and.nwidth.ne.8.and.nwidth.ne.6) then
        do i=1,nlength
        write(iunit,*) (arrout(i,j), j=1,nwidth)
        end do
       else
        if(nwidth.eq.8) then
         do i=1,nlength
          write(iunit,'(F10.1,F10.1,F10.1,F10.1,
     1          F13.2,F13.2,F13.2,F13.2)') (arrout(i,j), j=1,nwidth)
         end do
        else
         if(nwidth.eq.6) then
          do i=1,nlength
           write(iunit,'(F11.4,F11.4,F11.4,F11.4,F11.4,f11.4)')
     1           (arrout(i,j), j=1,nwidth)
          end do
         else
          do i=1,nlength
           write(iunit,'(F6.0,F6.0,F6.0,F6.0,F6.0,F6.0,F6.0,F6.0,
     1          F10.2,F10.2,F10.2,F10.2)') (arrout(i,j), j=1,nwidth)
          end do
         end if
        end if
       end if
       close(iunit)

       return
      end
!----------------------------------------------------------------
!this reads a nlength by nwidth matrix from the file 'filename'
      SUBROUTINE readdatadouble(arrout,filename,nlength,nwidth,
     1           mlength,mwidth)
       implicit none
       integer nlength,iunit,nwidth,i,j,mlength,mwidth
       character(len=10) filename
       double precision readnum(nwidth)
       double precision arrout(mlength,mwidth)
       data iunit /10/

       open(unit=iunit,file=filename,status='old',form='FORMATTED')

       do i=1,nlength
        read(iunit,*,end=1011) readnum
        do j=1,nwidth
         arrout(i,j)=readnum(j)
        end do
       end do
       close(iunit)

 1011  continue

       return
       end
!--------------------------------------------------------------
!This writes an ngrid by nwidth matrix to the file 'filename'
      SUBROUTINE writedatadouble(arrout,filename,nlength,nwidth,mlength,
     1 mwidth)
       implicit none
       integer nlength,nwidth,iunit,i,j,mlength,mwidth
       character(len=10) filename
       double precision arrout(mlength,mwidth)
       data iunit /11/

       open(unit=iunit,file=filename,status='old',form='FORMATTED')

       if(nwidth.ne.12.and.nwidth.ne.8) then
        do i=1,nlength
        write(iunit,*) (arrout(i,j), j=1,nwidth)
        end do
       else
        if(nwidth.eq.8) then
         do i=1,nlength
          write(iunit,'(F10.1,F10.1,F10.1,F10.1,
     1          F13.2,F13.2,F13.2,F13.2)') (arrout(i,j), j=1,nwidth)
         end do
        else
         do i=1,nlength
          write(iunit,'(F6.0,F6.0,F6.0,F6.0,F6.0,F6.0,F6.0,F6.0,
     1         F10.2,F10.2,F10.2,F10.2)') (arrout(i,j), j=1,nwidth)
         end do
        end if
       end if
       close(iunit)

       return
      end
!-------------------------------------------------------------------
      SUBROUTINE findspot(Kgrid,nK,Knext,iK,iKnext)
      implicit none
      integer nK,iK,iKnext,i
      real Knext,Kgrid(nK)

      if(Knext.lt.Kgrid(iK)) then
       do i=0,iK-1
        if(Knext.lt.Kgrid(iK-i)) then
         iKnext=iK-i-1
        else
         goto 101
        end if
       end do
 101   continue
       if(iKnext.lt.1) iKnext=1
      else
       if(iK.eq.nK) then
        iKnext=nK-1
        goto 102
       end if
       do i=iK,nK-1
        if(Knext.ge.Kgrid(i)) then
         iKnext=i
        else
         goto 102
        end if
       end do
 102   continue
      end if

      end
!-------------------------------------------------------------
      SUBROUTINE summarystats(X,Y,meanX,meanY,meanXY,meanXXL,
     1 meanYYL,meanXXX,meanXXXX,T)
      implicit none
      integer i,j,T
      real X(T,1),Y(T,1)
      double precision meanX,meanY,meanXY,meanXXL,meanYYL
      double precision meanXXX,meanYYY,meanXXXX,meanYYYY

      meanX=0
      meanY=0
      meanXY=0
      meanXXL=0
      meanYYL=0
      meanXXX=0.0
      meanXXXX=0.0
      do i=5,T-5
       meanX=meanX+(X(i,1)/real(T-9.0))
       meanY=meanY+(Y(i,1)/real(T-9.0))
       meanXY=meanXY+(X(i,1)*Y(i,1)/real(T-9.0))
       meanXXL=meanXXL+(X(i,1)*X(i+1,1))/real(T-9.0)
       meanYYL=meanYYL+(Y(i,1)*Y(i+1,1))/real(T-9.0)
       meanXXX=meanXXX+((X(i,1)**3.0)/real(T-9.0))
       meanXXXX=meanXXXX+((X(i,1)**4.0)/real(T-9.0))
      end do



      end

!-------------------------------------------------------------
!      This subroutine takes the product of two matricies
!      A is NxM, B is MxL
      SUBROUTINE matmult(A,B,C,N,M,L)
      implicit none
      integer N,M,L,i,j,k
      double precision A(N,M),B(M,L),C(N,L),s

      do i=1,N
      do j=1,L
       s=0
       do k=1,M
        s=s+A(i,k)*B(k,j)
       end do
       C(i,j)=s
      end do
      end do

      end

!--------------------------------------------------------------
      SUBROUTINE transpos(A,At,N,M)
      implicit none
      integer N,M,i,j
      double precision A(N,M),At(M,N)

      do i=1,N
      do j=1,M
       At(j,i)=A(i,j)
       !write(6,*) i,j,At(j,i)
      end do
      end do

      end
!--------------------------------------------------------------
!this regresses Y on X, B=((X'X)^-1)*(X'Y)
      SUBROUTINE regress(Y0,X0,T0,T,N0,N,B0,rsq)
      implicit none
      integer T0,T,N,N0,i,j,Indx(N),lwork
      real X0(T0,N0),Y0(T0,1)
      double precision X(T,N),Y(T,1),Xt(N,T),XX(N,N),XXi(N,N)
      double precision B(1,N),Bt(N,1),XY(N,1)
      !real Ypred(T,1)
      real B0(N0,1)
      real Ymean,s1,s2,tempR1
      double precision rsq,work(2*N)

      lwork=2*N
      do i=1,T
       Y(i,1)=Y0(i,1)
       do j=1,N
        X(i,j)=X0(i,j)
       end do
      end do
      call transpos(X,Xt,T,N)
      call matmult(Xt,X,XX,N,T,N)

      do i=1,N
       do j=1,N
        XXi(i,j)=XX(i,j)
       end do
      end do
      !if(N.le.3) then
      ! call inverse(XX,XXi,N)
      !else
       !call migs(XX,N,XXi,Indx)

       call DGETRF(N,N,XXi,N,Indx,i)
       call DGETRI(N,XXi,N,Indx,WORK,LWORK,i)
      !end if
      call matmult(Xt,Y,XY,N,T,1)
      call matmult(XXi,XY,B,N,N,1)

      !this does Rsq
      Ymean=0
      s1=0
      s2=0
      !call transpos(B,Bt,N,1)
      !call matmult(X,Bt,Ypred,T,N,1)

      do i=1,T
       Ymean=Y(i,1)+Ymean
      end do
      Ymean=Ymean/real(T)
      do i=1,T
       tempR1=0
       do j=1,N
        tempR1=tempR1+X(i,j)*B(1,j)
       end do
       s1=s1+(Y(i,1)-tempR1)*(Y(i,1)-tempR1)
       s2=s2+(Y(i,1)-Ymean)*(Y(i,1)-Ymean)
      end do
      rsq=1-(s1/s2)
      do i=1,N
       B0(i,1)=B(1,i)
      end do

!      write(6,*) 'works 7'
!      write(6,*) rsq


      end

!--------------------------------------------------------------
!this takes in a matrix of size (T,N), it then HP filters just the part
!starting at T1 and ending (including) T2
      subroutine HPfilter(T,N,T1,T2,Lambda,datain,dataout)
      implicit none
      integer T,TF,T1,T2,i,j,k,LWORK,N,Indx(T2-T1+1)
      real Lambda,S
      real datain(T,N),dataout(T2-T1+1,N),datainSmooth(T2-T1+1,N)
      double precision X(1000,1000),WORK(2*1000)

      lwork=2*1000
      TF=T2-T1+1
      do i=1,TF
      do j=1,TF
       X(i,j)=0.0
      end do
      end do

      do i=1,TF
       X(i,i)=(1-6*Lambda)
       if(i-2.gt.0) then
        X(i,i-2)=-Lambda
       end if
       if(i-1.gt.0) then
        X(i,i-1)=4*Lambda
       end if
       if(i+1.le.TF) then
        X(i,i+1)=4*Lambda
       end if
       if(i+2.le.TF) then
        X(i,i+2)=-Lambda
       end if
      end do

      call DGETRF(TF,TF,X,TF,Indx,i)
      call DGETRI(TF,X,TF,Indx,WORK,LWORK,i)

      do k=1,N
      do i=1,TF
       S=0
       do j=1,TF
! 11th column of output is TFP so need to reconstruct growth model data before HP filtering
        S=S+datain(T1-1+j,k)*real(X(i,j))
       end do
       datainSmooth(i,k)=S
       dataout(i,k)=datain(T1-1+i,k)-datainSmooth(i,k)
      end do
      end do

      end



!-------------------------------------------
      subroutine inverse(arrayin,arrayout,N)
      implicit none
      integer N,i
      double precision arrayin(N,N),arrayout(N,N),tempR1,tempR2

      if(N.eq.2) then
       tempR1=arrayin(1,2)*arrayin(1,2)-arrayin(1,1)*arrayin(2,2)
       arrayout(1,1)=-arrayin(2,2)/tempR1
       arrayout(1,2)=arrayin(2,1)/tempR1
       arrayout(2,1)=arrayin(1,2)/tempR1
       arrayout(2,2)=arrayin(1,1)/tempR1
      end if
      if(N.eq.3) then
       tempR1=(arrayin(2,3)*arrayin(1,3)-arrayin(3,3)*arrayin(1,2))/
     1        (arrayin(2,3)*arrayin(1,2)-arrayin(2,2)*arrayin(1,3))
       tempR2=(arrayin(2,2)*arrayin(3,3)-arrayin(2,3)*arrayin(2,3))/
     1        (arrayin(2,3)*arrayin(1,2)-arrayin(2,2)*arrayin(1,3))
       arrayout(1,3)=1/(arrayin(1,3)+tempR2*arrayin(1,1)+
     1               tempR1*arrayin(1,2))
       arrayout(3,1)=arrayout(1,3)
       arrayout(1,1)=arrayout(1,3)*tempR2
       arrayout(1,2)=arrayout(1,3)*tempR1
       arrayout(2,1)=arrayout(1,2)
       arrayout(3,3)=arrayout(1,3)*
     1          (arrayin(2,2)*arrayin(1,1)-arrayin(1,2)*arrayin(1,2))/
     2          (arrayin(2,3)*arrayin(1,2)-arrayin(2,2)*arrayin(1,3))
       arrayout(2,3)=-arrayout(1,3)*(arrayin(1,1)/arrayin(1,2))-
     1                arrayout(3,3)*(arrayin(1,3)/arrayin(1,2))
       arrayout(3,2)=arrayout(2,3)
       arrayout(2,2)=-arrayout(2,3)*(arrayin(1,3)/arrayin(1,2))-
     1                arrayout(1,2)*(arrayin(1,1)/arrayin(1,2))
      end if

      end


!-------------------------------------------------------------------
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      subroutine writeoutput(output1,output4,
     1 filename,nLength,nWidth,nLwrite,nWwrite,nWidth2,nWwrite2)
      implicit none

      integer nLength,nWidth,i,j,iunit,nLwrite,nWwrite,nWidth2,nWwrite2
      integer n
      real output1(nLength,nWidth),output4(nLength,nWidth)
      real outputVal(nLength,nWidth2),outputCr(nLength,nWidth2)
      character(len=10) filename
      character(len=7) tempchar
      data iunit /11/

      open(unit=iunit,file=filename,status='old',form='FORMATTED')

      write(iunit,*) 'temp1=['
      do i=1,nLwrite
      write(iunit,*) (output1(i,j),j=1,5)
      end do
      write(iunit,*) '];'
      write(iunit,*) 'temp2=['
      do i=1,nLwrite
      write(iunit,*) (output1(i,j),j=6,10)
      end do
      write(iunit,*) '];'
      write(iunit,*) 'temp3=['
      do i=1,nLwrite
      write(iunit,*) (output1(i,j),j=11,15)
      end do
      write(iunit,*) '];'
      write(iunit,*) 'temp4=['
      do i=1,nLwrite
      write(iunit,*) (output1(i,j),j=16,20)
      end do
      write(iunit,*) '];'
      write(iunit,*) 'temp5=['
      do i=1,nLwrite
      write(iunit,*) (output1(i,j),j=21,25)
      end do
      write(iunit,*) '];'
      write(iunit,*) 'out1=[temp1 temp2 temp3 temp4 temp5];'
      write(iunit,*) 'clear temp1 temp2 temp3 temp4 temp5; '

      write(iunit,*) 'temp1=['
      do i=1,nLwrite
      write(iunit,*) (output4(i,j),j=1,5)
      end do
      write(iunit,*) '];'
      write(iunit,*) 'temp2=['
      do i=1,nLwrite
      write(iunit,*) (output4(i,j),j=6,10)
      end do
      write(iunit,*) '];'
      write(iunit,*) 'temp3=['
      do i=1,nLwrite
      write(iunit,*) (output4(i,j),j=11,15)
      end do
      write(iunit,*) '];'
      write(iunit,*) 'temp4=['
      do i=1,nLwrite
      write(iunit,*) (output4(i,j),j=16,20)
      end do
      write(iunit,*) '];'
      write(iunit,*) 'temp5=['
      do i=1,nLwrite
      write(iunit,*) (output4(i,j),j=21,25)
      end do
      write(iunit,*) '];'
      write(iunit,*) 'out4=[temp1 temp2 temp3 temp4 temp5];'

      write(iunit,*) 'clear temp1 temp2 temp3 temp4 temp5'

      close(iunit)

      end



      !-------------------------------------------------------------------
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      subroutine writeXsec(output,filename,nLength,nWidth)
      implicit none

      integer nLength,nWidth,i,j,iunit
      real output(nLength,nWidth)
      character(len=10) filename
      data iunit /11/

      open(unit=iunit,file=filename,status='old',form='FORMATTED')

      do i=1,nLength
      write(iunit,'(f8.4,f8.4,f8.4,f8.4,f8.4,f8.4,f8.4,f8.4)')
     1 (output(i,j),j=1,8)
      end do


      close(iunit)

      end


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      SUBROUTINE getpolicy(nKI,nNIlast,nWBI,nDKI,nZind,nS,nK,nZagg,
     1    Kind,NIlastInd,WBind,DKind,iKind,iNIlast,iWBind,iDKind,iZind,
     1    S,K,iZ,nFirms,Agrid,
     2    Kgrid,Sgrid,Zgrid,KIgrid,NIlastGrid,WBIgrid,DKIgrid,ZIgrid,
     3    Policy,V,DerivsVF,DerivsPD,PriceDebtNRP,DerivsPDNRP,
     3    psiK,RTS,deltaK,INVind,LaborIndMult,
     4    DKindNext,Val,DebtDefault,PriceDebtInd,PriceDebtNRPind,
     5    GDPmult,psiKshock2,ComputePolInd,t)
      implicit none
      integer t,nFirms,i,nK,nZagg,nS,nKI,nWBI,nDKI,nNIlast,nZind,nAgg
      integer iZ,iK,iS,iZind(nFirms),iDKind(nFirms),iState!,iInd0,iState0
      integer jK,jS,jNI,jWBI,jDKI,jKI,iInd,iAgg,ComputePolInd(nFirms)
      integer tempI1,tempI2,tempI3,tempI4
      real tempR1,tempR2,tempR3,tempR4,tempR5,tempR6,tempR7
      real Agrid(nZagg),multDKImax
      real Kind(nFirms),NIlastInd(nFirms),WBind(nFirms),DKind(nFirms)
      real KIgrid(nKI),NIlastGrid(nNIlast),Kgrid(nK),Sgrid(nS)
      real INVind(nFirms),LaborIndMult(nFirms),ZIgrid(nZind)
      real DKindNext(nFirms),DebtDefault(nFirms)
      real MPLtempL,MPLtempH,psiK,RTS,psiKshock2(nZind),WBIgrid(nWBI)
      real DKIgrid(nDKI),PriceDebtInd(nFirms),PriceDebtNRPInd(nFirms)
      real KInext
      real S,K,multK,multS,multKI,multWBI,multNI,multDKI,GDPmult,deltaK
      real P1_6(2,2,2,2,2,2),P2_6(2,2,2,2,2,2),V_6(2,2,2,2,2,2)
      real P1_5(2,2,2,2,2),P2_5(2,2,2,2,2),P1_4(2,2,2,2),P2_4(2,2,2,2)
      real P1_3(2,2,2),P2_3(2,2,2),P1_2(2,2),P2_2(2,2),P1_1(2),P2_1(2)
      real V_5(2,2,2,2,2),V_4(2,2,2,2),V_3(2,2,2),V_2(2,2),V_1(2)
      real P3_6(2,2,2,2,2,2),P3_5(2,2,2,2,2),P3_4(2,2,2,2),P3_3(2,2,2)
      real P4_6(2,2,2,2,2,2),P4_5(2,2,2,2,2),P4_4(2,2,2,2),P4_3(2,2,2)
      real P3_2(2,2),P3_1(2),P4_2(2,2),P4_1(2),PD_2(2,2),PD_1(2)
      real PD_6(2,2,2,2,2,2),PD_5(2,2,2,2,2),PD_4(2,2,2,2),PD_3(2,2,2)
      real dPD_6(2,2,2,2,2,2),dPD_5(2,2,2,2,2)
      real dPDNRP_6(2,2,2,2,2,2),dPDNRP_5(2,2,2,2,2)
      real ChngDbt_6(2,2,2,2,2,2),ChngDbt_5(2,2,2,2,2),ChngDbt_3(2,2,2)
      real ChngDbt_4(2,2,2,2),ChngDbt_2(2,2),ChngDbt_1(2),ChngDbt
      real PDNRP_6(2,2,2,2,2,2),PDNRP_5(2,2,2,2,2),PDNRP_4(2,2,2,2)
      real PDNRP_3(2,2,2),PDNRP_2(2,2),PDNRP_1(2)
      !real PDM_2(2,2),PDM_1(2),PDM_3(2,2,2)
      !real PDM_6(2,2,2,2,2,2),PDM_5(2,2,2,2,2),PDM_4(2,2,2,2)
      real Policy(nK*nS*nZagg*nDKI*nKI*nWBI*nNILast*nZind,5)
      real V(nK*nS*nZagg*nDKI*nKI*nWBI*nNILast*nZind,1),Zgrid(nZagg)
      real PriceDebtNRP(nK*nS*nZagg*nDKI*nKI*nWBI*nNILast*nZind,1)
      real DerivsVF(nK*nS*nZagg*nDKI*nKI*nWBI*nNILast*nZind)
      real DerivsPD(nK*nS*nZagg*nDKI*nKI*nWBI*nNILast*nZind)
      real DerivsPDNRP(nK*nS*nZagg*nDKI*nKI*nWBI*nNILast*nZind)
      double precision Val(nFirms)
      integer iKind(nFirms),iWBind(nFirms),iNIlast(nFirms),extrap(2)
      real DKInext,DKInextWeight,PDI,PDNRPI

      nAgg=nS*nK*nZagg

      multDKImax=(DKIgrid(nDKI)*(Agrid(nZagg)**RTS)-DKIgrid(nDKI-1))/
     1           (DKIgrid(nDKI)-DKIgrid(nDKI-1))

      call findspot(Kgrid,nK,K,nint(.5*real(nK)),iK)
      multK=(K-Kgrid(iK))/(Kgrid(iK+1)-Kgrid(iK))
      call findspot(Sgrid,nS,S,nint(.5*real(nS)),iS)
      multS=(S-Sgrid(iS))/(Sgrid(iS+1)-Sgrid(iS))
      if(multK.gt.1.0) multK=1.0
      if(multK.lt.0.0) multK=0.0
      if(multS.gt.1.0) multS=1.0
      if(multS.lt.0.0) multS=0.0


c$omp parallel
c$omp& default(none)
c$omp& shared(i,nFirms,nAgg,nK,nZagg,nKI,nWBI,nDKI,nNIlast,nZind,
c$omp& KIgrid,DKIgrid,WBIgrid,NILastGrid,Kind,WBind,NIlastInd,Policy,
c$omp& V,DerivsVF,multK,multS,INVind,LaborIndMult,Val,Zgrid,ZIgrid,psiK,
c$omp& RTS,iKind,iWBind,iNIlast,iZ,iZind,iS,iK,t,GDPmult,psiKshock2,
c$omp& DKind,iDKind,DebtDefault,DKindNext,ComputePolInd,PriceDebtInd,
c$omp& deltaK,multDKImax,DerivsPD,DerivsPDNRP,PriceDebtNRP,
c$omp& PriceDebtNRPind)
c$omp& private(multKI,multNI,multWBI,iInd,iAgg,
c$omp& jK,jS,jNI,jDKI,jWBI,jKI,MPLtempL,MPLtempH,P1_6,P1_5,P1_4,P1_3,
c$omp& P1_2,P1_1,P2_6,P2_5,P2_4,P2_3,P2_2,P2_1,V_1,V_2,V_3,V_4,V_5,V_6,
c$omp& P3_6,P3_5,P3_4,P3_3,P3_2,P3_1,P4_6,P4_5,P4_4,P4_3,P4_2,P4_1,
c$omp& PD_6,PD_5,PD_4,PD_3,PD_2,PD_1,multDKI,KInext,!PDM_6,PDM_5,PDM_4,PDM_3,PDM_2,PDM_1,iInd0,iState0,
c$omp& PDNRP_6,PDNRP_5,PDNRP_4,PDNRP_3,PDNRP_2,PDNRP_1,
c$omp& ChngDbt_6,ChngDbt_5,ChngDbt_4,ChngDbt_3,ChngDbt_2,ChngDbt_1,
c$omp& ChngDbt,tempI1,tempI2,tempI3,tempI4,iState,
c$omp& extrap,tempR1,tempR2,tempR3,tempR4,tempR5,tempR6,tempR7,
c$omp& DKInext,DKInextWeight,PDI,dPD_5,dPD_6,dPDNRP_5,dPDNRP_6,PDNRPI)
c$omp do

      do i=1,nFirms
      if(ComputePolInd(i).eq.1) then
!       call findspot(KIgrid,nKi,Kind(i),nint(.5*real(nKi)),iKi)
!       call findspot(WBIgrid,nWBi,WBind(i),nint(.5*real(nWBi)),iWBi)
!       call findspot(NIlastGrid,nNIlast,NIlastInd(i),
!     1      nint(.5*real(nNIlast)),iNIlast)
       multKI=(Kind(i)-KIgrid(iKind(i)))/
     1        (KIgrid(iKind(i)+1)-KIgrid(iKind(i)))
       multWBI=(WBind(i)-WBIgrid(iWBind(i)))/
     1         (WBIgrid(iWBind(i)+1)-WBIgrid(iWBind(i)))
       multNI=(NIlastInd(i)-NIlastGrid(iNIlast(i)))/
     1        (NIlastGrid(iNIlast(i)+1)-NIlastGrid(iNIlast(i)))
       multDKI=(DKind(i)-DKIgrid(iDKind(i)))/
     1         (DKIgrid(iDKind(i)+1)-DKIgrid(iDKind(i)))
       if(multKI.gt.1.0) multKI=1.0
       if(multKI.lt.0.0) multKI=0.0
       if(multWBI.gt.1.0) multWBI=1.0
       if(multWBI.lt.0.0) multWBI=0.0
       if(multNI.gt.1.0) multNI=1.0
       if(multNI.lt.0.0) multNI=0.0
       if(multDKI.gt.multDKImax) multDKI=multDKImax
       if(multDKI.lt.0.0) multDKI=0.0

       tempR1=psiK*psiKshock2(iZind(i))
       MPLtempL=(((1.0-tempR1)*RTS*GDPmult*Zgrid(iZ)*ZIgrid(iZind(i)))**
     1          (1.0/(1.0-(1.0-tempR1)*RTS)))*
     1          (KIgrid(iKind(i))**(tempR1/(1.0-(1.0-tempR1)*RTS)))
       MPLtempH=(((1.0-tempR1)*RTS*GDPmult*Zgrid(iZ)*ZIgrid(iZind(i)))**
     1          (1.0/(1.0-(1.0-tempR1)*RTS)))*
     1          (KIgrid(iKind(i)+1)**(tempR1/(1.0-(1.0-tempR1)*RTS)))

       DKInext=0
       DKInextWeight=0
       PDI=0
       PDNRPI=0
       do jK=1,2
        if(jK.eq.1) then
         tempR6=1.0-multK
        else
         tempR6=multK
        end if

        do jS=1,2
         iAgg=(iS+(jS-1)-1)*nK*nZagg+(iK+(jK-1)-1)*nZagg+iZ
         if(jS.eq.1) then
          tempR5=1.0-multS
         else
          tempR5=multS
         end if

         do jNI=1,2
          if(jNI.eq.1) then
           tempR4=1.0-multNI
          else
           tempR4=multNI
          end if

          do jWBI=1,2
           if(jWBI.eq.1) then
            tempR3=1.0-multWBI
           else
            tempR3=multWBI
           end if

           do jDKI=1,2
            if(jDKI.eq.1) then
             tempR2=1.0-multDKI
            else
             tempR2=multDKI
            end if

            do jKI=1,2
             iInd=(iDKind(i)+(jDKI-1)-1)*nWBI*nNIlast*nKI*nZind+
     1            (iWBind(i)+(jWBI-1)-1)*nNIlast*nKI*nZind+
     1            (iNIlast(i)+(jNI-1)-1)*nKI*nZind+
     2            (iKind(i)+(jKI-1)-1)*nZind+iZind(i)
             iState=(iInd-1)*nAgg+iAgg
!             iInd0=(1+(jDKI-1)-1)*nWBI*nNIlast*nKI*nZind+
!     1            (iWBind(i)+(jWBI-1)-1)*nNIlast*nKI*nZind+
!     1            (iNIlast(i)+(jNI-1)-1)*nKI*nZind+
!     2            (iKind(i)+(jKI-1)-1)*nZind+iZind(i)
!             iState0=(iInd0-1)*nAgg+iAgg
             if(jKI.eq.1) then
              tempR1=1.0-multKI
             else
              tempR1=multKI
             end if
             KInext=KIgrid(iKind(i)+jKI-1)*(1.0-deltaK)+policy(iState,1)
             P1_6(jK,jS,jNI,jWBI,jDKI,jKI)=policy(iState,1)
             if(jKI.eq.1) then
              P2_6(jK,jS,jNI,jWBI,jDKI,jKI)=policy(iState,2)*MPLtempL
             else
              P2_6(jK,jS,jNI,jWBI,jDKI,jKI)=policy(iState,2)*MPLtempH
             end if


             P3_6(jK,jS,jNI,jWBI,jDKI,jKI)=policy(iState,3)  !debt
             P4_6(jK,jS,jNI,jWBI,jDKI,jKI)=policy(iState,4)  !default (0 or 1)
             PD_6(jK,jS,jNI,jWBI,jDKI,jKI)=Policy(iState,5)  !price of debt for issuing firm; if firm is not issuing (that is if DKI>0) multiply this by (1-ProbExp) to get actual price of debt
             if(DKind(i).gt.0.001.and.
     1          iDKind(i)+jDKI-1.eq.1) then
              PD_6(jK,jS,jNI,jWBI,jDKI,jKI)=0
             end if

             dPD_6(jK,jS,jNI,jWBI,jDKI,jKI)=DerivsPD(iState)
             
             PDNRP_6(jK,jS,jNI,jWBI,jDKI,jKI)=PriceDebtNRP(iState,1)
             if(DKind(i).gt.0.001.and.
     1          iDKind(i)+jDKI-1.eq.1) then
              PDNRP_6(jK,jS,jNI,jWBI,jDKI,jKI)=0
             end if
             dPDNRP_6(jK,jS,jNI,jWBI,jDKI,jKI)=DerivsPDNRP(iState)
             if(policy(iState,3).lt..0001.or.DKind(i).gt.0.0001) then
              ChngDbt_6(jK,jS,jNI,jWBI,jDKI,jKI)=0.0
              tempR7=0.0
             else
              ChngDbt_6(jK,jS,jNI,jWBI,jDKI,jKI)=1.0
              tempR7=tempR1*tempR2*tempR3*tempR4*tempR5*tempR6 
             end if
             DKInext=DKInext+policy(iState,3)*tempR7
             PDI=PDI+Policy(iState,5)*tempR7
             DKInextWeight=DKInextWeight+tempR7
             PDNRPI=PDNRPI+PriceDebtNRP(iState,1)*tempR7
            end do  !jKI

            P1_5(jK,jS,jNI,jWBI,jDKI)=
     1        P1_6(jK,jS,jNI,jWBI,jDKI,1)+multKI*
     1       (P1_6(jK,jS,jNI,jWBI,jDKI,2)-P1_6(jK,jS,jNI,jWBI,jDKI,1))
            P2_5(jK,jS,jNI,jWBI,jDKI)=
     1        P2_6(jK,jS,jNI,jWBI,jDKI,1)+multKI*
     1       (P2_6(jK,jS,jNI,jWBI,jDKI,2)-P2_6(jK,jS,jNI,jWBI,jDKI,1))
            P3_5(jK,jS,jNI,jWBI,jDKI)=
     1        P3_6(jK,jS,jNI,jWBI,jDKI,1)+multKI*
     1       (P3_6(jK,jS,jNI,jWBI,jDKI,2)-P3_6(jK,jS,jNI,jWBI,jDKI,1))
            P4_5(jK,jS,jNI,jWBI,jDKI)=
     1        P4_6(jK,jS,jNI,jWBI,jDKI,1)+multKI*
     1       (P4_6(jK,jS,jNI,jWBI,jDKI,2)-P4_6(jK,jS,jNI,jWBI,jDKI,1))
            PD_5(jK,jS,jNI,jWBI,jDKI)=
     1        PD_6(jK,jS,jNI,jWBI,jDKI,1)+multKI*
     1       (PD_6(jK,jS,jNI,jWBI,jDKI,2)-PD_6(jK,jS,jNI,jWBI,jDKI,1))
            dPD_5(jK,jS,jNI,jWBI,jDKI)=
     1        dPD_6(jK,jS,jNI,jWBI,jDKI,1)+multKI*
     1       (dPD_6(jK,jS,jNI,jWBI,jDKI,2)-dPD_6(jK,jS,jNI,jWBI,jDKI,1))
            ChngDbt_5(jK,jS,jNI,jWBI,jDKI)=
     1        ChngDbt_6(jK,jS,jNI,jWBI,jDKI,1)+multKI*
     1       (ChngDbt_6(jK,jS,jNI,jWBI,jDKI,2)-
     1        ChngDbt_6(jK,jS,jNI,jWBI,jDKI,1))
            PDNRP_5(jK,jS,jNI,jWBI,jDKI)=
     1        PDNRP_6(jK,jS,jNI,jWBI,jDKI,1)+multKI*
     1       (PDNRP_6(jK,jS,jNI,jWBI,jDKI,2)-
     1        PDNRP_6(jK,jS,jNI,jWBI,jDKI,1))
            dPDNRP_5(jK,jS,jNI,jWBI,jDKI)=
     1        dPDNRP_6(jK,jS,jNI,jWBI,jDKI,1)+multKI*
     1       (dPDNRP_6(jK,jS,jNI,jWBI,jDKI,2)-
     1        dPDNRP_6(jK,jS,jNI,jWBI,jDKI,1))

            iInd=(iDKind(i)+(jDKI-1)-1)*nWBI*nNIlast*nKI*nZind+
     1           (iWBind(i)+(jWBI-1)-1)*nNIlast*nKI*nZind+
     1           (iNIlast(i)+(jNI-1)-1)*nKI*nZind+
     2           (iKind(i)+(1-1)-1)*nZind+iZind(i)
            iState=(iInd-1)*nAgg+iAgg
            call CHFEV(KIgrid(iKind(i)),KIgrid(iKind(i)+1),
     1                 V(iState,1),V(iState+nAgg*nZind,1),
     2                 DerivsVF(iState),DerivsVF(iState+nAgg*nZind),
     3                 1,Kind(i),tempR1,extrap,tempI4)
            V_5(jK,jS,jNI,jWBI,jDKI)=tempR1
           end do !jDKI

           P1_4(jK,jS,jNI,jWBI)=P1_5(jK,jS,jNI,jWBI,1)+multDKI*
     1              (P1_5(jK,jS,jNI,jWBI,2)-P1_5(jK,jS,jNI,jWBI,1))
           P2_4(jK,jS,jNI,jWBI)=P2_5(jK,jS,jNI,jWBI,1)+multDKI*
     1              (P2_5(jK,jS,jNI,jWBI,2)-P2_5(jK,jS,jNI,jWBI,1))
           P3_4(jK,jS,jNI,jWBI)=P3_5(jK,jS,jNI,jWBI,1)+multDKI*
     1              (P3_5(jK,jS,jNI,jWBI,2)-P3_5(jK,jS,jNI,jWBI,1))
           P4_4(jK,jS,jNI,jWBI)=P4_5(jK,jS,jNI,jWBI,1)+multDKI*
     1              (P4_5(jK,jS,jNI,jWBI,2)-P4_5(jK,jS,jNI,jWBI,1))
           PD_4(jK,jS,jNI,jWBI)=PD_5(jK,jS,jNI,jWBI,1)+multDKI*
     1              (PD_5(jK,jS,jNI,jWBI,2)-PD_5(jK,jS,jNI,jWBI,1))
           PDNRP_4(jK,jS,jNI,jWBI)=PDNRP_5(jK,jS,jNI,jWBI,1)+multDKI*
     1              (PDNRP_5(jK,jS,jNI,jWBI,2)-
     1               PDNRP_5(jK,jS,jNI,jWBI,1))

           call CHFEV(DKIgrid(iDKind(i)),DKIgrid(iDKind(i)+1),
     1                 PD_5(jK,jS,jNI,jWBI,1),PD_5(jK,jS,jNI,jWBI,2),
     2                 dPD_5(jK,jS,jNI,jWBI,1),dPD_5(jK,jS,jNI,jWBI,2),
     3                 1,DKind(i),tempR1,extrap,tempI4)
           if(tempR1.lt.0.0) tempR1=0.0
           PD_4(jK,jS,jNI,jWBI)=tempR1
           
           call CHFEV(DKIgrid(iDKind(i)),DKIgrid(iDKind(i)+1),
     1            PDNRP_5(jK,jS,jNI,jWBI,1),PDNRP_5(jK,jS,jNI,jWBI,2),
     2            dPDNRP_5(jK,jS,jNI,jWBI,1),dPDNRP_5(jK,jS,jNI,jWBI,2),
     3            1,DKind(i),tempR1,extrap,tempI4)
           if(tempR1.lt.0.0) tempR1=0.0
           PDNRP_4(jK,jS,jNI,jWBI)=tempR1

           ChngDbt_4(jK,jS,jNI,jWBI)=
     1         ChngDbt_5(jK,jS,jNI,jWBI,1)+multDKI*
     1        (ChngDbt_5(jK,jS,jNI,jWBI,2)-ChngDbt_5(jK,jS,jNI,jWBI,1))
           V_4(jK,jS,jNI,jWBI)=V_5(jK,jS,jNI,jWBI,1)+multDKI*
     1               (V_5(jK,jS,jNI,jWBI,2)-V_5(jK,jS,jNI,jWBI,1))

          end do !jWBI
          P1_3(jK,jS,jNI)=P1_4(jK,jS,jNI,1)+multWBI*
     1                   (P1_4(jK,jS,jNI,2)-P1_4(jK,jS,jNI,1))
          P2_3(jK,jS,jNI)=P2_4(jK,jS,jNI,1)+multWBI*
     1                   (P2_4(jK,jS,jNI,2)-P2_4(jK,jS,jNI,1))
          P3_3(jK,jS,jNI)=P3_4(jK,jS,jNI,1)+multWBI*
     1                   (P3_4(jK,jS,jNI,2)-P3_4(jK,jS,jNI,1))
          P4_3(jK,jS,jNI)=P4_4(jK,jS,jNI,1)+multWBI*
     1                   (P4_4(jK,jS,jNI,2)-P4_4(jK,jS,jNI,1))
          PD_3(jK,jS,jNI)=PD_4(jK,jS,jNI,1)+multWBI*
     1                   (PD_4(jK,jS,jNI,2)-PD_4(jK,jS,jNI,1))
          ChngDbt_3(jK,jS,jNI)=ChngDbt_4(jK,jS,jNI,1)+multWBI*
     1                 (ChngDbt_4(jK,jS,jNI,2)-ChngDbt_4(jK,jS,jNI,1))
          V_3(jK,jS,jNI)=V_4(jK,jS,jNI,1)+multWBI*
     1                   (V_4(jK,jS,jNI,2)-V_4(jK,jS,jNI,1))
          PDNRP_3(jK,jS,jNI)=PDNRP_4(jK,jS,jNI,1)+multWBI*
     1                   (PDNRP_4(jK,jS,jNI,2)-PDNRP_4(jK,jS,jNI,1))
         end do
         P1_2(jK,jS)=P1_3(jK,jS,1)+multNI*(P1_3(jK,jS,2)-P1_3(jK,jS,1))
         P2_2(jK,jS)=P2_3(jK,jS,1)+multNI*(P2_3(jK,jS,2)-P2_3(jK,jS,1))
         P3_2(jK,jS)=P3_3(jK,jS,1)+multNI*(P3_3(jK,jS,2)-P3_3(jK,jS,1))
         P4_2(jK,jS)=P4_3(jK,jS,1)+multNI*(P4_3(jK,jS,2)-P4_3(jK,jS,1))
         PD_2(jK,jS)=PD_3(jK,jS,1)+multNI*(PD_3(jK,jS,2)-PD_3(jK,jS,1))
         ChngDbt_2(jK,jS)=ChngDbt_3(jK,jS,1)+multNI*
     1                   (ChngDbt_3(jK,jS,2)-ChngDbt_3(jK,jS,1))
         V_2(jK,jS)=V_3(jK,jS,1)+multNI*(V_3(jK,jS,2)-V_3(jK,jS,1))
         PDNRP_2(jK,jS)=PDNRP_3(jK,jS,1)+
     1          multNI*(PDNRP_3(jK,jS,2)-PDNRP_3(jK,jS,1))
        end do
        P1_1(jK)=P1_2(jK,1)+multS*(P1_2(jK,2)-P1_2(jK,1))
        P2_1(jK)=P2_2(jK,1)+multS*(P2_2(jK,2)-P2_2(jK,1))
        P3_1(jK)=P3_2(jK,1)+multS*(P3_2(jK,2)-P3_2(jK,1))
        P4_1(jK)=P4_2(jK,1)+multS*(P4_2(jK,2)-P4_2(jK,1))
        PD_1(jK)=PD_2(jK,1)+multS*(PD_2(jK,2)-PD_2(jK,1))
        ChngDbt_1(jK)=ChngDbt_2(jK,1)+multS*
     1               (ChngDbt_2(jK,2)-ChngDbt_2(jK,1))
        V_1(jK)=V_2(jK,1)+multS*(V_2(jK,2)-V_2(jK,1))
        PDNRP_1(jK)=PDNRP_2(jK,1)+multS*(PDNRP_2(jK,2)-PDNRP_2(jK,1))
       end do

      Val(i)=V_1(1)+multK*(V_1(2)-V_1(1))
      INVind(i)=P1_1(1)+multK*(P1_1(2)-P1_1(1))
      LaborIndMult(i)=P2_1(1)+multK*(P2_1(2)-P2_1(1))
      PriceDebtInd(i)=PD_1(1)+multK*(PD_1(2)-PD_1(1))
      PriceDebtNRPInd(i)=PDNRP_1(1)+multK*(PDNRP_1(2)-PDNRP_1(1))
      if(DKind(i).gt.0.001) then
       DKindNext(i)=DKind(i)
      else
       DKindNext(i)=P3_1(1)+multK*(P3_1(2)-P3_1(1))
      end if
      ChngDbt=ChngDbt_1(1)+multK*(ChngDbt_1(2)-ChngDbt_1(1))
      if(ChngDbt.gt.0.5) then
       if(DKInextWeight.lt.0.0001) then
        DKindNext(i)=P3_1(1)+multK*(P3_1(2)-P3_1(1))
        PriceDebtInd(i)=PD_1(1)+multK*(PD_1(2)-PD_1(1))
        PriceDebtNRPind(i)=PDNRP_1(1)+multK*(PDNRP_1(2)-PDNRP_1(1))
       else
        DKindNext(i)=DKInext/DKInextWeight
        PriceDebtInd(i)=PDI/DKInextWeight
        PriceDebtNRPind(i)=PDNRPI/DKInextWeight
       end if
      else
       DKindNext(i)=DKind(i)
       if(DKind(i).lt.0.0001) then
        PriceDebtInd(i)=0
        PriceDebtNRPInd(i)=0
       end if
      end if
      DebtDefault(i)=P4_1(1)+multK*(P4_1(2)-P4_1(1))
      if(Val(i).lt.0.001) DebtDefault(i)=1.0
      if(PriceDebtInd(i).lt.0.001.and.DKind(i).gt.0.001)
     1 DebtDefault(i)=1.0

      end if !ComputePolInd
      end do

c$omp end do
c$omp end parallel


      end

!-------------------------------------------------------------------
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      subroutine writeoutputInd(outputLaborInd,outputWageInd,
     1 outputSalesInd,outputIntInd,outputPDind,outputPDRFind,
     1 outputDefInd,outputRDind,outputREind,
     1 outputKind,outputVind,outputExpInd,
     1 outputPDNRPind,filename,nLength,nWidth,nLwrite,nWwrite)
      implicit none
      integer nLength,nWidth,i,j,iunit,nLwrite,nWwrite
      integer n,t,iFile,iIter
      real outputLaborInd(nLength,nWidth),outputWageInd(nLength,nWidth)
      real outputSalesInd(nLength,nWidth),outputIntInd(nLength,nWidth)
      real outputPDInd(nLength,nWidth),outputPDRFInd(nLength,nWidth)
      real outputDefInd(nLength,nWidth),outputRDInd(nLength,nWidth)
      real outputREInd(nLength,nWidth)
      real output(nLwrite,nWwrite),outputKind(nLength,nWidth)
      real outputVind(nLength,nWidth),outputExpInd(nLength,nWidth)
      real outputPDNRPind(nLength,nWidth)
      character(len=10) filename
      character(len=8) tempchar
      data iunit /11/

      open(unit=iunit,file=filename,status='old',form='FORMATTED')

      do iFile=1,13

       if(iFile.eq.1) then
        do t=1,nLwrite
        do i=1,nWwrite
         output(t,i)=outputLaborInd(t,i)
        end do
        end do
       end if
       if(iFile.eq.2) then
        do t=1,nLwrite
        do i=1,nWwrite
         output(t,i)=outputWageInd(t,i)
        end do
        end do
       end if
       if(iFile.eq.3) then
        do t=1,nLwrite
        do i=1,nWwrite
         output(t,i)=outputSalesInd(t,i)
        end do
        end do
       end if
       if(iFile.eq.4) then
        do t=1,nLwrite
        do i=1,nWwrite
         output(t,i)=outputIntInd(t,i)
        end do
        end do
       end if
       if(iFile.eq.5) then
        do t=1,nLwrite
        do i=1,nWwrite
         output(t,i)=outputPDInd(t,i)
        end do
        end do
       end if
       if(iFile.eq.6) then
        do t=1,nLwrite
        do i=1,nWwrite
         output(t,i)=outputPDRFInd(t,i)
        end do
        end do
       end if
       if(iFile.eq.7) then
        do t=1,nLwrite
        do i=1,nWwrite
         output(t,i)=outputDefInd(t,i)
        end do
        end do
       end if
       if(iFile.eq.8) then
        do t=1,nLwrite
        do i=1,nWwrite
         output(t,i)=outputRDInd(t,i)
        end do
        end do
       end if
       if(iFile.eq.9) then
        do t=1,nLwrite
        do i=1,nWwrite
         output(t,i)=outputKind(t,i)
        end do
        end do
       end if
       if(iFile.eq.10) then
        do t=1,nLwrite
        do i=1,nWwrite
         output(t,i)=outputVind(t,i)
        end do
        end do
       end if
       if(iFile.eq.11) then
        do t=1,nLwrite
        do i=1,nWwrite
         output(t,i)=outputExpInd(t,i)
        end do
        end do
       end if
       if(iFile.eq.12) then
        do t=1,nLwrite
        do i=1,nWwrite
         output(t,i)=outputPDNRPind(t,i)
        end do
        end do
       end if
       if(iFile.eq.13) then
        do t=1,nLwrite
        do i=1,nWwrite
         output(t,i)=outputREind(t,i)
        end do
        end do
       end if

       do iIter=1,10

        if(iIter.eq.1) tempchar='temp01=['
        if(iIter.eq.2) tempchar='temp02=['
        if(iIter.eq.3) tempchar='temp03=['
        if(iIter.eq.4) tempchar='temp04=['
        if(iIter.eq.5) tempchar='temp05=['
        if(iIter.eq.6) tempchar='temp06=['
        if(iIter.eq.7) tempchar='temp07=['
        if(iIter.eq.8) tempchar='temp08=['
        if(iIter.eq.9) tempchar='temp09=['
        if(iIter.eq.10) tempchar='temp10=['

        write(iunit,*) tempchar
        do i=1,nLwrite
         write(iunit,'(f10.5,f10.5,f10.5,f10.5,f10.5,f10.5,
     1                 f10.5,f10.5,f10.5,f10.5)')
     1        (output(i,j),j=(iIter-1)*10+1,(iIter-1)*10+10)
        end do
        write(iunit,*) '];'

       end do

       if(iFile.eq.1) then
        write(iunit,*)
     1 'outLaborInd=[temp01 temp02 temp03 temp04 temp05 ...'
        write(iunit,*) 'temp06 temp07 temp08 temp09 temp10];'
        write(iunit,*) 'clear temp01 temp02 temp03 temp04 temp05; '
        write(iunit,*) 'clear temp06 temp07 temp08 temp09 temp10; '
       end if
       if(iFile.eq.2) then
        write(iunit,*)
     1   'outWageInd=[temp01 temp02 temp03 temp04 temp05 ...'
        write(iunit,*) 'temp06 temp07 temp08 temp09 temp10];'
        write(iunit,*) 'clear temp01 temp02 temp03 temp04 temp05; '
        write(iunit,*) 'clear temp06 temp07 temp08 temp09 temp10; '
       end if
       if(iFile.eq.3) then
        write(iunit,*)
     1   'outSalesInd=[temp01 temp02 temp03 temp04 temp05 ...'
        write(iunit,*) 'temp06 temp07 temp08 temp09 temp10];'
        write(iunit,*) 'clear temp01 temp02 temp03 temp04 temp05; '
        write(iunit,*) 'clear temp06 temp07 temp08 temp09 temp10; '
       end if
       if(iFile.eq.4) then
        write(iunit,*)
     1   'outIntInd=[temp01 temp02 temp03 temp04 temp05 ...'
        write(iunit,*) 'temp06 temp07 temp08 temp09 temp10];'
        write(iunit,*) 'clear temp01 temp02 temp03 temp04 temp05; '
        write(iunit,*) 'clear temp06 temp07 temp08 temp09 temp10; '
       end if
       if(iFile.eq.5) then
        write(iunit,*)
     1   'outPDInd=[temp01 temp02 temp03 temp04 temp05 ...'
        write(iunit,*) 'temp06 temp07 temp08 temp09 temp10];'
        write(iunit,*) 'clear temp01 temp02 temp03 temp04 temp05; '
        write(iunit,*) 'clear temp06 temp07 temp08 temp09 temp10; '
       end if
       if(iFile.eq.6) then
        write(iunit,*)
     1   'outPDRFInd=[temp01 temp02 temp03 temp04 temp05 ...'
        write(iunit,*) 'temp06 temp07 temp08 temp09 temp10];'
        write(iunit,*) 'clear temp01 temp02 temp03 temp04 temp05; '
        write(iunit,*) 'clear temp06 temp07 temp08 temp09 temp10; '
       end if
       if(iFile.eq.7) then
        write(iunit,*)
     1   'outDefInd=[temp01 temp02 temp03 temp04 temp05 ...'
        write(iunit,*) 'temp06 temp07 temp08 temp09 temp10];'
        write(iunit,*) 'clear temp01 temp02 temp03 temp04 temp05; '
        write(iunit,*) 'clear temp06 temp07 temp08 temp09 temp10; '
       end if
       if(iFile.eq.8) then
        write(iunit,*)
     1   'outRDInd=[temp01 temp02 temp03 temp04 temp05 ...'
        write(iunit,*) 'temp06 temp07 temp08 temp09 temp10];'
        write(iunit,*) 'clear temp01 temp02 temp03 temp04 temp05; '
        write(iunit,*) 'clear temp06 temp07 temp08 temp09 temp10; '
       end if
       if(iFile.eq.9) then
        write(iunit,*)
     1   'outKInd=[temp01 temp02 temp03 temp04 temp05 ...'
        write(iunit,*) 'temp06 temp07 temp08 temp09 temp10];'
        write(iunit,*) 'clear temp01 temp02 temp03 temp04 temp05; '
        write(iunit,*) 'clear temp06 temp07 temp08 temp09 temp10; '
       end if
       if(iFile.eq.10) then
        write(iunit,*)
     1   'outVInd=[temp01 temp02 temp03 temp04 temp05 ...'
        write(iunit,*) 'temp06 temp07 temp08 temp09 temp10];'
        write(iunit,*) 'clear temp01 temp02 temp03 temp04 temp05; '
        write(iunit,*) 'clear temp06 temp07 temp08 temp09 temp10; '
       end if
       if(iFile.eq.11) then
        write(iunit,*)
     1   'outExpInd=[temp01 temp02 temp03 temp04 temp05 ...'
        write(iunit,*) 'temp06 temp07 temp08 temp09 temp10];'
        write(iunit,*) 'clear temp01 temp02 temp03 temp04 temp05; '
        write(iunit,*) 'clear temp06 temp07 temp08 temp09 temp10; '
       end if
       if(iFile.eq.12) then
        write(iunit,*)
     1   'outPDNRPInd=[temp01 temp02 temp03 temp04 temp05 ...'
        write(iunit,*) 'temp06 temp07 temp08 temp09 temp10];'
        write(iunit,*) 'clear temp01 temp02 temp03 temp04 temp05; '
        write(iunit,*) 'clear temp06 temp07 temp08 temp09 temp10; '
       end if
       if(iFile.eq.13) then
        write(iunit,*)
     1   'outREInd=[temp01 temp02 temp03 temp04 temp05 ...'
        write(iunit,*) 'temp06 temp07 temp08 temp09 temp10];'
        write(iunit,*) 'clear temp01 temp02 temp03 temp04 temp05; '
        write(iunit,*) 'clear temp06 temp07 temp08 temp09 temp10; '
       end if

      end do

      close(iunit)

      end

